#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <richedit.h>
#include <shellapi.h>
#include <objbase.h>
#include <shlobj.h>
#include "AkelEdit.h"
#include "AkelDLL.h"
#include "ConvFunc.h"
#include "StackFunc.h"
#include "Resources\Resource.h"


//Include conversion functions
#define xatoiA
#define xatoiW
#include "ConvFunc.h"

//Include stack functions
#define StackGetElement
#define StackInsertAfter
#define StackInsertBefore
#define StackInsertIndex
#define StackDelete
#define StackClear
#define StackSize
#include "StackFunc.h"

//Defines
#define DLLA_CONTEXTMENU_INDEX  1

#define STRID_MANUAL           1
#define STRID_MENUMAIN         2
#define STRID_MENUEDIT         3
#define STRID_MENUTAB          4
#define STRID_MENUURL          5
#define STRID_MENURECENTFILES  6
#define STRID_ENABLE           7
#define STRID_SHOW             8
#define STRID_AUTOLOAD         9
#define STRID_OK               10
#define STRID_CANCEL           11

#define OF_MENUTEXT       0x1
#define OF_WINDOWRECT     0x2

#define ACT_COMMAND       1
#define ACT_CALL          2
#define ACT_EXEC          3
#define ACT_FONT          4
#define ACT_RECODE        5
#define ACT_INSERT        6
#define ACT_LINK          7

#define URL_OPEN          1
#define URL_COPY          2
#define URL_SELECT        3

#define TYPE_MAIN         1
#define TYPE_EDIT         2
#define TYPE_TAB          3
#define TYPE_URL          4
#define TYPE_RECENTFILES  5

#define PARAM_CHAR        1
#define PARAM_INT         2

#define MAX_MENUTEXT_SIZE  64000

#define IDM_MIN_EXPLORER   20001
#define IDM_MAX_EXPLORER   21000
#define IDM_MIN_MENU       21001
#define IDM_MAX_MENU       22000

#define FS_NONE            0
#define FS_FONTNORMAL      1
#define FS_FONTITALIC      2
#define FS_FONTBOLD        3
#define FS_FONTBOLDITALIC  4

#define INIT_EXPLORER    1
#define INIT_RECENTFILES 2
#define INIT_LANGUAGES   3

//DIALOGRESIZE
#define DRS_SIZE  0x1 //Resize control
#define DRS_MOVE  0x2 //Move control
#define DRS_X     0x4 //X value
#define DRS_Y     0x8 //Y value

#ifndef WM_MENURBUTTONUP
  #define WM_MENURBUTTONUP 0x0122
#endif
#ifndef TPM_RECURSE
  #define TPM_RECURSE 0x0001L
#endif

#define IMENU_EDIT     0x00000001
#define IMENU_CHECKS   0x00000004

#define TXT_MANUALW \
L"# %f file, %d file directory, %a akelpad directory, %% symbol %\r\
\r\
\"Open in notepad\" Exec(`notepad.exe \"%f\"`)\r\
# Syntax: Exec(\"command line\", [\"working directory\"])\r\
\r\
-\"Script call\" Call(\"Scripts::Main\", 1, \"InsertDate.js\", \"\")\r\
# Parameters: 1 -execute, \"InsertDate.js\" -script name, \"\" -argumets\r\
\r\
-\"Macro call\" Call(\"Macros::Main\", 1, \"123\", 1)\r\
# Parameters: 1 -execute, \"123\" -macro name, 1 -repeat count\r\
\r\
SEPARATOR\r\
\r\
-\"Edit...\" Call(\"ContextMenu::Main\", 1, 0)\r\
# Parameters: 1 -execute, 0 -menu index\r"

#define TXT_MAINW \
L"\"F&avourites\" Index(3)\r\
{\r\
  \"AkelPad-Eng.htm\" Exec(`\"%a\\AkelPad.exe\" \"%a\\AkelFiles\\AkelPad-Eng.htm\"`)\r\
  \"AkelPad-Rus.htm\"\" Exec(`\"%a\\AkelPad.exe\" \"%a\\AkelFiles\\AkelPad-Rus.htm\"`)\r\
  SEPARATOR\r\
  -\"Edit...\" Call(\"ContextMenu::Main\", 1, 1)\r\
}\r\
\"&Plugins\" Index(-2)\r\
{\r\
  \"ToolBar\" +Call(\"ToolBar::Main\")\r\
  \"LineBoard\" +Call(\"LineBoard::Main\")\r\
  \"SpecialChar\" +Call(\"SpecialChar::Main\")\r\
  SEPARATOR\r\
  \"SaveAllAs\" Call(\"SaveAllAs::Main\")\r\
  \"PasteSerial\" Call(\"PasteSerial::Main\")\r\
  \"MinimizeToTray\" Call(\"MinimizeToTray::Now\")\r\
  SEPARATOR\r\
  \"Lines\"\r\
  {\r\
    \"SortStrAsc\" Call(\"Lines::SortStrAsc\")\r\
    \"SortStrDesc\" Call(\"Lines::SortStrDesc\")\r\
    \"SortIntAsc\" Call(\"Lines::SortIntAsc\")\r\
    \"SortIntDesc\" Call(\"Lines::SortIntDesc\")\r\
    SEPARATOR\r\
    \"FixWrap\" Call(\"Lines::FixWrap\")\r\
    \"Reverse\" Call(\"Lines::Reverse\")\r\
    \"GetDuplicates\" Call(\"Lines::GetDuplicates\")\r\
    \"RemoveDuplicates\" Call(\"Lines::RemoveDuplicates\")\r\
  }\r\
  SEPARATOR\r\
  -\"Edit...\" Call(\"ContextMenu::Main\", 1, 1)\r\
}\r"

#define TXT_EDITW \
L"\"\" Command(4151)\r\
\"\" Command(4152)\r\
SEPARATOR\r\
\"\" Command(4153)\r\
\"\" Command(4154)\r\
\"\" Command(4155)\r\
\"\" Command(4156)\r\
SEPARATOR\r\
\"\" Command(4157)\r\
SEPARATOR\r\
\"Lines\"\r\
{\r\
  \"SortStrAsc\" Call(\"Lines::SortStrAsc\")\r\
  \"SortStrDesc\" Call(\"Lines::SortStrDesc\")\r\
  \"SortIntAsc\" Call(\"Lines::SortIntAsc\")\r\
  \"SortIntDesc\" Call(\"Lines::SortIntDesc\")\r\
  SEPARATOR\r\
  \"FixWrap\" Call(\"Lines::FixWrap\")\r\
  \"Reverse\" Call(\"Lines::Reverse\")\r\
  \"GetDuplicates\" Call(\"Lines::GetDuplicates\")\r\
  \"RemoveDuplicates\" Call(\"Lines::RemoveDuplicates\")\r\
}\r"

#define TXT_TABW \
L"\"Window &list\" Command(10019)\r\
SEPARATOR\r\
\"&Close\" Command(4406)\r\
\"Close &all\" Command(4111)\r\
\"Close all, &but active\" Command(4112)\r\
SEPARATOR\r\
\"Explorer\"\r\
{\r\
  EXPLORER\r\
}\r"

#define TXT_URLW \
L"\"Ope&n\" Link(1)\r\
\"Cop&y\" Link(2)\r\
\"&Select\" Link(3)\r\
SEPARATOR\r\
\"\" Command(4151)\r\
\"\" Command(4152)\r\
SEPARATOR\r\
\"\" Command(4153)\r\
\"\" Command(4154)\r\
\"\" Command(4155)\r\
\"\" Command(4156)\r\
SEPARATOR\r\
\"\" Command(4157)\r"

#define TXT_RECENTFILESW \
L"EXPLORER\r"

typedef struct _SUBMENUS {
  struct _SUBMENUS *next;
  struct _SUBMENUS *prev;
  HMENU hSubMenu;
  int nSubMenuIndex;
} SUBMENUS;

typedef struct _INDEXES {
  struct _INDEXES *next;
  struct _INDEXES *prev;
  int nMainMenuIndex;
  HMENU hSubMenu;
} INDEXES;

typedef struct _POPUPMENUA {
  HMENU hPopupMenu;
  HSTACK hActionStack;
  HSTACK hMainMenuIndexStack;
  HMENU hMainMenu;
  BOOL bClearMainMenu;
  HMENU hExplorerSubMenu;
  int nExplorerFirstIndex;
  int nExplorerLastIndex;
  HMENU hRecentFilesSubMenu;
  int nRecentFilesFirstIndex;
  int nRecentFilesLastIndex;
  HMENU hLanguagesSubMenu;
  int nLanguagesFirstIndex;
  int nLanguagesLastIndex;
  HMENU hMdiDocumentsSubMenu;
  LPCONTEXTMENU pExplorerMenu;
  LPCONTEXTMENU2 pExplorerSubMenu2;
  LPCONTEXTMENU3 pExplorerSubMenu3;
  char szExplorerFile[MAX_PATH];
} POPUPMENUA;

typedef struct _POPUPMENUW {
  HMENU hPopupMenu;
  HSTACK hActionStack;
  HSTACK hMainMenuIndexStack;
  HMENU hMainMenu;
  BOOL bClearMainMenu;
  HMENU hExplorerSubMenu;
  int nExplorerFirstIndex;
  int nExplorerLastIndex;
  HMENU hRecentFilesSubMenu;
  int nRecentFilesFirstIndex;
  int nRecentFilesLastIndex;
  HMENU hLanguagesSubMenu;
  int nLanguagesFirstIndex;
  int nLanguagesLastIndex;
  HMENU hMdiDocumentsSubMenu;
  LPCONTEXTMENU pExplorerMenu;
  LPCONTEXTMENU2 pExplorerSubMenu2;
  LPCONTEXTMENU3 pExplorerSubMenu3;
  wchar_t wszExplorerFile[MAX_PATH];
} POPUPMENUW;

typedef struct _MENUITEM {
  struct _MENUITEM *next;
  struct _MENUITEM *prev;
  int nItem;
  BOOL bUpdateItem;
  BOOL bSetOnStart;
  DWORD dwAction;
  HSTACK hParamStack;
} MENUITEM;

typedef struct _PARAMETER {
  struct _PARAMETER *next;
  struct _PARAMETER *prev;
  DWORD dwType;
  LPARAM lParam;
  unsigned char *pExpanded;
} PARAMETER;

typedef struct _PLUGINCALL {
  unsigned char *lpStruct;
  BOOL bOnStart;
  BOOL bSetOnStart;
} PLUGINCALL;

typedef struct {
  HWND *lpWnd;   //Control window
  DWORD dwType;  //See DRS_* defines
} DIALOGRESIZE;

//Functions prototypes
DWORD WINAPI ThreadProcA(LPVOID lpParameter);
DWORD WINAPI ThreadProcW(LPVOID lpParameter);
LRESULT CALLBACK NewMainProcA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK NewMainProcW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK NewFrameProcA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK NewFrameProcW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK EditParentMessagesA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK EditParentMessagesW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK MainDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK MainDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK NewEditDlgProcA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK NewEditDlgProcW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void CreateContextMenuA(POPUPMENUA *hMenuStackA, char *pText);
void CreateContextMenuW(POPUPMENUW *hMenuStackW, wchar_t *wpText);
void UpdateContextMenuA(POPUPMENUA *hMenuStackA, int nType);
void UpdateContextMenuW(POPUPMENUW *hMenuStackW, int nType);
int ShowContextMenuA(POPUPMENUA *hMenuStackA, HWND hWnd, int nType, int x, int y);
int ShowContextMenuW(POPUPMENUW *hMenuStackW, HWND hWnd, int nType, int x, int y);
void InitMenuPopupA(POPUPMENUA *hMenuStackA, int nMenuType);
void InitMenuPopupW(POPUPMENUW *hMenuStackW, int nMenuType);
void InsertMainMenuA(POPUPMENUA *hMenuStackA);
void InsertMainMenuW(POPUPMENUW *hMenuStackW);
void DeleteMainMenuA(POPUPMENUA *hMenuStackA);
void DeleteMainMenuW(POPUPMENUW *hMenuStackW);
MENUITEM* GetContextMenuItemA(POPUPMENUA *hMenuStackA, int nItem);
MENUITEM* GetContextMenuItemW(POPUPMENUW *hMenuStackW, int nItem);
MENUITEM* GetCommandItemA(POPUPMENUA *hMenuStackA, int nCommand);
MENUITEM* GetCommandItemW(POPUPMENUW *hMenuStackW, int nCommand);
void CallContextMenuA(POPUPMENUA *hMenuStackA, int nItem);
void CallContextMenuW(POPUPMENUW *hMenuStackW, int nItem);
void FreeContextMenuA(POPUPMENUA *hMenuStackA);
void FreeContextMenuW(POPUPMENUW *hMenuStackW);
BOOL GetExplorerMenu(LPCONTEXTMENU *pContextMenu, LPCONTEXTMENU2 *pContextSubMenu2, LPCONTEXTMENU3 *pContextSubMenu3, HWND hWnd, wchar_t *wpFile);
LPITEMIDLIST NextPIDL(LPCITEMIDLIST pidl);
void GetActionParametersA(HSTACK *hParamStack, char *pText, char **ppText);
void GetActionParametersW(HSTACK *hParamStack, wchar_t *wpText, wchar_t **wppText);
void SetParametersExpCharA(HSTACK *hParamStack, char *pFile, char *pExeDir, char *pMenuID, char *pItemID, char *pUrlLink);
void SetParametersExpCharW(HSTACK *hParamStack, wchar_t *wpFile, wchar_t *wpExeDir, wchar_t *wpMenuID, wchar_t *wpItemID, wchar_t *wpUrlLink);
int CreateParametersStruct(HSTACK *hParamStack, unsigned char **lppStruct);
int GetParameterInt(HSTACK *hParamStack, int nIndex);
unsigned char* GetParameterChar(HSTACK *hParamStack, int nIndex);
unsigned char* GetParameterExpChar(HSTACK *hParamStack, int nIndex);
void FreeActionParameters(HSTACK *hParamStack);
int NextStringA(char *pText, char *szStr, int nStrLen, char **ppText, int *nMinus);
int NextStringW(wchar_t *wpText, wchar_t *wszStr, int nStrLen, wchar_t **wppText, int *nMinus);
BOOL SkipCommentA(char **pText);
BOOL SkipCommentW(wchar_t **wpText);
int GetActionNameA(char *pText, char *szStr, int nStrLen, char **ppText);
int GetActionNameW(wchar_t *wpText, wchar_t *wszStr, int nStrLen, wchar_t **wppText);
int GetFileDirA(char *pFile, char *szFileDir, int nFileDirLen);
int GetFileDirW(wchar_t *wpFile, wchar_t *wszFileDir, int nFileDirLen);
int GetSubMenuIndex(HMENU hMenu, HMENU hSubMenu);
int GetSubMenuCount(HMENU hMenu);
void ShowStandartEditMenu(HWND hWnd, HMENU hMenu, BOOL bMouse);
BOOL GetWindowPos(HWND hWnd, HWND hWndOwner, RECT *rc);
BOOL DialogResizeMessages(DIALOGRESIZE *drs, RECT *rcInit, RECT *rcCurrent, HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
void ReadOptionsA();
void ReadOptionsW();
void SaveOptionsA(DWORD dwFlags);
void SaveOptionsW(DWORD dwFlags);
char* GetLangStringA(LANGID wLangID, int nStringID);
wchar_t* GetLangStringW(LANGID wLangID, int nStringID);
BOOL IsExtCallParamValid(LPARAM lParam, int nIndex);
int GetExtCallParam(LPARAM lParam, int nIndex);
void InitCommon(PLUGINDATA *pd);
void InitMain();
void UninitMain();

//Global variables
char szPluginName[MAX_PATH];
wchar_t wszPluginName[MAX_PATH];
HINSTANCE hInstanceDLL;
HWND hMainWnd;
HWND hMdiClient;
HMENU hMainMenu;
HMENU hMenuRecentFiles;
HMENU hMenuLanguage;
HMENU hPopupEdit;
HICON hMainIcon;
BOOL bOldWindows;
BOOL bAkelEdit;
BOOL bMDI;
LANGID wLangSystem;
BOOL bInitCommon=FALSE;
BOOL bInitMain=FALSE;
HANDLE hThread=NULL;
DWORD dwThreadId;
HWND hWndMainDlg=NULL;
RECT rcMainInitDialog={0};
RECT rcMainCurrentDialog={0};
BOOL bMainDialogRectSave=FALSE;
BOOL bMenuMainEnable=FALSE;
BOOL bMenuEditEnable=FALSE;
BOOL bMenuTabEnable=FALSE;
BOOL bMenuUrlEnable=FALSE;
BOOL bMenuUrlShow=FALSE;
BOOL bMenuRecentFilesEnable=FALSE;
POPUPMENUA hMenuManualStackA={0};
POPUPMENUW hMenuManualStackW={0};
POPUPMENUA hMenuMainStackA={0};
POPUPMENUW hMenuMainStackW={0};
POPUPMENUA hMenuEditStackA={0};
POPUPMENUW hMenuEditStackW={0};
POPUPMENUA hMenuTabStackA={0};
POPUPMENUW hMenuTabStackW={0};
POPUPMENUA hMenuUrlStackA={0};
POPUPMENUW hMenuUrlStackW={0};
POPUPMENUA hMenuRecentFilesStackA={0};
POPUPMENUW hMenuRecentFilesStackW={0};
POPUPMENUA hMenuDialogStackA={0};
POPUPMENUW hMenuDialogStackW={0};
POPUPMENUA *lpCurrentMenuStackA=NULL;
POPUPMENUW *lpCurrentMenuStackW=NULL;
char szCurrentFile[MAX_PATH];
wchar_t wszCurrentFile[MAX_PATH];
char szExeDir[MAX_PATH];
wchar_t wszExeDir[MAX_PATH];
char szUrlLink[MAX_PATH];
wchar_t wszUrlLink[MAX_PATH];
char *szManualText=NULL;
wchar_t *wszManualText=NULL;
char *szMainText=NULL;
wchar_t *wszMainText=NULL;
char *szEditText=NULL;
wchar_t *wszEditText=NULL;
char *szTabText=NULL;
wchar_t *wszTabText=NULL;
char *szUrlText=NULL;
wchar_t *wszUrlText=NULL;
char *szRecentFilesText=NULL;
wchar_t *wszRecentFilesText=NULL;
char szMenuSearch[MAX_PATH]="";
wchar_t wszMenuSearch[MAX_PATH]=L"";
int nMenuIndex=-1;
WNDPROC OldEditDlgProc=NULL;
WNDPROCDATA *NewMainProcData=NULL;
WNDPROCDATA *NewFrameProcData=NULL;


//Identification
extern "C" void __declspec(dllexport) DllAkelPadID(PLUGINVERSION *pv)
{
  pv->dwAkelDllVersion=AKELDLL;
  pv->dwExeMinVersion3x=MAKE_IDENTIFIER(3, 7, 4, 0);
  pv->dwExeMinVersion4x=MAKE_IDENTIFIER(4, 4, 0, 0);
  pv->pPluginName="ContextMenu";
}

//Plugin extern function
extern "C" void __declspec(dllexport) Main(PLUGINDATA *pd)
{
  if (pd->lpbAutoLoad)
  {
    *pd->lpbAutoLoad=TRUE;
    return;
  }

  if (!bInitCommon) InitCommon(pd);
  if (!bInitMain) InitMain();

  if (pd->lParam)
  {
    if (IsExtCallParamValid(pd->lParam, 1))
    {
      if (bOldWindows)
      {
        if (GetExtCallParam(pd->lParam, 1) == DLLA_CONTEXTMENU_INDEX)
        {
          char *pSearchString=NULL;

          if (IsExtCallParamValid(pd->lParam, 2))
            nMenuIndex=GetExtCallParam(pd->lParam, 2);
          if (IsExtCallParamValid(pd->lParam, 3))
            pSearchString=(char *)GetExtCallParam(pd->lParam, 3);

          if (pSearchString)
          {
            lstrcpynA(szMenuSearch, pSearchString, MAX_PATH);
          }
        }
      }
      else
      {
        if (GetExtCallParam(pd->lParam, 1) == DLLA_CONTEXTMENU_INDEX)
        {
          wchar_t *wpSearchString=NULL;

          if (IsExtCallParamValid(pd->lParam, 2))
            nMenuIndex=GetExtCallParam(pd->lParam, 2);
          if (IsExtCallParamValid(pd->lParam, 3))
            wpSearchString=(wchar_t *)GetExtCallParam(pd->lParam, 3);

          if (wpSearchString)
          {
            lstrcpynW(wszMenuSearch, wpSearchString, MAX_PATH);
          }
        }
      }
    }
  }
  if (!pd->bOnStart)
  {
    if (!hThread)
    {
      if (bOldWindows)
        hThread=CreateThread(NULL, 0, ThreadProcA, NULL, 0, &dwThreadId);
      else
        hThread=CreateThread(NULL, 0, ThreadProcW, NULL, 0, &dwThreadId);
    }
  }

  //Stay in memory, and show as active
  pd->nUnload=UD_NONUNLOAD_ACTIVE;
}

extern "C" void __declspec(dllexport) Show(PLUGINDATA *pd)
{
  if (pd->lpbAutoLoad)
  {
    *pd->lpbAutoLoad=FALSE;
    return;
  }

  if (!bInitCommon) InitCommon(pd);
  if (!bInitMain) InitMain();

  if (bOldWindows)
  {
    EDITINFO ei;
    RECT rc;
    int nCmd;

    if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
    {
      if (!hMenuManualStackA.hPopupMenu)
        CreateContextMenuA(&hMenuManualStackA, szManualText);
      lstrcpynA(szCurrentFile, (char *)ei.pFile, MAX_PATH);

      GetWindowRect(ei.hWndEdit, &rc);
      if (nCmd=ShowContextMenuA(&hMenuManualStackA, hMainWnd, TYPE_EDIT, rc.left, rc.top))
        CallContextMenuA(&hMenuManualStackA, nCmd);
    }
  }
  else
  {
    EDITINFO ei;
    RECT rc;
    int nCmd;

    if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
    {
      if (!hMenuManualStackW.hPopupMenu)
        CreateContextMenuW(&hMenuManualStackW, wszManualText);
      lstrcpynW(wszCurrentFile, (wchar_t *)ei.pFile, MAX_PATH);

      GetWindowRect(ei.hWndEdit, &rc);
      if (nCmd=ShowContextMenuW(&hMenuManualStackW, hMainWnd, TYPE_EDIT, rc.left, rc.top))
        CallContextMenuW(&hMenuManualStackW, nCmd);
    }
  }

  //Stay in memory, but show as non-active
  pd->nUnload=UD_NONUNLOAD_NONACTIVE;
}

DWORD WINAPI ThreadProcA(LPVOID lpParameter)
{
  MSG msg;
  BOOL bMsgStatus;

  OleInitialize(NULL);

  hWndMainDlg=CreateDialogA(hInstanceDLL, MAKEINTRESOURCEA(IDD_CONTEXTA), hMainWnd, (DLGPROC)MainDlgProcA);

  if (hWndMainDlg)
  {
    while ((bMsgStatus=GetMessage(&msg, NULL, 0, 0)) && bMsgStatus != -1)
    {
      if (hWndMainDlg && !IsDialogMessage(hWndMainDlg, &msg))
      {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
      }
    }
  }

  return 0;
}

DWORD WINAPI ThreadProcW(LPVOID lpParameter)
{
  MSG msg;
  BOOL bMsgStatus;

  OleInitialize(NULL);

  hWndMainDlg=CreateDialogW(hInstanceDLL, MAKEINTRESOURCEW(IDD_CONTEXTW), hMainWnd, (DLGPROC)MainDlgProcW);

  if (hWndMainDlg)
  {
    while ((bMsgStatus=GetMessageW(&msg, NULL, 0, 0)) && bMsgStatus != -1)
    {
      if (hWndMainDlg && !IsDialogMessageW(hWndMainDlg, &msg))
      {
        TranslateMessage(&msg);
        DispatchMessageW(&msg);
      }
    }
  }

  return 0;
}

LRESULT CALLBACK NewMainProcA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == AKDN_MAIN_ONSTART_PRESHOW)
  {
    if (bMenuMainEnable)
    {
      if (!hMenuMainStackA.hPopupMenu)
        CreateContextMenuA(&hMenuMainStackA, szMainText);
      InsertMainMenuA(&hMenuMainStackA);
    }
  }
  else if (uMsg == AKDN_CONTEXTMENU)
  {
    NCONTEXTMENU *ncm=(NCONTEXTMENU *)lParam;

    if (bMenuEditEnable && ncm->uType == NCM_EDIT)
    {
      ncm->bProcess=FALSE;

      //Show context menu
      if (!bMenuUrlShow)
      {
        EDITINFO ei;
        int nCmd;

        if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
        {
          if (!hMenuEditStackA.hPopupMenu)
            CreateContextMenuA(&hMenuEditStackA, szEditText);
          lstrcpynA(szCurrentFile, (char *)ei.pFile, MAX_PATH);

          if (nCmd=ShowContextMenuA(&hMenuEditStackA, hMainWnd, TYPE_EDIT, ncm->pt.x, ncm->pt.y))
            CallContextMenuA(&hMenuEditStackA, nCmd);
        }
      }
    }
    else if (bMenuTabEnable && ncm->uType == NCM_TAB)
    {
      ncm->bProcess=FALSE;

      //Show context menu
      if (!bMenuUrlShow)
      {
        EDITINFO ei;
        int nCmd;

        if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
        {
          if (!hMenuTabStackA.hPopupMenu)
            CreateContextMenuA(&hMenuTabStackA, szTabText);
          lstrcpynA(szCurrentFile, (char *)ei.pFile, MAX_PATH);

          if (nCmd=ShowContextMenuA(&hMenuTabStackA, hMainWnd, TYPE_TAB, ncm->pt.x, ncm->pt.y))
            CallContextMenuA(&hMenuTabStackA, nCmd);
        }
      }
    }
    if (bMenuUrlShow) ncm->bProcess=FALSE;
    bMenuUrlShow=FALSE;
  }
  else if (uMsg == WM_MENURBUTTONUP)
  {
    if (bMenuRecentFilesEnable)
    {
      if (hMenuRecentFiles == (HMENU)lParam ||
         hMenuMainStackA.hRecentFilesSubMenu == (HMENU)lParam)
      {
        POINT pt;

        GetCursorPos(&pt);

        if (MenuItemFromPoint(hMainWnd, (HMENU)lParam, pt) != -1)
        {
          RECENTFILESA rf;

          if (SendMessage(hMainWnd, AKD_RECENTFILES, RF_GET, (LPARAM)&rf) >= (int)(wParam + 1))
          {
            if (!hMenuRecentFilesStackA.hPopupMenu)
              CreateContextMenuA(&hMenuRecentFilesStackA, szRecentFilesText);
            lstrcpynA(szCurrentFile, rf.lpszRecentNames[wParam], MAX_PATH);

            //Show context menu
            {
              POINT pt;
              int nCmd;

              GetCursorPos(&pt);
              if (nCmd=ShowContextMenuA(&hMenuRecentFilesStackA, hMainWnd, TYPE_RECENTFILES, pt.x, pt.y))
              {
                CallContextMenuA(&hMenuRecentFilesStackA, nCmd);
                SendMessage(hMainWnd, WM_CANCELMODE, 0, 0);
              }
            }
          }
        }
      }
    }
  }
  else if (uMsg == WM_ENTERMENULOOP)
  {
    if (bMenuMainEnable)
    {
      if (wParam == FALSE)
      {
        EDITINFO ei;

        if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
          lstrcpynA(szCurrentFile, (char *)ei.pFile, MAX_PATH);
        else
          szCurrentFile[0]='\0';

        lpCurrentMenuStackA=&hMenuMainStackA;
        UpdateContextMenuA(lpCurrentMenuStackA, TYPE_MAIN);
      }
    }
  }
  else if (uMsg == WM_EXITMENULOOP)
  {
    if (bMenuMainEnable)
    {
      if (wParam == FALSE)
      {
        lpCurrentMenuStackA=NULL;
      }
    }
  }
  else if (uMsg == WM_INITMENUPOPUP)
  {
    if (lpCurrentMenuStackA)
    {
      if ((HMENU)wParam == lpCurrentMenuStackA->hExplorerSubMenu)
      {
        InitMenuPopupA(lpCurrentMenuStackA, INIT_EXPLORER);
      }
      else if ((HMENU)wParam == lpCurrentMenuStackA->hRecentFilesSubMenu)
      {
        InitMenuPopupA(lpCurrentMenuStackA, INIT_RECENTFILES);
      }
      else if ((HMENU)wParam == lpCurrentMenuStackA->hLanguagesSubMenu)
      {
        InitMenuPopupA(lpCurrentMenuStackA, INIT_LANGUAGES);
      }
    }
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) >= IDM_MIN_EXPLORER && LOWORD(wParam) <= IDM_MAX_MENU)
    {
      CallContextMenuA(&hMenuMainStackA, LOWORD(wParam));
    }
    else
    {
      if (hMenuMainStackA.hMainMenu)
      {
        //TranslateAccelerator
        if (HIWORD(wParam) == 1)
        {
          DWORD dwMenuState;

          if (GetMenuState(hMainMenu, LOWORD(wParam), MF_BYCOMMAND) != (DWORD)-1)
          {
            SendMessage(hMainWnd, WM_INITMENU, (WPARAM)hMainMenu, IMENU_EDIT|IMENU_CHECKS);

            if ((dwMenuState=GetMenuState(hMainMenu, LOWORD(wParam), MF_BYCOMMAND)) != (DWORD)-1)
            {
              if (dwMenuState & (MF_DISABLED | MF_GRAYED))
                return 0;
            }
          }
        }
      }
    }
  }
  else if (uMsg == AKDN_MAIN_ONFINISH)
  {
    NewMainProcData->NextProc(hWnd, uMsg, wParam, lParam);
    if (hWndMainDlg) SendMessage(hWndMainDlg, WM_COMMAND, IDCANCEL, 0);
    return FALSE;
  }

  //Edit parent
  {
   LRESULT lResult;

   if (lResult=EditParentMessagesA(hWnd, uMsg, wParam, lParam)) return lResult;
  }

  //Explorer menu
  if (lpCurrentMenuStackA)
  {
    if (lpCurrentMenuStackA->pExplorerSubMenu3)
    {
      LRESULT lResult;

      if (SUCCEEDED(lpCurrentMenuStackA->pExplorerSubMenu3->HandleMenuMsg2(uMsg, wParam, lParam, &lResult)))
        return lResult;
    }
    else if (lpCurrentMenuStackA->pExplorerSubMenu2)
    {
      if (SUCCEEDED(lpCurrentMenuStackA->pExplorerSubMenu2->HandleMenuMsg(uMsg, wParam, lParam)))
        return 0;
    }
  }

  //Call next procedure
  return NewMainProcData->NextProc(hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK NewMainProcW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == AKDN_MAIN_ONSTART_PRESHOW)
  {
    if (bMenuMainEnable)
    {
      if (!hMenuMainStackW.hPopupMenu)
        CreateContextMenuW(&hMenuMainStackW, wszMainText);
      InsertMainMenuW(&hMenuMainStackW);
    }
  }
  else if (uMsg == AKDN_CONTEXTMENU)
  {
    NCONTEXTMENU *ncm=(NCONTEXTMENU *)lParam;

    if (bMenuEditEnable && ncm->uType == NCM_EDIT)
    {
      ncm->bProcess=FALSE;

      //Show context menu
      if (!bMenuUrlShow)
      {
        EDITINFO ei;
        int nCmd;

        if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
        {
          if (!hMenuEditStackW.hPopupMenu)
            CreateContextMenuW(&hMenuEditStackW, wszEditText);
          lstrcpynW(wszCurrentFile, (wchar_t *)ei.pFile, MAX_PATH);

          if (nCmd=ShowContextMenuW(&hMenuEditStackW, hMainWnd, TYPE_EDIT, ncm->pt.x, ncm->pt.y))
            CallContextMenuW(&hMenuEditStackW, nCmd);
        }
      }
    }
    else if (bMenuTabEnable && ncm->uType == NCM_TAB)
    {
      ncm->bProcess=FALSE;

      //Show context menu
      if (!bMenuUrlShow)
      {
        EDITINFO ei;
        int nCmd;

        if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
        {
          if (!hMenuTabStackW.hPopupMenu)
            CreateContextMenuW(&hMenuTabStackW, wszTabText);
          lstrcpynW(wszCurrentFile, (wchar_t *)ei.pFile, MAX_PATH);

          if (nCmd=ShowContextMenuW(&hMenuTabStackW, hMainWnd, TYPE_TAB, ncm->pt.x, ncm->pt.y))
            CallContextMenuW(&hMenuTabStackW, nCmd);
        }
      }
    }
    if (bMenuUrlShow) ncm->bProcess=FALSE;
    bMenuUrlShow=FALSE;
  }
  else if (uMsg == WM_MENURBUTTONUP)
  {
    if (bMenuRecentFilesEnable)
    {
      if (hMenuRecentFiles == (HMENU)lParam ||
         hMenuMainStackW.hRecentFilesSubMenu == (HMENU)lParam)
      {
        POINT pt;

        GetCursorPos(&pt);

        if (MenuItemFromPoint(hMainWnd, (HMENU)lParam, pt) != -1)
        {
          RECENTFILESW rf;

          if (SendMessage(hMainWnd, AKD_RECENTFILES, RF_GET, (LPARAM)&rf) >= (int)(wParam + 1))
          {
            if (!hMenuRecentFilesStackW.hPopupMenu)
              CreateContextMenuW(&hMenuRecentFilesStackW, wszRecentFilesText);
            lstrcpynW(wszCurrentFile, rf.lpszRecentNames[wParam], MAX_PATH);

            //Show context menu
            {
              POINT pt;
              int nCmd;

              GetCursorPos(&pt);
              if (nCmd=ShowContextMenuW(&hMenuRecentFilesStackW, hMainWnd, TYPE_RECENTFILES, pt.x, pt.y))
              {
                CallContextMenuW(&hMenuRecentFilesStackW, nCmd);
                SendMessage(hMainWnd, WM_CANCELMODE, 0, 0);
              }
            }
          }
        }
      }
    }
  }
  else if (uMsg == WM_ENTERMENULOOP)
  {
    if (bMenuMainEnable)
    {
      if (wParam == FALSE)
      {
        EDITINFO ei;

        if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
          lstrcpynW(wszCurrentFile, (wchar_t *)ei.pFile, MAX_PATH);
        else
          wszCurrentFile[0]='\0';

        lpCurrentMenuStackW=&hMenuMainStackW;
        UpdateContextMenuW(lpCurrentMenuStackW, TYPE_MAIN);
      }
    }
  }
  else if (uMsg == WM_EXITMENULOOP)
  {
    if (bMenuMainEnable)
    {
      if (wParam == FALSE)
      {
        lpCurrentMenuStackW=NULL;
      }
    }
  }
  else if (uMsg == WM_INITMENUPOPUP)
  {
    if (lpCurrentMenuStackW)
    {
      if ((HMENU)wParam == lpCurrentMenuStackW->hExplorerSubMenu)
      {
        InitMenuPopupW(lpCurrentMenuStackW, INIT_EXPLORER);
      }
      else if ((HMENU)wParam == lpCurrentMenuStackW->hRecentFilesSubMenu)
      {
        InitMenuPopupW(lpCurrentMenuStackW, INIT_RECENTFILES);
      }
      else if ((HMENU)wParam == lpCurrentMenuStackW->hLanguagesSubMenu)
      {
        InitMenuPopupW(lpCurrentMenuStackW, INIT_LANGUAGES);
      }
    }
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) >= IDM_MIN_EXPLORER && LOWORD(wParam) <= IDM_MAX_MENU)
    {
      CallContextMenuW(&hMenuMainStackW, LOWORD(wParam));
    }
    else
    {
      if (hMenuMainStackW.hMainMenu)
      {
        //TranslateAccelerator
        if (HIWORD(wParam) == 1)
        {
          DWORD dwMenuState;

          if (GetMenuState(hMainMenu, LOWORD(wParam), MF_BYCOMMAND) != (DWORD)-1)
          {
            SendMessage(hMainWnd, WM_INITMENU, (WPARAM)hMainMenu, IMENU_EDIT|IMENU_CHECKS);

            if ((dwMenuState=GetMenuState(hMainMenu, LOWORD(wParam), MF_BYCOMMAND)) != (DWORD)-1)
            {
              if (dwMenuState & (MF_DISABLED | MF_GRAYED))
                return 0;
            }
          }
        }
      }
    }
  }
  else if (uMsg == AKDN_MAIN_ONFINISH)
  {
    NewMainProcData->NextProc(hWnd, uMsg, wParam, lParam);
    if (hWndMainDlg) SendMessage(hWndMainDlg, WM_COMMAND, IDCANCEL, 0);
    return FALSE;
  }

  //Edit parent
  {
   LRESULT lResult;

   if (lResult=EditParentMessagesW(hWnd, uMsg, wParam, lParam)) return lResult;
  }

  //Explorer menu
  if (lpCurrentMenuStackW)
  {
    if (lpCurrentMenuStackW->pExplorerSubMenu3)
    {
      LRESULT lResult;

      if (SUCCEEDED(lpCurrentMenuStackW->pExplorerSubMenu3->HandleMenuMsg2(uMsg, wParam, lParam, &lResult)))
        return lResult;
    }
    else if (lpCurrentMenuStackW->pExplorerSubMenu2)
    {
      if (SUCCEEDED(lpCurrentMenuStackW->pExplorerSubMenu2->HandleMenuMsg(uMsg, wParam, lParam)))
        return 0;
    }
  }

  //Call next procedure
  return NewMainProcData->NextProc(hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK NewFrameProcA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  LRESULT lResult;

  if (lResult=EditParentMessagesA(hWnd, uMsg, wParam, lParam)) return lResult;

  //Call next procedure
  return NewFrameProcData->NextProc(hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK NewFrameProcW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  LRESULT lResult;

  if (lResult=EditParentMessagesW(hWnd, uMsg, wParam, lParam)) return lResult;

  //Call next procedure
  return NewFrameProcData->NextProc(hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK EditParentMessagesA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == WM_NOTIFY)
  {
    if (wParam == ID_EDIT)
    {
      if (((NMHDR *)lParam)->code == EN_LINK)
      {
        if (((ENLINK *)lParam)->msg == WM_RBUTTONUP)
        {
          //Show context menu
          if (bMenuUrlEnable)
          {
            MENUITEM *lpElement;
            EDITINFO ei;
            GETTEXTRANGE gtr;
            CHARRANGE cr;
            POINT pt;
            int nCmd;

            if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
            {
              if (!hMenuUrlStackA.hPopupMenu)
                CreateContextMenuA(&hMenuUrlStackA, szUrlText);
              lstrcpynA(szCurrentFile, (char *)ei.pFile, MAX_PATH);

              GetCursorPos(&pt);
              if (nCmd=ShowContextMenuA(&hMenuUrlStackA, hMainWnd, TYPE_URL, pt.x, pt.y))
              {
                if (lpElement=GetContextMenuItemA(&hMenuUrlStackA, nCmd))
                {
                  if (lpElement->dwAction == ACT_LINK)
                  {
                    int nCommand=0;

                    nCommand=GetParameterInt(&lpElement->hParamStack, 1);

                    if (nCommand)
                    {
                      if (nCommand == URL_OPEN)
                      {
                        gtr.cpMin=((ENLINK *)lParam)->chrg.cpMin;
                        gtr.cpMax=((ENLINK *)lParam)->chrg.cpMax;

                        if (SendMessage(hMainWnd, AKD_GETTEXTRANGE, (LPARAM)((NMHDR *)lParam)->hwndFrom, (WPARAM)&gtr))
                        {
                          ShellExecuteA(((NMHDR *)lParam)->hwndFrom, "open", (char *)gtr.pText, NULL, NULL, SW_SHOWNORMAL);

                          SendMessage(hMainWnd, AKD_FREETEXT, 0, (WPARAM)gtr.pText);
                        }
                      }
                      else if (nCommand == URL_COPY)
                      {
                        SendMessage(((NMHDR *)lParam)->hwndFrom, WM_SETREDRAW, FALSE, 0);
                        if (bAkelEdit) SendMessage(((NMHDR *)lParam)->hwndFrom, AEM_LOCKSCROLL, SB_BOTH, TRUE);
                        SendMessage(((NMHDR *)lParam)->hwndFrom, EM_EXGETSEL, 0, (WPARAM)&cr);
                        SendMessage(((NMHDR *)lParam)->hwndFrom, EM_EXSETSEL, 0, (WPARAM)&((ENLINK *)lParam)->chrg);
                        SendMessage(hMainWnd, AKD_COPY, (WPARAM)((NMHDR *)lParam)->hwndFrom, 0);
                        SendMessage(((NMHDR *)lParam)->hwndFrom, EM_EXSETSEL, 0, (WPARAM)&cr);
                        if (bAkelEdit) SendMessage(((NMHDR *)lParam)->hwndFrom, AEM_LOCKSCROLL, SB_BOTH, FALSE);
                        SendMessage(((NMHDR *)lParam)->hwndFrom, WM_SETREDRAW, TRUE, 0);
                        InvalidateRect(((NMHDR *)lParam)->hwndFrom, NULL, FALSE);
                      }
                      else if (nCommand == URL_SELECT)
                      {
                        SendMessage(((NMHDR *)lParam)->hwndFrom, EM_EXSETSEL, 0, (WPARAM)&((ENLINK *)lParam)->chrg);
                      }
                    }
                  }
                  else
                  {
                    gtr.cpMin=((ENLINK *)lParam)->chrg.cpMin;
                    gtr.cpMax=((ENLINK *)lParam)->chrg.cpMax;
                    szUrlLink[0]='\0';

                    if (SendMessage(hMainWnd, AKD_GETTEXTRANGE, (LPARAM)((NMHDR *)lParam)->hwndFrom, (WPARAM)&gtr))
                    {
                      lstrcpynA(szUrlLink, (char *)gtr.pText, MAX_PATH);
                      SendMessage(hMainWnd, AKD_FREETEXT, 0, (WPARAM)gtr.pText);
                    }
                    CallContextMenuA(&hMenuUrlStackA, nCmd);
                    szUrlLink[0]='\0';
                  }
                }
              }
              bMenuUrlShow=TRUE;
            }
          }
        }
      }
    }
  }
  return FALSE;
}

LRESULT CALLBACK EditParentMessagesW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == WM_NOTIFY)
  {
    if (wParam == ID_EDIT)
    {
      if (((NMHDR *)lParam)->code == EN_LINK)
      {
        if (((ENLINK *)lParam)->msg == WM_RBUTTONUP)
        {
          //Show context menu
          if (bMenuUrlEnable)
          {
            MENUITEM *lpElement;
            EDITINFO ei;
            GETTEXTRANGE gtr;
            CHARRANGE cr;
            POINT pt;
            int nCmd;

            if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
            {
              if (!hMenuUrlStackW.hPopupMenu)
                CreateContextMenuW(&hMenuUrlStackW, wszUrlText);
              lstrcpynW(wszCurrentFile, (wchar_t *)ei.pFile, MAX_PATH);

              GetCursorPos(&pt);
              if (nCmd=ShowContextMenuW(&hMenuUrlStackW, hMainWnd, TYPE_URL, pt.x, pt.y))
              {
                if (lpElement=GetContextMenuItemW(&hMenuUrlStackW, nCmd))
                {
                  if (lpElement->dwAction == ACT_LINK)
                  {
                    int nCommand=0;

                    nCommand=GetParameterInt(&lpElement->hParamStack, 1);

                    if (nCommand)
                    {
                      if (nCommand == URL_OPEN)
                      {
                        gtr.cpMin=((ENLINK *)lParam)->chrg.cpMin;
                        gtr.cpMax=((ENLINK *)lParam)->chrg.cpMax;

                        if (SendMessage(hMainWnd, AKD_GETTEXTRANGE, (LPARAM)((NMHDR *)lParam)->hwndFrom, (WPARAM)&gtr))
                        {
                          ShellExecuteW(((NMHDR *)lParam)->hwndFrom, L"open", (wchar_t *)gtr.pText, NULL, NULL, SW_SHOWNORMAL);

                          SendMessage(hMainWnd, AKD_FREETEXT, 0, (WPARAM)gtr.pText);
                        }
                      }
                      else if (nCommand == URL_COPY)
                      {
                        SendMessage(((NMHDR *)lParam)->hwndFrom, WM_SETREDRAW, FALSE, 0);
                        if (bAkelEdit) SendMessage(((NMHDR *)lParam)->hwndFrom, AEM_LOCKSCROLL, SB_BOTH, TRUE);
                        SendMessage(((NMHDR *)lParam)->hwndFrom, EM_EXGETSEL, 0, (WPARAM)&cr);
                        SendMessage(((NMHDR *)lParam)->hwndFrom, EM_EXSETSEL, 0, (WPARAM)&((ENLINK *)lParam)->chrg);
                        SendMessage(hMainWnd, AKD_COPY, (WPARAM)((NMHDR *)lParam)->hwndFrom, 0);
                        SendMessage(((NMHDR *)lParam)->hwndFrom, EM_EXSETSEL, 0, (WPARAM)&cr);
                        if (bAkelEdit) SendMessage(((NMHDR *)lParam)->hwndFrom, AEM_LOCKSCROLL, SB_BOTH, FALSE);
                        SendMessage(((NMHDR *)lParam)->hwndFrom, WM_SETREDRAW, TRUE, 0);
                        InvalidateRect(((NMHDR *)lParam)->hwndFrom, NULL, FALSE);
                      }
                      else if (nCommand == URL_SELECT)
                      {
                        SendMessage(((NMHDR *)lParam)->hwndFrom, EM_EXSETSEL, 0, (WPARAM)&((ENLINK *)lParam)->chrg);
                      }
                    }
                  }
                  else
                  {
                    gtr.cpMin=((ENLINK *)lParam)->chrg.cpMin;
                    gtr.cpMax=((ENLINK *)lParam)->chrg.cpMax;
                    wszUrlLink[0]='\0';

                    if (SendMessage(hMainWnd, AKD_GETTEXTRANGE, (LPARAM)((NMHDR *)lParam)->hwndFrom, (WPARAM)&gtr))
                    {
                      lstrcpynW(wszUrlLink, (wchar_t *)gtr.pText, MAX_PATH);
                      SendMessage(hMainWnd, AKD_FREETEXT, 0, (WPARAM)gtr.pText);
                    }
                    CallContextMenuW(&hMenuUrlStackW, nCmd);
                    wszUrlLink[0]='\0';
                  }
                }
              }
              bMenuUrlShow=TRUE;
            }
          }
        }
      }
    }
  }
  return FALSE;
}

LRESULT CALLBACK MainDlgProcA(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndType;
  static HWND hWndEnable;
  static HWND hWndText;
  static HWND hWndShow;
  static HWND hWndOK;
  static HWND hWndCancel;
  static int nMenuType;
  static char *szManualTextDlg;
  static char *szMainTextDlg;
  static char *szEditTextDlg;
  static char *szTabTextDlg;
  static char *szUrlTextDlg;
  static char *szRecentFilesTextDlg;
  static BOOL bMenuMainEnableDlg;
  static BOOL bMenuEditEnableDlg;
  static BOOL bMenuTabEnableDlg;
  static BOOL bMenuUrlEnableDlg;
  static BOOL bMenuRecentFilesEnableDlg;
  static DIALOGRESIZE drs[]={{&hWndType,   DRS_SIZE|DRS_X},
                             {&hWndEnable, DRS_MOVE|DRS_X},
                             {&hWndText,   DRS_SIZE|DRS_X|DRS_Y},
                             {&hWndShow,   DRS_MOVE|DRS_Y},
                             {&hWndOK,     DRS_MOVE|DRS_X|DRS_Y},
                             {&hWndCancel, DRS_MOVE|DRS_X|DRS_Y},
                             {0, 0}};

  if (uMsg == WM_INITDIALOG)
  {
    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hMainIcon);
    hWndType=GetDlgItem(hDlg, IDC_MENUTYPE);
    hWndEnable=GetDlgItem(hDlg, IDC_MENUENABLE);
    hWndText=GetDlgItem(hDlg, IDC_MENUTEXT);
    hWndShow=GetDlgItem(hDlg, IDC_MENUSHOW);
    hWndOK=GetDlgItem(hDlg, IDOK);
    hWndCancel=GetDlgItem(hDlg, IDCANCEL);

    SetDlgItemTextA(hDlg, IDC_MENUENABLE, GetLangStringA(wLangSystem, STRID_ENABLE));
    SetDlgItemTextA(hDlg, IDC_MENUSHOW, GetLangStringA(wLangSystem, STRID_SHOW));
    SetDlgItemTextA(hDlg, IDOK, GetLangStringA(wLangSystem, STRID_OK));
    SetDlgItemTextA(hDlg, IDCANCEL, GetLangStringA(wLangSystem, STRID_CANCEL));

    SendMessage(hWndText, EM_SETTEXTMODE, TM_PLAINTEXT|TM_MULTILEVELUNDO|TM_MULTICODEPAGE, 0);
    SendMessage(hWndText, EM_EXLIMITTEXT, 0, MAX_MENUTEXT_SIZE);

    SendMessageA(hWndType, CB_ADDSTRING, 0, (LPARAM)GetLangStringA(wLangSystem, STRID_MANUAL));
    SendMessageA(hWndType, CB_ADDSTRING, 0, (LPARAM)GetLangStringA(wLangSystem, STRID_MENUMAIN));
    SendMessageA(hWndType, CB_ADDSTRING, 0, (LPARAM)GetLangStringA(wLangSystem, STRID_MENUEDIT));
    SendMessageA(hWndType, CB_ADDSTRING, 0, (LPARAM)GetLangStringA(wLangSystem, STRID_MENUTAB));
    SendMessageA(hWndType, CB_ADDSTRING, 0, (LPARAM)GetLangStringA(wLangSystem, STRID_MENUURL));
    SendMessageA(hWndType, CB_ADDSTRING, 0, (LPARAM)GetLangStringA(wLangSystem, STRID_MENURECENTFILES));

    bMenuMainEnableDlg=bMenuMainEnable;
    bMenuEditEnableDlg=bMenuEditEnable;
    bMenuTabEnableDlg=bMenuTabEnable;
    bMenuUrlEnableDlg=bMenuUrlEnable;
    bMenuRecentFilesEnableDlg=bMenuRecentFilesEnable;

    if (szManualTextDlg=(char *)GlobalAlloc(GPTR, lstrlenA(szManualText) + 1))
    {
      lstrcpyA(szManualTextDlg, szManualText);
    }
    if (szMainTextDlg=(char *)GlobalAlloc(GPTR, lstrlenA(szMainText) + 1))
    {
      lstrcpyA(szMainTextDlg, szMainText);
    }
    if (szEditTextDlg=(char *)GlobalAlloc(GPTR, lstrlenA(szEditText) + 1))
    {
      lstrcpyA(szEditTextDlg, szEditText);
    }
    if (szTabTextDlg=(char *)GlobalAlloc(GPTR, lstrlenA(szTabText) + 1))
    {
      lstrcpyA(szTabTextDlg, szTabText);
    }
    if (szUrlTextDlg=(char *)GlobalAlloc(GPTR, lstrlenA(szUrlText) + 1))
    {
      lstrcpyA(szUrlTextDlg, szUrlText);
    }
    if (szRecentFilesTextDlg=(char *)GlobalAlloc(GPTR, lstrlenA(szRecentFilesText) + 1))
    {
      lstrcpyA(szRecentFilesTextDlg, szRecentFilesText);
    }

    OldEditDlgProc=(WNDPROC)GetWindowLongA(hWndText, GWL_WNDPROC);
    SetWindowLongA(hWndText, GWL_WNDPROC, (LONG)NewEditDlgProcA);

    nMenuType=-1;
    if (nMenuIndex >= 0)
      SetFocus(hWndText);
    else
      nMenuIndex=0;
    SendMessage(hWndType, CB_SETCURSEL, nMenuIndex, 0);
    nMenuIndex=-1;
    PostMessage(hDlg, WM_COMMAND, MAKELONG(IDC_MENUTYPE, CBN_SELCHANGE), (LPARAM)hWndType);
  }
  else if (uMsg == WM_INITMENUPOPUP)
  {
    if (lpCurrentMenuStackA)
    {
      if ((HMENU)wParam == lpCurrentMenuStackA->hExplorerSubMenu)
      {
        InitMenuPopupA(lpCurrentMenuStackA, INIT_EXPLORER);
      }
      else if ((HMENU)wParam == lpCurrentMenuStackA->hRecentFilesSubMenu)
      {
        InitMenuPopupA(lpCurrentMenuStackA, INIT_RECENTFILES);
      }
      else if ((HMENU)wParam == lpCurrentMenuStackA->hLanguagesSubMenu)
      {
        InitMenuPopupA(lpCurrentMenuStackA, INIT_LANGUAGES);
      }
    }
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDC_MENUTYPE && HIWORD(wParam) == CBN_SELCHANGE)
    {
      GETTEXTRANGE gtr;
      int nTextLen;
      char *pText=NULL;
      int nItem;
      BOOL bEnable=FALSE;

      nItem=SendMessage(hWndType, CB_GETCURSEL, 0, 0);

      if (nItem != nMenuType)
      {
        if (nMenuType == 0) pText=szManualTextDlg;
        else if (nMenuType == 1) pText=szMainTextDlg;
        else if (nMenuType == 2) pText=szEditTextDlg;
        else if (nMenuType == 3) pText=szTabTextDlg;
        else if (nMenuType == 4) pText=szUrlTextDlg;
        else if (nMenuType == 5) pText=szRecentFilesTextDlg;

        if (pText)
        {
          gtr.cpMin=0;
          gtr.cpMax=-1;

          if (SendMessage(hWndText, EM_GETMODIFY, 0, 0))
          {
            if (nTextLen=SendMessage(hMainWnd, AKD_GETTEXTRANGE, (WPARAM)hWndText, (LPARAM)&gtr))
            {
              if (pText) GlobalFree((HGLOBAL)pText);

              if (pText=(char *)GlobalAlloc(GPTR, nTextLen + 1))
              {
                lstrcpyA(pText, (char *)gtr.pText);

                if (nMenuType == 0) szManualTextDlg=pText;
                else if (nMenuType == 1) szMainTextDlg=pText;
                else if (nMenuType == 2) szEditTextDlg=pText;
                else if (nMenuType == 3) szTabTextDlg=pText;
                else if (nMenuType == 4) szUrlTextDlg=pText;
                else if (nMenuType == 5) szRecentFilesTextDlg=pText;
              }
              SendMessage(hMainWnd, AKD_FREETEXT, 0, (LPARAM)gtr.pText);
            }
          }
        }
        nMenuType=nItem;

        if (!nMenuType)
        {
          ShowWindow(hWndEnable, FALSE);
          EnableWindow(hWndText, TRUE);
          SetWindowTextA(hWndText, szManualTextDlg);
        }
        else
        {
          if (nMenuType == 1)
          {
            bEnable=bMenuMainEnableDlg;
            SetWindowTextA(hWndText, szMainTextDlg);
          }
          else if (nMenuType == 2)
          {
            bEnable=bMenuEditEnableDlg;
            SetWindowTextA(hWndText, szEditTextDlg);
          }
          else if (nMenuType == 3)
          {
            bEnable=bMenuTabEnableDlg;
            SetWindowTextA(hWndText, szTabTextDlg);
          }
          else if (nMenuType == 4)
          {
            bEnable=bMenuUrlEnableDlg;
            SetWindowTextA(hWndText, szUrlTextDlg);
          }
          else if (nMenuType == 5)
          {
            bEnable=bMenuRecentFilesEnableDlg;
            SetWindowTextA(hWndText, szRecentFilesTextDlg);
          }
          ShowWindow(hWndEnable, TRUE);
          SendMessage(hWndEnable, BM_SETCHECK, bEnable?BST_CHECKED:BST_UNCHECKED, 0);
          EnableWindow(hWndText, bEnable);
        }
      }

      if (*szMenuSearch)
      {
        TEXTFINDA tf;

        tf.dwFlags=FR_DOWN|FR_BEGINNING|FR_MATCHCASE;
        tf.pFindIt=szMenuSearch;
        SendMessage(hMainWnd, AKD_TEXTFIND, (WPARAM)hWndText, (LPARAM)&tf);
        szMenuSearch[0]='\0';
      }
    }
    else if (LOWORD(wParam) == IDC_MENUENABLE)
    {
      BOOL bEnable;

      if (SendMessage(hWndEnable, BM_GETCHECK, 0, 0) == BST_CHECKED)
        bEnable=TRUE;
      else
        bEnable=FALSE;

      if (nMenuType == 1) bMenuMainEnableDlg=bEnable;
      else if (nMenuType == 2) bMenuEditEnableDlg=bEnable;
      else if (nMenuType == 3) bMenuTabEnableDlg=bEnable;
      else if (nMenuType == 4) bMenuUrlEnableDlg=bEnable;
      else if (nMenuType == 5) bMenuRecentFilesEnableDlg=bEnable;

      EnableWindow(hWndText, bEnable);
    }
    else if (LOWORD(wParam) == IDC_MENUSHOW)
    {
      GETTEXTRANGE gtr;

      gtr.cpMin=0;
      gtr.cpMax=-1;

      if (SendMessage(hMainWnd, AKD_GETTEXTRANGE, (WPARAM)hWndText, (LPARAM)&gtr))
      {
        EDITINFO ei;
        POINT pt;
        int nCmd;

        if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
        {
          if (hMenuDialogStackA.hPopupMenu) FreeContextMenuA(&hMenuDialogStackA);
          CreateContextMenuA(&hMenuDialogStackA, (char *)gtr.pText);
          lstrcpynA(szCurrentFile, (char *)ei.pFile, MAX_PATH);

          GetCursorPos(&pt);
          if (nCmd=ShowContextMenuA(&hMenuDialogStackA, hDlg, TYPE_EDIT, pt.x, pt.y))
            CallContextMenuA(&hMenuDialogStackA, nCmd);
        }
        SendMessage(hMainWnd, AKD_FREETEXT, 0, (LPARAM)gtr.pText);
      }
    }
    else if (LOWORD(wParam) == IDOK)
    {
      GETTEXTRANGE gtr;
      int nTextLen;
      char *pText=NULL;
      BOOL bEnable;

      if (SendMessage(hWndEnable, BM_GETCHECK, 0, 0) == BST_CHECKED)
        bEnable=TRUE;
      else
        bEnable=FALSE;

      if (nMenuType == 0)
      {
        pText=szManualTextDlg;
      }
      else if (nMenuType == 1)
      {
        bMenuMainEnableDlg=bEnable;
        pText=szMainTextDlg;
      }
      else if (nMenuType == 2)
      {
        bMenuEditEnableDlg=bEnable;
        pText=szEditTextDlg;
      }
      else if (nMenuType == 3)
      {
        bMenuTabEnableDlg=bEnable;
        pText=szTabTextDlg;
      }
      else if (nMenuType == 4)
      {
        bMenuUrlEnableDlg=bEnable;
        pText=szUrlTextDlg;
      }
      else if (nMenuType == 5)
      {
        bMenuRecentFilesEnableDlg=bEnable;
        pText=szRecentFilesTextDlg;
      }
      bMenuMainEnable=bMenuMainEnableDlg;
      bMenuEditEnable=bMenuEditEnableDlg;
      bMenuTabEnable=bMenuTabEnableDlg;
      bMenuUrlEnable=bMenuUrlEnableDlg;
      bMenuRecentFilesEnable=bMenuRecentFilesEnableDlg;

      gtr.cpMin=0;
      gtr.cpMax=-1;

      if (SendMessage(hWndText, EM_GETMODIFY, 0, 0))
      {
        if (nTextLen=SendMessage(hMainWnd, AKD_GETTEXTRANGE, (WPARAM)hWndText, (LPARAM)&gtr))
        {
          if (pText) GlobalFree((HGLOBAL)pText);

          if (pText=(char *)GlobalAlloc(GPTR, nTextLen + 1))
          {
            lstrcpyA(pText, (char *)gtr.pText);

            if (nMenuType == 0) szManualTextDlg=pText;
            else if (nMenuType == 1) szMainTextDlg=pText;
            else if (nMenuType == 2) szEditTextDlg=pText;
            else if (nMenuType == 3) szTabTextDlg=pText;
            else if (nMenuType == 4) szUrlTextDlg=pText;
            else if (nMenuType == 5) szRecentFilesTextDlg=pText;
          }
          SendMessage(hMainWnd, AKD_FREETEXT, 0, (LPARAM)gtr.pText);
        }
      }

      if (szManualText) GlobalFree((HGLOBAL)szManualText);
      if (szMainText) GlobalFree((HGLOBAL)szMainText);
      if (szEditText) GlobalFree((HGLOBAL)szEditText);
      if (szTabText) GlobalFree((HGLOBAL)szTabText);
      if (szUrlText) GlobalFree((HGLOBAL)szUrlText);
      if (szRecentFilesText) GlobalFree((HGLOBAL)szRecentFilesText);
      szManualText=szManualTextDlg;
      szMainText=szMainTextDlg;
      szEditText=szEditTextDlg;
      szTabText=szTabTextDlg;
      szUrlText=szUrlTextDlg;
      szRecentFilesText=szRecentFilesTextDlg;

      DeleteMainMenuA(&hMenuMainStackA);
      FreeContextMenuA(&hMenuManualStackA);
      FreeContextMenuA(&hMenuMainStackA);
      FreeContextMenuA(&hMenuEditStackA);
      FreeContextMenuA(&hMenuTabStackA);
      FreeContextMenuA(&hMenuUrlStackA);
      FreeContextMenuA(&hMenuRecentFilesStackA);
      SaveOptionsA(OF_MENUTEXT);

      if (bMenuMainEnable)
      {
        if (!hMenuMainStackA.hPopupMenu)
          CreateContextMenuA(&hMenuMainStackA, szMainText);
        InsertMainMenuA(&hMenuMainStackA);
      }

      DestroyWindow(hWndMainDlg);
      hWndMainDlg=NULL;
      CloseHandle(hThread);
      hThread=NULL;
      ExitThread(0);
    }
    else if (LOWORD(wParam) == IDCANCEL)
    {
      if (szManualTextDlg) GlobalFree((HGLOBAL)szManualTextDlg);
      if (szMainTextDlg) GlobalFree((HGLOBAL)szMainTextDlg);
      if (szEditTextDlg) GlobalFree((HGLOBAL)szEditTextDlg);
      if (szTabTextDlg) GlobalFree((HGLOBAL)szTabTextDlg);
      if (szUrlTextDlg) GlobalFree((HGLOBAL)szUrlTextDlg);
      if (szRecentFilesTextDlg) GlobalFree((HGLOBAL)szRecentFilesTextDlg);

      DestroyWindow(hWndMainDlg);
      hWndMainDlg=NULL;
      CloseHandle(hThread);
      hThread=NULL;
      ExitThread(0);
    }
  }
  else if (uMsg == WM_CLOSE)
  {
    PostMessage(hDlg, WM_COMMAND, IDCANCEL, 0);
    return TRUE;
  }

  //Explorer menu
  if (lpCurrentMenuStackA)
  {
    if (lpCurrentMenuStackA->pExplorerSubMenu3)
    {
      LRESULT lResult;

      if (SUCCEEDED(lpCurrentMenuStackA->pExplorerSubMenu3->HandleMenuMsg2(uMsg, wParam, lParam, &lResult)))
        return lResult;
    }
    else if (lpCurrentMenuStackA->pExplorerSubMenu2)
    {
      if (SUCCEEDED(lpCurrentMenuStackA->pExplorerSubMenu2->HandleMenuMsg(uMsg, wParam, lParam)))
        return 0;
    }
  }

  if (DialogResizeMessages(&drs[0], &rcMainInitDialog, &rcMainCurrentDialog, hDlg, uMsg, wParam, lParam))
    bMainDialogRectSave=TRUE;

  return FALSE;
}

LRESULT CALLBACK MainDlgProcW(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  static HWND hWndType;
  static HWND hWndEnable;
  static HWND hWndText;
  static HWND hWndShow;
  static HWND hWndOK;
  static HWND hWndCancel;
  static int nMenuType;
  static wchar_t *wszManualTextDlg;
  static wchar_t *wszMainTextDlg;
  static wchar_t *wszEditTextDlg;
  static wchar_t *wszTabTextDlg;
  static wchar_t *wszUrlTextDlg;
  static wchar_t *wszRecentFilesTextDlg;
  static BOOL bMenuMainEnableDlg;
  static BOOL bMenuEditEnableDlg;
  static BOOL bMenuTabEnableDlg;
  static BOOL bMenuUrlEnableDlg;
  static BOOL bMenuRecentFilesEnableDlg;
  static DIALOGRESIZE drs[]={{&hWndType,   DRS_SIZE|DRS_X},
                             {&hWndEnable, DRS_MOVE|DRS_X},
                             {&hWndText,   DRS_SIZE|DRS_X|DRS_Y},
                             {&hWndShow,   DRS_MOVE|DRS_Y},
                             {&hWndOK,     DRS_MOVE|DRS_X|DRS_Y},
                             {&hWndCancel, DRS_MOVE|DRS_X|DRS_Y},
                             {0, 0}};

  if (uMsg == WM_INITDIALOG)
  {
    SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hMainIcon);
    hWndType=GetDlgItem(hDlg, IDC_MENUTYPE);
    hWndEnable=GetDlgItem(hDlg, IDC_MENUENABLE);
    hWndText=GetDlgItem(hDlg, IDC_MENUTEXT);
    hWndShow=GetDlgItem(hDlg, IDC_MENUSHOW);
    hWndOK=GetDlgItem(hDlg, IDOK);
    hWndCancel=GetDlgItem(hDlg, IDCANCEL);

    SetDlgItemTextW(hDlg, IDC_MENUENABLE, GetLangStringW(wLangSystem, STRID_ENABLE));
    SetDlgItemTextW(hDlg, IDC_MENUSHOW, GetLangStringW(wLangSystem, STRID_SHOW));
    SetDlgItemTextW(hDlg, IDOK, GetLangStringW(wLangSystem, STRID_OK));
    SetDlgItemTextW(hDlg, IDCANCEL, GetLangStringW(wLangSystem, STRID_CANCEL));

    SendMessage(hWndText, EM_SETTEXTMODE, TM_PLAINTEXT|TM_MULTILEVELUNDO|TM_MULTICODEPAGE, 0);
    SendMessage(hWndText, EM_EXLIMITTEXT, 0, MAX_MENUTEXT_SIZE);

    SendMessageW(hWndType, CB_ADDSTRING, 0, (LPARAM)GetLangStringW(wLangSystem, STRID_MANUAL));
    SendMessageW(hWndType, CB_ADDSTRING, 0, (LPARAM)GetLangStringW(wLangSystem, STRID_MENUMAIN));
    SendMessageW(hWndType, CB_ADDSTRING, 0, (LPARAM)GetLangStringW(wLangSystem, STRID_MENUEDIT));
    SendMessageW(hWndType, CB_ADDSTRING, 0, (LPARAM)GetLangStringW(wLangSystem, STRID_MENUTAB));
    SendMessageW(hWndType, CB_ADDSTRING, 0, (LPARAM)GetLangStringW(wLangSystem, STRID_MENUURL));
    SendMessageW(hWndType, CB_ADDSTRING, 0, (LPARAM)GetLangStringW(wLangSystem, STRID_MENURECENTFILES));

    bMenuMainEnableDlg=bMenuMainEnable;
    bMenuEditEnableDlg=bMenuEditEnable;
    bMenuTabEnableDlg=bMenuTabEnable;
    bMenuUrlEnableDlg=bMenuUrlEnable;
    bMenuRecentFilesEnableDlg=bMenuRecentFilesEnable;

    if (wszManualTextDlg=(wchar_t *)GlobalAlloc(GPTR, lstrlenW(wszManualText) * sizeof(wchar_t) + 2))
    {
      lstrcpyW(wszManualTextDlg, wszManualText);
    }
    if (wszMainTextDlg=(wchar_t *)GlobalAlloc(GPTR, lstrlenW(wszMainText) * sizeof(wchar_t) + 2))
    {
      lstrcpyW(wszMainTextDlg, wszMainText);
    }
    if (wszEditTextDlg=(wchar_t *)GlobalAlloc(GPTR, lstrlenW(wszEditText) * sizeof(wchar_t) + 2))
    {
      lstrcpyW(wszEditTextDlg, wszEditText);
    }
    if (wszTabTextDlg=(wchar_t *)GlobalAlloc(GPTR, lstrlenW(wszTabText) * sizeof(wchar_t) + 2))
    {
      lstrcpyW(wszTabTextDlg, wszTabText);
    }
    if (wszUrlTextDlg=(wchar_t *)GlobalAlloc(GPTR, lstrlenW(wszUrlText) * sizeof(wchar_t) + 2))
    {
      lstrcpyW(wszUrlTextDlg, wszUrlText);
    }
    if (wszRecentFilesTextDlg=(wchar_t *)GlobalAlloc(GPTR, lstrlenW(wszRecentFilesText) * sizeof(wchar_t) + 2))
    {
      lstrcpyW(wszRecentFilesTextDlg, wszRecentFilesText);
    }

    OldEditDlgProc=(WNDPROC)GetWindowLongW(hWndText, GWL_WNDPROC);
    SetWindowLongW(hWndText, GWL_WNDPROC, (LONG)NewEditDlgProcW);

    nMenuType=-1;
    if (nMenuIndex >= 0)
      SetFocus(hWndText);
    else
      nMenuIndex=0;
    SendMessage(hWndType, CB_SETCURSEL, nMenuIndex, 0);
    nMenuIndex=-1;
    PostMessage(hDlg, WM_COMMAND, MAKELONG(IDC_MENUTYPE, CBN_SELCHANGE), (LPARAM)hWndType);
  }
  else if (uMsg == WM_INITMENUPOPUP)
  {
    if (lpCurrentMenuStackW)
    {
      if ((HMENU)wParam == lpCurrentMenuStackW->hExplorerSubMenu)
      {
        InitMenuPopupW(lpCurrentMenuStackW, INIT_EXPLORER);
      }
      else if ((HMENU)wParam == lpCurrentMenuStackW->hRecentFilesSubMenu)
      {
        InitMenuPopupW(lpCurrentMenuStackW, INIT_RECENTFILES);
      }
      else if ((HMENU)wParam == lpCurrentMenuStackW->hLanguagesSubMenu)
      {
        InitMenuPopupW(lpCurrentMenuStackW, INIT_LANGUAGES);
      }
    }
  }
  else if (uMsg == WM_COMMAND)
  {
    if (LOWORD(wParam) == IDC_MENUTYPE && HIWORD(wParam) == CBN_SELCHANGE)
    {
      GETTEXTRANGE gtr;
      int nTextLen;
      wchar_t *wpText=NULL;
      int nItem;
      BOOL bEnable=FALSE;

      nItem=SendMessage(hWndType, CB_GETCURSEL, 0, 0);

      if (nItem != nMenuType)
      {
        if (nMenuType == 0) wpText=wszManualTextDlg;
        else if (nMenuType == 1) wpText=wszMainTextDlg;
        else if (nMenuType == 2) wpText=wszEditTextDlg;
        else if (nMenuType == 3) wpText=wszTabTextDlg;
        else if (nMenuType == 4) wpText=wszUrlTextDlg;
        else if (nMenuType == 5) wpText=wszRecentFilesTextDlg;

        if (wpText)
        {
          gtr.cpMin=0;
          gtr.cpMax=-1;

          if (SendMessage(hWndText, EM_GETMODIFY, 0, 0))
          {
            if (nTextLen=SendMessage(hMainWnd, AKD_GETTEXTRANGE, (WPARAM)hWndText, (LPARAM)&gtr))
            {
              if (wpText) GlobalFree((HGLOBAL)wpText);

              if (wpText=(wchar_t *)GlobalAlloc(GPTR, nTextLen * sizeof(wchar_t) + 2))
              {
                lstrcpyW(wpText, (wchar_t *)gtr.pText);

                if (nMenuType == 0) wszManualTextDlg=wpText;
                else if (nMenuType == 1) wszMainTextDlg=wpText;
                else if (nMenuType == 2) wszEditTextDlg=wpText;
                else if (nMenuType == 3) wszTabTextDlg=wpText;
                else if (nMenuType == 4) wszUrlTextDlg=wpText;
                else if (nMenuType == 5) wszRecentFilesTextDlg=wpText;
              }
              SendMessage(hMainWnd, AKD_FREETEXT, 0, (LPARAM)gtr.pText);
            }
          }
        }
        nMenuType=nItem;

        if (!nMenuType)
        {
          ShowWindow(hWndEnable, FALSE);
          EnableWindow(hWndText, TRUE);
          SetWindowTextW(hWndText, wszManualTextDlg);
        }
        else
        {
          if (nMenuType == 1)
          {
            bEnable=bMenuMainEnableDlg;
            SetWindowTextW(hWndText, wszMainTextDlg);
          }
          else if (nMenuType == 2)
          {
            bEnable=bMenuEditEnableDlg;
            SetWindowTextW(hWndText, wszEditTextDlg);
          }
          else if (nMenuType == 3)
          {
            bEnable=bMenuTabEnableDlg;
            SetWindowTextW(hWndText, wszTabTextDlg);
          }
          else if (nMenuType == 4)
          {
            bEnable=bMenuUrlEnableDlg;
            SetWindowTextW(hWndText, wszUrlTextDlg);
          }
          else if (nMenuType == 5)
          {
            bEnable=bMenuRecentFilesEnableDlg;
            SetWindowTextW(hWndText, wszRecentFilesTextDlg);
          }
          ShowWindow(hWndEnable, TRUE);
          SendMessage(hWndEnable, BM_SETCHECK, bEnable?BST_CHECKED:BST_UNCHECKED, 0);
          EnableWindow(hWndText, bEnable);
        }
      }

      if (*wszMenuSearch)
      {
        TEXTFINDW tf;

        tf.dwFlags=FR_DOWN|FR_BEGINNING|FR_MATCHCASE;
        tf.pFindIt=wszMenuSearch;
        SendMessage(hMainWnd, AKD_TEXTFIND, (WPARAM)hWndText, (LPARAM)&tf);
        wszMenuSearch[0]='\0';
      }
    }
    else if (LOWORD(wParam) == IDC_MENUENABLE)
    {
      BOOL bEnable;

      if (SendMessage(hWndEnable, BM_GETCHECK, 0, 0) == BST_CHECKED)
        bEnable=TRUE;
      else
        bEnable=FALSE;

      if (nMenuType == 1) bMenuMainEnableDlg=bEnable;
      else if (nMenuType == 2) bMenuEditEnableDlg=bEnable;
      else if (nMenuType == 3) bMenuTabEnableDlg=bEnable;
      else if (nMenuType == 4) bMenuUrlEnableDlg=bEnable;
      else if (nMenuType == 5) bMenuRecentFilesEnableDlg=bEnable;

      EnableWindow(hWndText, bEnable);
    }
    else if (LOWORD(wParam) == IDC_MENUSHOW)
    {
      GETTEXTRANGE gtr;

      gtr.cpMin=0;
      gtr.cpMax=-1;

      if (SendMessage(hMainWnd, AKD_GETTEXTRANGE, (WPARAM)hWndText, (LPARAM)&gtr))
      {
        EDITINFO ei;
        POINT pt;
        int nCmd;

        if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
        {
          if (hMenuDialogStackW.hPopupMenu) FreeContextMenuW(&hMenuDialogStackW);
          CreateContextMenuW(&hMenuDialogStackW, (wchar_t *)gtr.pText);
          lstrcpynW(wszCurrentFile, (wchar_t *)ei.pFile, MAX_PATH);

          GetCursorPos(&pt);
          if (nCmd=ShowContextMenuW(&hMenuDialogStackW, hDlg, TYPE_EDIT, pt.x, pt.y))
            CallContextMenuW(&hMenuDialogStackW, nCmd);
        }
        SendMessage(hMainWnd, AKD_FREETEXT, 0, (LPARAM)gtr.pText);
      }
    }
    else if (LOWORD(wParam) == IDOK)
    {
      GETTEXTRANGE gtr;
      int nTextLen;
      wchar_t *wpText=NULL;
      BOOL bEnable;

      if (SendMessage(hWndEnable, BM_GETCHECK, 0, 0) == BST_CHECKED)
        bEnable=TRUE;
      else
        bEnable=FALSE;

      if (nMenuType == 0)
      {
        wpText=wszManualTextDlg;
      }
      else if (nMenuType == 1)
      {
        bMenuMainEnableDlg=bEnable;
        wpText=wszMainTextDlg;
      }
      else if (nMenuType == 2)
      {
        bMenuEditEnableDlg=bEnable;
        wpText=wszEditTextDlg;
      }
      else if (nMenuType == 3)
      {
        bMenuTabEnableDlg=bEnable;
        wpText=wszTabTextDlg;
      }
      else if (nMenuType == 4)
      {
        bMenuUrlEnableDlg=bEnable;
        wpText=wszUrlTextDlg;
      }
      else if (nMenuType == 5)
      {
        bMenuRecentFilesEnableDlg=bEnable;
        wpText=wszRecentFilesTextDlg;
      }
      bMenuMainEnable=bMenuMainEnableDlg;
      bMenuEditEnable=bMenuEditEnableDlg;
      bMenuTabEnable=bMenuTabEnableDlg;
      bMenuUrlEnable=bMenuUrlEnableDlg;
      bMenuRecentFilesEnable=bMenuRecentFilesEnableDlg;

      gtr.cpMin=0;
      gtr.cpMax=-1;

      if (SendMessage(hWndText, EM_GETMODIFY, 0, 0))
      {
        if (nTextLen=SendMessage(hMainWnd, AKD_GETTEXTRANGE, (WPARAM)hWndText, (LPARAM)&gtr))
        {
          if (wpText) GlobalFree((HGLOBAL)wpText);

          if (wpText=(wchar_t *)GlobalAlloc(GPTR, nTextLen * sizeof(wchar_t) + 2))
          {
            lstrcpyW(wpText, (wchar_t *)gtr.pText);

            if (nMenuType == 0) wszManualTextDlg=wpText;
            else if (nMenuType == 1) wszMainTextDlg=wpText;
            else if (nMenuType == 2) wszEditTextDlg=wpText;
            else if (nMenuType == 3) wszTabTextDlg=wpText;
            else if (nMenuType == 4) wszUrlTextDlg=wpText;
            else if (nMenuType == 5) wszRecentFilesTextDlg=wpText;
          }
          SendMessage(hMainWnd, AKD_FREETEXT, 0, (LPARAM)gtr.pText);
        }
      }

      if (wszManualText) GlobalFree((HGLOBAL)wszManualText);
      if (wszMainText) GlobalFree((HGLOBAL)wszMainText);
      if (wszEditText) GlobalFree((HGLOBAL)wszEditText);
      if (wszTabText) GlobalFree((HGLOBAL)wszTabText);
      if (wszUrlText) GlobalFree((HGLOBAL)wszUrlText);
      if (wszRecentFilesText) GlobalFree((HGLOBAL)wszRecentFilesText);
      wszManualText=wszManualTextDlg;
      wszMainText=wszMainTextDlg;
      wszEditText=wszEditTextDlg;
      wszTabText=wszTabTextDlg;
      wszUrlText=wszUrlTextDlg;
      wszRecentFilesText=wszRecentFilesTextDlg;

      DeleteMainMenuW(&hMenuMainStackW);
      FreeContextMenuW(&hMenuManualStackW);
      FreeContextMenuW(&hMenuMainStackW);
      FreeContextMenuW(&hMenuEditStackW);
      FreeContextMenuW(&hMenuTabStackW);
      FreeContextMenuW(&hMenuUrlStackW);
      FreeContextMenuW(&hMenuRecentFilesStackW);
      SaveOptionsW(OF_MENUTEXT);

      if (bMenuMainEnable)
      {
        if (!hMenuMainStackW.hPopupMenu)
          CreateContextMenuW(&hMenuMainStackW, wszMainText);
        InsertMainMenuW(&hMenuMainStackW);
      }

      DestroyWindow(hWndMainDlg);
      hWndMainDlg=NULL;
      CloseHandle(hThread);
      hThread=NULL;
      ExitThread(0);
    }
    else if (LOWORD(wParam) == IDCANCEL)
    {
      if (wszManualTextDlg) GlobalFree((HGLOBAL)wszManualTextDlg);
      if (wszMainTextDlg) GlobalFree((HGLOBAL)wszMainTextDlg);
      if (wszEditTextDlg) GlobalFree((HGLOBAL)wszEditTextDlg);
      if (wszTabTextDlg) GlobalFree((HGLOBAL)wszTabTextDlg);
      if (wszUrlTextDlg) GlobalFree((HGLOBAL)wszUrlTextDlg);
      if (wszRecentFilesTextDlg) GlobalFree((HGLOBAL)wszRecentFilesTextDlg);

      DestroyWindow(hWndMainDlg);
      hWndMainDlg=NULL;
      CloseHandle(hThread);
      hThread=NULL;
      ExitThread(0);
    }
  }
  else if (uMsg == WM_CLOSE)
  {
    PostMessage(hDlg, WM_COMMAND, IDCANCEL, 0);
    return TRUE;
  }

  //Explorer menu
  if (lpCurrentMenuStackW)
  {
    if (lpCurrentMenuStackW->pExplorerSubMenu3)
    {
      LRESULT lResult;

      if (SUCCEEDED(lpCurrentMenuStackW->pExplorerSubMenu3->HandleMenuMsg2(uMsg, wParam, lParam, &lResult)))
        return lResult;
    }
    else if (lpCurrentMenuStackW->pExplorerSubMenu2)
    {
      if (SUCCEEDED(lpCurrentMenuStackW->pExplorerSubMenu2->HandleMenuMsg(uMsg, wParam, lParam)))
        return 0;
    }
  }

  if (DialogResizeMessages(&drs[0], &rcMainInitDialog, &rcMainCurrentDialog, hDlg, uMsg, wParam, lParam))
    bMainDialogRectSave=TRUE;

  return FALSE;
}

LRESULT CALLBACK NewEditDlgProcA(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  LRESULT lResult;

  if (uMsg == WM_GETDLGCODE)
  {
    lResult=CallWindowProcA(OldEditDlgProc, hWnd, uMsg, wParam, lParam);

    if (lResult & DLGC_HASSETSEL)
    {
      lResult&=~DLGC_HASSETSEL;
    }
    return lResult;
  }
  else if (uMsg == WM_CONTEXTMENU)
  {
    ShowStandartEditMenu((HWND)wParam, hPopupEdit, !(lParam == -1));
  }
  return CallWindowProcA(OldEditDlgProc, hWnd, uMsg, wParam, lParam);
}

LRESULT CALLBACK NewEditDlgProcW(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  LRESULT lResult;

  if (uMsg == WM_GETDLGCODE)
  {
    lResult=CallWindowProcW(OldEditDlgProc, hWnd, uMsg, wParam, lParam);

    if (lResult & DLGC_HASSETSEL)
    {
      lResult&=~DLGC_HASSETSEL;
    }
    return lResult;
  }
  else if (uMsg == WM_CONTEXTMENU)
  {
    ShowStandartEditMenu((HWND)wParam, hPopupEdit, !(lParam == -1));
  }
  return CallWindowProcW(OldEditDlgProc, hWnd, uMsg, wParam, lParam);
}

void CreateContextMenuA(POPUPMENUA *hMenuStackA, char *pText)
{
  char szMenuItem[MAX_PATH];
  char szActionName[MAX_PATH];
  HSTACK hSubMenuStack={0};
  SUBMENUS *lpSubMenuElement=NULL;
  MENUITEM *lpMenuItemElement=NULL;
  INDEXES *lpIndexElement=NULL;
  HMENU hMenu=NULL;
  HMENU hSubMenu;
  HMENU hParentMenu=NULL;
  DWORD dwAction;
  BOOL bNewLineReached;
  int nPlus;
  int nMinus;
  int nSubMenuIndex=0;
  int nParentMenuIndex=0;
  int nItem=IDM_MIN_MENU;
  int nCommand=0;
  int i;

  hMenuStackA->bClearMainMenu=FALSE;

  if (pText)
  {
    hMenu=hSubMenu=CreatePopupMenu();

    while (*pText)
    {
      SkipCommentA(&pText);
      NextStringA(pText, szMenuItem, MAX_PATH, &pText, &nMinus);

      SubMenu:
      for (bNewLineReached=FALSE; *pText == ' ' || *pText == '\t' || *pText == '\r' || *pText == '\n'; ++pText)
      {
        if (*pText == '\r' || *pText == '\n')
          bNewLineReached=TRUE;
      }

      if (*pText == '{')
      {
        ++pText;

        if (!StackInsertIndex((stack **)&hSubMenuStack.first, (stack **)&hSubMenuStack.last, (stack **)&lpSubMenuElement, -1, sizeof(SUBMENUS)))
        {
          lpSubMenuElement->hSubMenu=hSubMenu;
          lpSubMenuElement->nSubMenuIndex=nSubMenuIndex;
        }
        else break;

        hParentMenu=hSubMenu;
        nParentMenuIndex=nSubMenuIndex;
        hSubMenu=CreatePopupMenu();
        AppendMenuA(hParentMenu, MF_POPUP, (UINT)hSubMenu, szMenuItem);
        nSubMenuIndex=0;
      }
      else
      {
        if (!lstrcmpA(szMenuItem, "SEPARATOR"))
        {
          if (hSubMenu)
          {
            AppendMenuA(hSubMenu, MF_SEPARATOR, 0, NULL);
            ++nSubMenuIndex;
          }
        }
        else if (!lstrcmpA(szMenuItem, "EXPLORER"))
        {
          if (hSubMenu)
          {
            hMenuStackA->hExplorerSubMenu=hSubMenu;
            hMenuStackA->nExplorerFirstIndex=nSubMenuIndex;
            hMenuStackA->nExplorerLastIndex=-1;
          }
        }
        else if (!lstrcmpA(szMenuItem, "RECENTFILES"))
        {
          if (hSubMenu)
          {
            hMenuStackA->hRecentFilesSubMenu=hSubMenu;
            hMenuStackA->nRecentFilesFirstIndex=nSubMenuIndex;
            hMenuStackA->nRecentFilesLastIndex=-1;
          }
        }
        else if (!lstrcmpA(szMenuItem, "LANGUAGES"))
        {
          if (hSubMenu)
          {
            hMenuStackA->hLanguagesSubMenu=hSubMenu;
            hMenuStackA->nLanguagesFirstIndex=nSubMenuIndex;
            hMenuStackA->nLanguagesLastIndex=-1;
          }
        }
        else if (!lstrcmpA(szMenuItem, "MDIDOCUMENTS"))
        {
          if (hSubMenu)
          {
            hMenuStackA->hMdiDocumentsSubMenu=hSubMenu;
          }
        }
        else if (!lstrcmpA(szMenuItem, "CLEAR"))
        {
          hMenuStackA->bClearMainMenu=TRUE;
        }
        else
        {
          if (!bNewLineReached)
          {
            if (*pText == '+')
            {
              ++pText;
              nPlus=1;
            }
            else nPlus=0;

            dwAction=0;
            GetActionNameA(pText, szActionName, MAX_PATH, &pText);

            if (!lstrcmpiA(szActionName, "Index"))
            {
              if (!StackInsertIndex((stack **)&hMenuStackA->hMainMenuIndexStack.first, (stack **)&hMenuStackA->hMainMenuIndexStack.last, (stack **)&lpIndexElement, -1, sizeof(INDEXES)))
              {
                lpIndexElement->nMainMenuIndex=xatoiA(pText);
              }
              //Next line
              while (*pText != '\r' && *pText != '\0') ++pText;
              goto SubMenu;
            }
            if (!lstrcmpiA(szActionName, "Command"))
              dwAction=ACT_COMMAND;
            else if (!lstrcmpiA(szActionName, "Call"))
              dwAction=ACT_CALL;
            else if (!lstrcmpiA(szActionName, "Exec"))
              dwAction=ACT_EXEC;
            else if (!lstrcmpiA(szActionName, "Font"))
              dwAction=ACT_FONT;
            else if (!lstrcmpiA(szActionName, "Recode"))
              dwAction=ACT_RECODE;
            else if (!lstrcmpiA(szActionName, "Insert"))
              dwAction=ACT_INSERT;
            else if (!lstrcmpiA(szActionName, "Link"))
              dwAction=ACT_LINK;

            if (dwAction)
            {
              if (!StackInsertIndex((stack **)&hMenuStackA->hActionStack.first, (stack **)&hMenuStackA->hActionStack.last, (stack **)&lpMenuItemElement, -1, sizeof(MENUITEM)))
              {
                lpMenuItemElement->nItem=nItem;
                lpMenuItemElement->bUpdateItem=!nMinus;
                lpMenuItemElement->bSetOnStart=nPlus;
                lpMenuItemElement->dwAction=dwAction;
                GetActionParametersA(&lpMenuItemElement->hParamStack, pText, &pText);

                if (dwAction == ACT_COMMAND)
                {
                  nCommand=GetParameterInt(&lpMenuItemElement->hParamStack, 1);

                  if (!*szMenuItem)
                  {
                    if (GetMenuStringA(hMainMenu, nCommand, szMenuItem, MAX_PATH, MF_BYCOMMAND))
                    {
                      for (i=0; szMenuItem[i]; ++i)
                      {
                        if (szMenuItem[i] == '\t')
                        {
                          szMenuItem[i]='\0';
                          break;
                        }
                      }
                    }
                  }
                }

                if (hSubMenu)
                {
                  AppendMenuA(hSubMenu, MF_STRING, nItem, szMenuItem);
                  ++nItem;
                  ++nSubMenuIndex;
                }
              }
              else break;
            }
          }
        }
      }

      while (1)
      {
        SkipCommentA(&pText);

        if (*pText == '}')
        {
          ++pText;

          if (hSubMenuStack.last)
          {
            hSubMenu=((SUBMENUS *)hSubMenuStack.last)->hSubMenu;
            nSubMenuIndex=((SUBMENUS *)hSubMenuStack.last)->nSubMenuIndex;
            StackDelete((stack **)&hSubMenuStack.first, (stack **)&hSubMenuStack.last, (stack *)hSubMenuStack.last);

            if (hSubMenuStack.last)
            {
              hParentMenu=((SUBMENUS *)hSubMenuStack.last)->hSubMenu;
              nParentMenuIndex=((SUBMENUS *)hSubMenuStack.last)->nSubMenuIndex;
            }
            else hParentMenu=NULL;

            ++nSubMenuIndex;
          }
        }
        else break;
      }
    }
    StackClear((stack **)&hSubMenuStack.first, (stack **)&hSubMenuStack.last);
  }
  hMenuStackA->hPopupMenu=hMenu;
}

void CreateContextMenuW(POPUPMENUW *hMenuStackW, wchar_t *wpText)
{
  wchar_t wszMenuItem[MAX_PATH];
  wchar_t wszActionName[MAX_PATH];
  HSTACK hSubMenuStack={0};
  SUBMENUS *lpSubMenuElement=NULL;
  MENUITEM *lpMenuItemElement=NULL;
  INDEXES *lpIndexElement=NULL;
  HMENU hMenu=NULL;
  HMENU hSubMenu;
  HMENU hParentMenu=NULL;
  DWORD dwAction;
  BOOL bNewLineReached;
  int nPlus;
  int nMinus;
  int nSubMenuIndex=0;
  int nParentMenuIndex=0;
  int nItem=IDM_MIN_MENU;
  int nCommand=0;
  int i;

  hMenuStackW->bClearMainMenu=FALSE;

  if (wpText)
  {
    hMenu=hSubMenu=CreatePopupMenu();

    while (*wpText)
    {
      SkipCommentW(&wpText);
      NextStringW(wpText, wszMenuItem, MAX_PATH, &wpText, &nMinus);

      SubMenu:
      for (bNewLineReached=FALSE; *wpText == ' ' || *wpText == '\t' || *wpText == '\r'; ++wpText)
      {
        if (*wpText == '\r')
          bNewLineReached=TRUE;
      }

      if (*wpText == '{')
      {
        ++wpText;

        if (!StackInsertIndex((stack **)&hSubMenuStack.first, (stack **)&hSubMenuStack.last, (stack **)&lpSubMenuElement, -1, sizeof(SUBMENUS)))
        {
          lpSubMenuElement->hSubMenu=hSubMenu;
          lpSubMenuElement->nSubMenuIndex=nSubMenuIndex;
        }
        else break;

        hParentMenu=hSubMenu;
        nParentMenuIndex=nSubMenuIndex;
        hSubMenu=CreatePopupMenu();
        AppendMenuW(hParentMenu, MF_POPUP, (UINT)hSubMenu, wszMenuItem);
        nSubMenuIndex=0;
      }
      else
      {
        if (!lstrcmpW(wszMenuItem, L"SEPARATOR"))
        {
          if (hSubMenu)
          {
            AppendMenuW(hSubMenu, MF_SEPARATOR, 0, NULL);
            ++nSubMenuIndex;
          }
        }
        else if (!lstrcmpW(wszMenuItem, L"EXPLORER"))
        {
          if (hSubMenu)
          {
            hMenuStackW->hExplorerSubMenu=hSubMenu;
            hMenuStackW->nExplorerFirstIndex=nSubMenuIndex;
            hMenuStackW->nExplorerLastIndex=-1;
          }
        }
        else if (!lstrcmpW(wszMenuItem, L"RECENTFILES"))
        {
          if (hSubMenu)
          {
            hMenuStackW->hRecentFilesSubMenu=hSubMenu;
            hMenuStackW->nRecentFilesFirstIndex=nSubMenuIndex;
            hMenuStackW->nRecentFilesLastIndex=-1;
          }
        }
        else if (!lstrcmpW(wszMenuItem, L"LANGUAGES"))
        {
          if (hSubMenu)
          {
            hMenuStackW->hLanguagesSubMenu=hSubMenu;
            hMenuStackW->nLanguagesFirstIndex=nSubMenuIndex;
            hMenuStackW->nLanguagesLastIndex=-1;
          }
        }
        else if (!lstrcmpW(wszMenuItem, L"MDIDOCUMENTS"))
        {
          if (hSubMenu)
          {
            hMenuStackW->hMdiDocumentsSubMenu=hSubMenu;
          }
        }
        else if (!lstrcmpW(wszMenuItem, L"CLEAR"))
        {
          hMenuStackW->bClearMainMenu=TRUE;
        }
        else
        {
          if (!bNewLineReached)
          {
            if (*wpText == '+')
            {
              ++wpText;
              nPlus=1;
            }
            else nPlus=0;

            dwAction=0;
            GetActionNameW(wpText, wszActionName, MAX_PATH, &wpText);

            if (!lstrcmpiW(wszActionName, L"Index"))
            {
              if (!StackInsertIndex((stack **)&hMenuStackW->hMainMenuIndexStack.first, (stack **)&hMenuStackW->hMainMenuIndexStack.last, (stack **)&lpIndexElement, -1, sizeof(INDEXES)))
              {
                lpIndexElement->nMainMenuIndex=xatoiW(wpText);
              }
              //Next line
              while (*wpText != '\r' && *wpText != '\0') ++wpText;
              goto SubMenu;
            }
            if (!lstrcmpiW(wszActionName, L"Command"))
              dwAction=ACT_COMMAND;
            else if (!lstrcmpiW(wszActionName, L"Call"))
              dwAction=ACT_CALL;
            else if (!lstrcmpiW(wszActionName, L"Exec"))
              dwAction=ACT_EXEC;
            else if (!lstrcmpiW(wszActionName, L"Font"))
              dwAction=ACT_FONT;
            else if (!lstrcmpiW(wszActionName, L"Recode"))
              dwAction=ACT_RECODE;
            else if (!lstrcmpiW(wszActionName, L"Insert"))
              dwAction=ACT_INSERT;
            else if (!lstrcmpiW(wszActionName, L"Link"))
              dwAction=ACT_LINK;

            if (dwAction)
            {
              if (!StackInsertIndex((stack **)&hMenuStackW->hActionStack.first, (stack **)&hMenuStackW->hActionStack.last, (stack **)&lpMenuItemElement, -1, sizeof(MENUITEM)))
              {
                lpMenuItemElement->nItem=nItem;
                lpMenuItemElement->bUpdateItem=!nMinus;
                lpMenuItemElement->bSetOnStart=nPlus;
                lpMenuItemElement->dwAction=dwAction;
                GetActionParametersW(&lpMenuItemElement->hParamStack, wpText, &wpText);

                if (dwAction == ACT_COMMAND)
                {
                  nCommand=GetParameterInt(&lpMenuItemElement->hParamStack, 1);

                  if (!*wszMenuItem)
                  {
                    if (GetMenuStringW(hMainMenu, nCommand, wszMenuItem, MAX_PATH, MF_BYCOMMAND))
                    {
                      for (i=0; wszMenuItem[i]; ++i)
                      {
                        if (wszMenuItem[i] == '\t')
                        {
                          wszMenuItem[i]='\0';
                          break;
                        }
                      }
                    }
                  }
                }

                if (hSubMenu)
                {
                  AppendMenuW(hSubMenu, MF_STRING, nItem, wszMenuItem);
                  ++nItem;
                  ++nSubMenuIndex;
                }
              }
              else break;
            }
          }
        }
      }

      while (1)
      {
        SkipCommentW(&wpText);

        if (*wpText == '}')
        {
          ++wpText;

          if (hSubMenuStack.last)
          {
            hSubMenu=((SUBMENUS *)hSubMenuStack.last)->hSubMenu;
            nSubMenuIndex=((SUBMENUS *)hSubMenuStack.last)->nSubMenuIndex;
            StackDelete((stack **)&hSubMenuStack.first, (stack **)&hSubMenuStack.last, (stack *)hSubMenuStack.last);

            if (hSubMenuStack.last)
            {
              hParentMenu=((SUBMENUS *)hSubMenuStack.last)->hSubMenu;
              nParentMenuIndex=((SUBMENUS *)hSubMenuStack.last)->nSubMenuIndex;
            }
            else hParentMenu=NULL;

            ++nSubMenuIndex;
          }
        }
        else break;
      }
    }
    StackClear((stack **)&hSubMenuStack.first, (stack **)&hSubMenuStack.last);
  }
  hMenuStackW->hPopupMenu=hMenu;
}

void UpdateContextMenuA(POPUPMENUA *hMenuStackA, int nType)
{
  MENUITEM *lpElement=(MENUITEM *)hMenuStackA->hActionStack.first;
  BOOL bInitMenu=FALSE;

  while (lpElement)
  {
    if (lpElement->bUpdateItem)
    {
      if (lpElement->dwAction == ACT_COMMAND)
      {
        DWORD dwMenuState;
        int nCommand=0;

        if (!bInitMenu)
        {
          SendMessage(hMainWnd, WM_INITMENU, (WPARAM)hMainMenu, IMENU_EDIT|IMENU_CHECKS);
          bInitMenu=TRUE;
        }
        nCommand=GetParameterInt(&lpElement->hParamStack, 1);

        if (nCommand)
        {
          dwMenuState=GetMenuState(hMainMenu, nCommand, MF_BYCOMMAND);
          CheckMenuItem(hMenuStackA->hPopupMenu, lpElement->nItem, MF_BYCOMMAND|dwMenuState);
          EnableMenuItem(hMenuStackA->hPopupMenu, lpElement->nItem, MF_BYCOMMAND|dwMenuState);
        }
      }
      else if (lpElement->dwAction == ACT_CALL)
      {
        PLUGINFUNCTIONA *pf;
        char *pFunction=NULL;
        DWORD dwFlags;

        pFunction=(char *)GetParameterChar(&lpElement->hParamStack, 1);

        if (pFunction)
        {
          dwFlags=MF_UNCHECKED;
          if (pf=(PLUGINFUNCTIONA *)SendMessage(hMainWnd, AKD_DLLFIND, (WPARAM)pFunction, 0))
            if (pf->bRunning) dwFlags=MF_CHECKED;
          CheckMenuItem(hMenuStackA->hPopupMenu, lpElement->nItem, dwFlags);
        }
      }
      else if (lpElement->dwAction == ACT_LINK)
      {
        if (nType == TYPE_URL)
          EnableMenuItem(hMenuStackA->hPopupMenu, lpElement->nItem, MF_BYCOMMAND|MF_ENABLED);
        else
          EnableMenuItem(hMenuStackA->hPopupMenu, lpElement->nItem, MF_BYCOMMAND|MF_GRAYED);
      }
    }
    lpElement=lpElement->next;
  }
}

void UpdateContextMenuW(POPUPMENUW *hMenuStackW, int nType)
{
  MENUITEM *lpElement=(MENUITEM *)hMenuStackW->hActionStack.first;
  BOOL bInitMenu=FALSE;

  while (lpElement)
  {
    if (lpElement->bUpdateItem)
    {
      if (lpElement->dwAction == ACT_COMMAND)
      {
        DWORD dwMenuState;
        int nCommand=0;

        if (!bInitMenu)
        {
          SendMessage(hMainWnd, WM_INITMENU, (WPARAM)hMainMenu, IMENU_EDIT|IMENU_CHECKS);
          bInitMenu=TRUE;
        }
        nCommand=GetParameterInt(&lpElement->hParamStack, 1);

        if (nCommand)
        {
          dwMenuState=GetMenuState(hMainMenu, nCommand, MF_BYCOMMAND);
          CheckMenuItem(hMenuStackW->hPopupMenu, lpElement->nItem, MF_BYCOMMAND|dwMenuState);
          EnableMenuItem(hMenuStackW->hPopupMenu, lpElement->nItem, MF_BYCOMMAND|dwMenuState);
        }
      }
      else if (lpElement->dwAction == ACT_CALL)
      {
        PLUGINFUNCTIONW *pf;
        wchar_t *wpFunction=NULL;
        DWORD dwFlags;

        wpFunction=(wchar_t *)GetParameterChar(&lpElement->hParamStack, 1);

        if (wpFunction)
        {
          dwFlags=MF_UNCHECKED;
          if (pf=(PLUGINFUNCTIONW *)SendMessage(hMainWnd, AKD_DLLFIND, (WPARAM)wpFunction, 0))
            if (pf->bRunning) dwFlags=MF_CHECKED;
          CheckMenuItem(hMenuStackW->hPopupMenu, lpElement->nItem, dwFlags);
        }
      }
      else if (lpElement->dwAction == ACT_LINK)
      {
        if (nType == TYPE_URL)
          EnableMenuItem(hMenuStackW->hPopupMenu, lpElement->nItem, MF_BYCOMMAND|MF_ENABLED);
        else
          EnableMenuItem(hMenuStackW->hPopupMenu, lpElement->nItem, MF_BYCOMMAND|MF_GRAYED);
      }
    }
    lpElement=lpElement->next;
  }
}

int ShowContextMenuA(POPUPMENUA *hMenuStackA, HWND hWnd, int nType, int x, int y)
{
  int nCmd;

  UpdateContextMenuA(hMenuStackA, nType);

  lpCurrentMenuStackA=hMenuStackA;
  if (nType == TYPE_RECENTFILES)
    nCmd=TrackPopupMenu(hMenuStackA->hPopupMenu, TPM_RETURNCMD|TPM_LEFTBUTTON|TPM_RIGHTBUTTON|TPM_RECURSE, x, y, 0, hWnd, NULL);
  else
    nCmd=TrackPopupMenu(hMenuStackA->hPopupMenu, TPM_RETURNCMD|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, x, y, 0, hWnd, NULL);
  lpCurrentMenuStackA=NULL;

  return nCmd;
}

int ShowContextMenuW(POPUPMENUW *hMenuStackW, HWND hWnd, int nType, int x, int y)
{
  int nCmd;

  UpdateContextMenuW(hMenuStackW, nType);

  lpCurrentMenuStackW=hMenuStackW;
  if (nType == TYPE_RECENTFILES)
    nCmd=TrackPopupMenu(hMenuStackW->hPopupMenu, TPM_RETURNCMD|TPM_LEFTBUTTON|TPM_RIGHTBUTTON|TPM_RECURSE, x, y, 0, hWnd, NULL);
  else
    nCmd=TrackPopupMenu(hMenuStackW->hPopupMenu, TPM_RETURNCMD|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, x, y, 0, hWnd, NULL);
  lpCurrentMenuStackW=NULL;

  return nCmd;
}

void InitMenuPopupA(POPUPMENUA *hMenuStackA, int nMenuType)
{
  MENUITEM *lpElement;
  char szItem[MAX_PATH];
  wchar_t wszFile[MAX_PATH];
  DWORD dwState;
  int nItemID;
  int nCountBefore;
  int nCountAfter;
  int i;

  if (nMenuType == INIT_EXPLORER)
  {
    if (lstrcmpiA(hMenuStackA->szExplorerFile, szCurrentFile))
    {
      lstrcpynA(hMenuStackA->szExplorerFile, szCurrentFile, MAX_PATH);
      MultiByteToWideChar(CP_ACP, 0, hMenuStackA->szExplorerFile, -1, wszFile, MAX_PATH);
      GetExplorerMenu(&hMenuStackA->pExplorerMenu, &hMenuStackA->pExplorerSubMenu2, &hMenuStackA->pExplorerSubMenu3, hMainWnd, wszFile);

      //Clear explorer menu
      for (i=hMenuStackA->nExplorerLastIndex; i >= hMenuStackA->nExplorerFirstIndex; --i)
      {
        DeleteMenu(hMenuStackA->hExplorerSubMenu, i, MF_BYPOSITION);
      }
      hMenuStackA->nExplorerLastIndex=-1;

      if (hMenuStackA->pExplorerMenu)
      {
        nCountBefore=GetMenuItemCount(hMenuStackA->hExplorerSubMenu);
        hMenuStackA->pExplorerMenu->QueryContextMenu(hMenuStackA->hExplorerSubMenu, hMenuStackA->nExplorerFirstIndex, IDM_MIN_EXPLORER, IDM_MAX_EXPLORER, 0);
        nCountAfter=GetMenuItemCount(hMenuStackA->hExplorerSubMenu);
        hMenuStackA->nExplorerLastIndex=hMenuStackA->nExplorerFirstIndex + (nCountAfter - nCountBefore) - 1;
      }
    }
  }
  else if (nMenuType == INIT_RECENTFILES)
  {
    //Clear recent files menu
    for (i=hMenuStackA->nRecentFilesLastIndex; i >= hMenuStackA->nRecentFilesFirstIndex; --i)
    {
      DeleteMenu(hMenuStackA->hRecentFilesSubMenu, i, MF_BYPOSITION);
    }
    hMenuStackA->nRecentFilesLastIndex=-1;

    //Force update AkelPad's recent files list
    SendMessage(hMainWnd, WM_INITMENUPOPUP, (WPARAM)hMenuRecentFiles, 0);

    //Fill menu
    for (i=0; GetMenuStringA(hMenuRecentFiles, i, szItem, MAX_PATH, MF_BYPOSITION); ++i)
    {
      nItemID=GetMenuItemID(hMenuRecentFiles, i);
      InsertMenuA(hMenuStackA->hRecentFilesSubMenu, hMenuStackA->nRecentFilesFirstIndex + i, MF_BYPOSITION, nItemID, szItem);
    }
    hMenuStackA->nRecentFilesLastIndex=hMenuStackA->nRecentFilesFirstIndex + i - 1;
  }
  else if (nMenuType == INIT_LANGUAGES)
  {
    //Clear languages menu
    for (i=hMenuStackA->nLanguagesLastIndex; i >= hMenuStackA->nLanguagesFirstIndex; --i)
    {
      DeleteMenu(hMenuStackA->hLanguagesSubMenu, i, MF_BYPOSITION);
    }
    hMenuStackA->nLanguagesLastIndex=-1;

    //Force update AkelPad's language list
    SendMessage(hMainWnd, WM_INITMENUPOPUP, (WPARAM)hMenuLanguage, 0);

    //Fill menu
    for (i=0; GetMenuStringA(hMenuLanguage, i, szItem, MAX_PATH, MF_BYPOSITION); ++i)
    {
      if ((dwState=GetMenuState(hMenuLanguage, i, MF_BYPOSITION)) != (DWORD)-1)
      {
        nItemID=GetMenuItemID(hMenuLanguage, i);
        InsertMenuA(hMenuStackA->hLanguagesSubMenu, hMenuStackA->nLanguagesFirstIndex + i, MF_BYPOSITION|dwState, nItemID, szItem);
      }
      else break;
    }

    //Check internal language item
    if ((dwState=GetMenuState(hMenuLanguage, IDM_LANGUAGE, MF_BYCOMMAND)) != (DWORD)-1)
    {
      if (dwState & MF_CHECKED)
      {
        if (lpElement=GetCommandItemA(hMenuStackA, IDM_LANGUAGE))
          CheckMenuItem(hMenuStackA->hLanguagesSubMenu, lpElement->nItem, MF_BYCOMMAND|dwState);
      }
    }
    hMenuStackA->nLanguagesLastIndex=hMenuStackA->nLanguagesFirstIndex + i - 1;
  }
}

void InitMenuPopupW(POPUPMENUW *hMenuStackW, int nMenuType)
{
  MENUITEM *lpElement;
  wchar_t wszItem[MAX_PATH];
  DWORD dwState;
  int nItemID;
  int nCountBefore;
  int nCountAfter;
  int i;

  if (nMenuType == INIT_EXPLORER)
  {
    if (lstrcmpiW(hMenuStackW->wszExplorerFile, wszCurrentFile))
    {
      lstrcpynW(hMenuStackW->wszExplorerFile, wszCurrentFile, MAX_PATH);
      GetExplorerMenu(&hMenuStackW->pExplorerMenu, &hMenuStackW->pExplorerSubMenu2, &hMenuStackW->pExplorerSubMenu3, hMainWnd, hMenuStackW->wszExplorerFile);

      //Clear explorer menu
      for (i=hMenuStackW->nExplorerLastIndex; i >= hMenuStackW->nExplorerFirstIndex; --i)
      {
        DeleteMenu(hMenuStackW->hExplorerSubMenu, i, MF_BYPOSITION);
      }
      hMenuStackW->nExplorerLastIndex=-1;

      if (hMenuStackW->pExplorerMenu)
      {
        nCountBefore=GetMenuItemCount(hMenuStackW->hExplorerSubMenu);
        hMenuStackW->pExplorerMenu->QueryContextMenu(hMenuStackW->hExplorerSubMenu, hMenuStackW->nExplorerFirstIndex, IDM_MIN_EXPLORER, IDM_MAX_EXPLORER, 0);
        nCountAfter=GetMenuItemCount(hMenuStackW->hExplorerSubMenu);
        hMenuStackW->nExplorerLastIndex=hMenuStackW->nExplorerFirstIndex + (nCountAfter - nCountBefore) - 1;
      }
    }
  }
  else if (nMenuType == INIT_RECENTFILES)
  {
    //Clear recent files menu
    for (i=hMenuStackW->nRecentFilesLastIndex; i >= hMenuStackW->nRecentFilesFirstIndex; --i)
    {
      DeleteMenu(hMenuStackW->hRecentFilesSubMenu, i, MF_BYPOSITION);
    }
    hMenuStackW->nRecentFilesLastIndex=-1;

    //Force update AkelPad's recent files list
    SendMessage(hMainWnd, WM_INITMENUPOPUP, (WPARAM)hMenuRecentFiles, 0);

    //Fill menu
    for (i=0; GetMenuStringW(hMenuRecentFiles, i, wszItem, MAX_PATH, MF_BYPOSITION); ++i)
    {
      nItemID=GetMenuItemID(hMenuRecentFiles, i);
      InsertMenuW(hMenuStackW->hRecentFilesSubMenu, hMenuStackW->nRecentFilesFirstIndex + i, MF_BYPOSITION, nItemID, wszItem);
    }
    hMenuStackW->nRecentFilesLastIndex=hMenuStackW->nRecentFilesFirstIndex + i - 1;
  }
  else if (nMenuType == INIT_LANGUAGES)
  {
    //Clear languages menu
    for (i=hMenuStackW->nLanguagesLastIndex; i >= hMenuStackW->nLanguagesFirstIndex; --i)
    {
      DeleteMenu(hMenuStackW->hLanguagesSubMenu, i, MF_BYPOSITION);
    }
    hMenuStackW->nLanguagesLastIndex=-1;

    //Force update AkelPad's language list
    SendMessage(hMainWnd, WM_INITMENUPOPUP, (WPARAM)hMenuLanguage, 0);

    //Fill menu
    for (i=0; GetMenuStringW(hMenuLanguage, i, wszItem, MAX_PATH, MF_BYPOSITION); ++i)
    {
      if ((dwState=GetMenuState(hMenuLanguage, i, MF_BYPOSITION)) != (DWORD)-1)
      {
        nItemID=GetMenuItemID(hMenuLanguage, i);
        InsertMenuW(hMenuStackW->hLanguagesSubMenu, hMenuStackW->nLanguagesFirstIndex + i, MF_BYPOSITION|dwState, nItemID, wszItem);
      }
      else break;
    }

    //Check internal language item
    if ((dwState=GetMenuState(hMenuLanguage, IDM_LANGUAGE, MF_BYCOMMAND)) != (DWORD)-1)
    {
      if (dwState & MF_CHECKED)
      {
        if (lpElement=GetCommandItemW(hMenuStackW, IDM_LANGUAGE))
          CheckMenuItem(hMenuStackW->hLanguagesSubMenu, lpElement->nItem, MF_BYCOMMAND|dwState);
      }
    }
    hMenuStackW->nLanguagesLastIndex=hMenuStackW->nLanguagesFirstIndex + i - 1;
  }
}

void InsertMainMenuA(POPUPMENUA *hMenuStackA)
{
  INDEXES *lpIndexElement=(INDEXES *)hMenuStackA->hMainMenuIndexStack.first;
  char szMenuItem[MAX_PATH];
  HMENU hMenu=hMainMenu;
  int nMainMenuIndex;
  int nMainMenuCount;
  int nSubMenuIndex=0;
  int nState;

  if (hMenuStackA->bClearMainMenu)
  {
    hMenu=CreateMenu();
  }

  while (lpIndexElement)
  {
    NextItem:
    if ((nState=GetMenuState(hMenuStackA->hPopupMenu, nSubMenuIndex, MF_BYPOSITION)) != -1)
    {
      if (!(LOBYTE(nState) & MF_POPUP))
      {
        ++nSubMenuIndex;
        goto NextItem;
      }
    }
    else break;

    if (lpIndexElement->hSubMenu=GetSubMenu(hMenuStackA->hPopupMenu, nSubMenuIndex))
    {
      if (GetMenuStringA(hMenuStackA->hPopupMenu, nSubMenuIndex, szMenuItem, MAX_PATH, MF_BYPOSITION))
      {
        nMainMenuIndex=lpIndexElement->nMainMenuIndex;

        if (nMainMenuIndex < 0)
        {
          nMainMenuCount=GetSubMenuCount(hMenu);

          if (nMainMenuCount + nMainMenuIndex >= 0)
            nMainMenuIndex=nMainMenuCount + nMainMenuIndex + 1;
          else
            nMainMenuIndex=0;
        }
        else
        {
          if ((nState=GetMenuState(hMenu, 0, MF_BYPOSITION)) != -1)
          {
            if (LOBYTE(nState) & MF_BITMAP)
              ++nMainMenuIndex;
          }
        }
        InsertMenuA(hMenu, nMainMenuIndex, MF_BYPOSITION|MF_POPUP, (UINT)lpIndexElement->hSubMenu, szMenuItem);
      }
    }
    ++nSubMenuIndex;
    lpIndexElement=lpIndexElement->next;
  }

  if (hMenuStackA->bClearMainMenu)
  {
    if (!bMDI)
      SetMenu(hMainWnd, hMenu);
    else
      SendMessage(hMdiClient, WM_MDISETMENU, (WPARAM)hMenu, (LPARAM)hMenuStackA->hMdiDocumentsSubMenu);

    if (hMenuStackA->hMainMenu)
    {
      DestroyMenu(hMenuStackA->hMainMenu);
      hMenuStackA->hMainMenu=NULL;
    }
    hMenuStackA->hMainMenu=hMenu;
  }
  else
  {
    if (hMenuStackA->hMainMenu)
    {
      if (!bMDI)
        SetMenu(hMainWnd, hMainMenu);
      else
        SendMessage(hMdiClient, WM_MDISETMENU, (WPARAM)hMainMenu, (LPARAM)GetSubMenu(hMainMenu, 4));

      DestroyMenu(hMenuStackA->hMainMenu);
      hMenuStackA->hMainMenu=NULL;
    }
  }

  DrawMenuBar(hMainWnd);
}

void InsertMainMenuW(POPUPMENUW *hMenuStackW)
{
  INDEXES *lpIndexElement=(INDEXES *)hMenuStackW->hMainMenuIndexStack.first;
  wchar_t wszMenuItem[MAX_PATH];
  HMENU hMenu=hMainMenu;
  int nMainMenuIndex;
  int nMainMenuCount;
  int nSubMenuIndex=0;
  int nState;

  if (hMenuStackW->bClearMainMenu)
  {
    hMenu=CreateMenu();
  }

  while (lpIndexElement)
  {
    NextItem:
    if ((nState=GetMenuState(hMenuStackW->hPopupMenu, nSubMenuIndex, MF_BYPOSITION)) != -1)
    {
      if (!(LOBYTE(nState) & MF_POPUP))
      {
        ++nSubMenuIndex;
        goto NextItem;
      }
    }
    else break;

    if (lpIndexElement->hSubMenu=GetSubMenu(hMenuStackW->hPopupMenu, nSubMenuIndex))
    {
      if (GetMenuStringW(hMenuStackW->hPopupMenu, nSubMenuIndex, wszMenuItem, MAX_PATH, MF_BYPOSITION))
      {
        nMainMenuIndex=lpIndexElement->nMainMenuIndex;

        if (nMainMenuIndex < 0)
        {
          nMainMenuCount=GetSubMenuCount(hMenu);

          if (nMainMenuCount + nMainMenuIndex >= 0)
            nMainMenuIndex=nMainMenuCount + nMainMenuIndex + 1;
          else
            nMainMenuIndex=0;
        }
        else
        {
          if ((nState=GetMenuState(hMenu, 0, MF_BYPOSITION)) != -1)
          {
            if (LOBYTE(nState) & MF_BITMAP)
              ++nMainMenuIndex;
          }
        }
        InsertMenuW(hMenu, nMainMenuIndex, MF_BYPOSITION|MF_POPUP, (UINT)lpIndexElement->hSubMenu, wszMenuItem);
      }
    }
    ++nSubMenuIndex;
    lpIndexElement=lpIndexElement->next;
  }

  if (hMenuStackW->bClearMainMenu)
  {
    if (!bMDI)
      SetMenu(hMainWnd, hMenu);
    else
      SendMessage(hMdiClient, WM_MDISETMENU, (WPARAM)hMenu, (LPARAM)hMenuStackW->hMdiDocumentsSubMenu);

    if (hMenuStackW->hMainMenu)
    {
      DestroyMenu(hMenuStackW->hMainMenu);
      hMenuStackW->hMainMenu=NULL;
    }
    hMenuStackW->hMainMenu=hMenu;
  }
  else
  {
    if (hMenuStackW->hMainMenu)
    {
      if (!bMDI)
        SetMenu(hMainWnd, hMainMenu);
      else
        SendMessage(hMdiClient, WM_MDISETMENU, (WPARAM)hMainMenu, (LPARAM)GetSubMenu(hMainMenu, 4));

      DestroyMenu(hMenuStackW->hMainMenu);
      hMenuStackW->hMainMenu=NULL;
    }
  }
  DrawMenuBar(hMainWnd);
}

void DeleteMainMenuA(POPUPMENUA *hMenuStackA)
{
  if (hMenuStackA->bClearMainMenu)
  {
    if (!bMDI)
      SetMenu(hMainWnd, hMainMenu);
    else
      SendMessage(hMdiClient, WM_MDISETMENU, (WPARAM)hMainMenu, (LPARAM)GetSubMenu(hMainMenu, 4));
  }
  else
  {
    INDEXES *lpIndexElement=NULL;
    int nIndex;

    lpIndexElement=(INDEXES *)hMenuStackA->hMainMenuIndexStack.first;

    while (lpIndexElement)
    {
      if ((nIndex=GetSubMenuIndex(hMainMenu, lpIndexElement->hSubMenu)) != -1)
        DeleteMenu(hMainMenu, nIndex, MF_BYPOSITION);

      lpIndexElement=lpIndexElement->next;
    }
    DrawMenuBar(hMainWnd);
  }
}

void DeleteMainMenuW(POPUPMENUW *hMenuStackW)
{
  if (hMenuStackW->bClearMainMenu)
  {
    if (!bMDI)
      SetMenu(hMainWnd, hMainMenu);
    else
      SendMessage(hMdiClient, WM_MDISETMENU, (WPARAM)hMainMenu, (LPARAM)GetSubMenu(hMainMenu, 4));
  }
  else
  {
    INDEXES *lpIndexElement=NULL;
    int nIndex;

    lpIndexElement=(INDEXES *)hMenuStackW->hMainMenuIndexStack.first;

    while (lpIndexElement)
    {
      if ((nIndex=GetSubMenuIndex(hMainMenu, lpIndexElement->hSubMenu)) != -1)
        DeleteMenu(hMainMenu, nIndex, MF_BYPOSITION);

      lpIndexElement=lpIndexElement->next;
    }
    DrawMenuBar(hMainWnd);
  }
}

MENUITEM* GetContextMenuItemA(POPUPMENUA *hMenuStackA, int nItem)
{
  if (nItem >= IDM_MIN_MENU && nItem <= IDM_MAX_MENU)
  {
    MENUITEM *lpElement=(MENUITEM *)hMenuStackA->hActionStack.first;

    while (lpElement)
    {
      if (lpElement->nItem > nItem)
        return NULL;
      if (lpElement->nItem == nItem)
        break;

      lpElement=lpElement->next;
    }
    return lpElement;
  }
  return NULL;
}

MENUITEM* GetContextMenuItemW(POPUPMENUW *hMenuStackW, int nItem)
{
  if (nItem >= IDM_MIN_MENU && nItem <= IDM_MAX_MENU)
  {
    MENUITEM *lpElement=(MENUITEM *)hMenuStackW->hActionStack.first;

    while (lpElement)
    {
      if (lpElement->nItem > nItem)
        return NULL;
      if (lpElement->nItem == nItem)
        break;

      lpElement=lpElement->next;
    }
    return lpElement;
  }
  return NULL;
}

MENUITEM* GetCommandItemA(POPUPMENUA *hMenuStackA, int nCommand)
{
  MENUITEM *lpElement=(MENUITEM *)hMenuStackA->hActionStack.first;

  while (lpElement)
  {
    if (lpElement->dwAction == ACT_COMMAND)
    {
      if (GetParameterInt(&lpElement->hParamStack, 1) == nCommand)
        break;
    }
    lpElement=lpElement->next;
  }
  return lpElement;
}

MENUITEM* GetCommandItemW(POPUPMENUW *hMenuStackW, int nCommand)
{
  MENUITEM *lpElement=(MENUITEM *)hMenuStackW->hActionStack.first;

  while (lpElement)
  {
    if (lpElement->dwAction == ACT_COMMAND)
    {
      if (GetParameterInt(&lpElement->hParamStack, 1) == nCommand)
        break;
    }
    lpElement=lpElement->next;
  }
  return lpElement;
}

void CALLBACK CallPluginA(void *lpParameter)
{
  PLUGINCALL *pc=(PLUGINCALL *)lpParameter;
  PLUGINCALLSENDA pcs;
  char szMessage[MAX_PATH];
  char *pFunction;
  int nParamStructSize;
  LPARAM lParam;
  BOOL bAutoLoad;

  pFunction=(char *)*(int *)pc->lpStruct;
  nParamStructSize=*(int *)(pc->lpStruct + sizeof(int));
  if (nParamStructSize > (int)sizeof(int))
    lParam=(LPARAM)(pc->lpStruct + sizeof(int));
  else
    lParam=0;

  if (pc->bSetOnStart)
  {
    pcs.pFunction=pFunction;
    pcs.bOnStart=FALSE;
    pcs.lParam=0;
    pcs.lpbAutoLoad=&bAutoLoad;

    if (SendMessage(hMainWnd, AKD_DLLCALL, 0, (LPARAM)&pcs) != UD_FAILED)
    {
      if (bAutoLoad)
      {
        PLUGINFUNCTIONA *pf;

        pcs.pFunction=pFunction;
        pcs.bOnStart=pc->bOnStart;
        pcs.lParam=lParam;
        pcs.lpbAutoLoad=NULL;
        SendMessage(hMainWnd, AKD_DLLCALL, 0, (LPARAM)&pcs);

        if (pf=(PLUGINFUNCTIONA *)SendMessage(hMainWnd, AKD_DLLFIND, (WPARAM)pFunction, 0))
        {
          if (pf->bRunning)
            pf->bOnStart=TRUE;
          else
            pf->bOnStart=FALSE;

          SendMessage(hMainWnd, AKD_DLLSAVE, 0, DLLS_CLEAR);
        }
      }
      else
      {
        wsprintfA(szMessage, GetLangStringA(wLangSystem, STRID_AUTOLOAD), pFunction);
        MessageBoxA(hMainWnd, szMessage, "ContextMenu plugin", MB_OK|MB_ICONEXCLAMATION);
      }
    }
  }
  else
  {
    pcs.pFunction=pFunction;
    pcs.bOnStart=pc->bOnStart;
    pcs.lParam=lParam;
    pcs.lpbAutoLoad=NULL;
    SendMessage(hMainWnd, AKD_DLLCALL, 0, (LPARAM)&pcs);
  }
  GlobalFree((HGLOBAL)pc->lpStruct);
  GlobalFree((HGLOBAL)pc);
  if (hMenuDialogStackA.hPopupMenu) FreeContextMenuA(&hMenuDialogStackA);
}

void CALLBACK CallPluginW(void *lpParameter)
{
  PLUGINCALL *pc=(PLUGINCALL *)lpParameter;
  PLUGINCALLSENDW pcs;
  wchar_t wszMessage[MAX_PATH];
  wchar_t *wpFunction;
  int nParamStructSize;
  LPARAM lParam;
  BOOL bAutoLoad;

  wpFunction=(wchar_t *)*(int *)pc->lpStruct;
  nParamStructSize=*(int *)(pc->lpStruct + sizeof(int));
  if (nParamStructSize > (int)sizeof(int))
    lParam=(LPARAM)(pc->lpStruct + sizeof(int));
  else
    lParam=0;

  if (pc->bSetOnStart)
  {
    pcs.pFunction=wpFunction;
    pcs.bOnStart=FALSE;
    pcs.lParam=0;
    pcs.lpbAutoLoad=&bAutoLoad;

    if (SendMessage(hMainWnd, AKD_DLLCALL, 0, (LPARAM)&pcs) != UD_FAILED)
    {
      if (bAutoLoad)
      {
        PLUGINFUNCTIONW *pf;

        pcs.pFunction=wpFunction;
        pcs.bOnStart=pc->bOnStart;
        pcs.lParam=lParam;
        pcs.lpbAutoLoad=NULL;
        SendMessage(hMainWnd, AKD_DLLCALL, 0, (LPARAM)&pcs);

        if (pf=(PLUGINFUNCTIONW *)SendMessage(hMainWnd, AKD_DLLFIND, (WPARAM)wpFunction, 0))
        {
          if (pf->bRunning)
            pf->bOnStart=TRUE;
          else
            pf->bOnStart=FALSE;

          SendMessage(hMainWnd, AKD_DLLSAVE, 0, DLLS_CLEAR);
        }
      }
      else
      {
        wsprintfW(wszMessage, GetLangStringW(wLangSystem, STRID_AUTOLOAD), wpFunction);
        MessageBoxW(hMainWnd, wszMessage, L"ContextMenu plugin", MB_OK|MB_ICONEXCLAMATION);
      }
    }
  }
  else
  {
    pcs.pFunction=wpFunction;
    pcs.bOnStart=pc->bOnStart;
    pcs.lParam=lParam;
    pcs.lpbAutoLoad=NULL;
    SendMessage(hMainWnd, AKD_DLLCALL, 0, (LPARAM)&pcs);
  }
  GlobalFree((HGLOBAL)pc->lpStruct);
  GlobalFree((HGLOBAL)pc);
  if (hMenuDialogStackW.hPopupMenu) FreeContextMenuW(&hMenuDialogStackW);
}

void CallContextMenuA(POPUPMENUA *hMenuStackA, int nItem)
{
  if (nItem >= IDM_MIN_EXPLORER && nItem <= IDM_MAX_EXPLORER)
  {
    CMINVOKECOMMANDINFO ici={0};

    ici.cbSize=sizeof(CMINVOKECOMMANDINFO);
    ici.hwnd=hMainWnd;
    ici.lpVerb=MAKEINTRESOURCEA(nItem - IDM_MIN_EXPLORER);
    ici.nShow=SW_SHOWNORMAL;

    if (hMenuStackA->pExplorerMenu) hMenuStackA->pExplorerMenu->InvokeCommand(&ici);
  }
  else if (nItem >= IDM_MIN_MENU && nItem <= IDM_MAX_MENU)
  {
    MENUITEM *lpElement;
    char szMenuID[16];
    char szItemID[16];

    if (lpElement=GetContextMenuItemA(hMenuStackA, nItem))
    {
      wsprintfA(szMenuID, "%d", hMenuStackA->hPopupMenu);
      wsprintfA(szItemID, "%d", nItem);

      if (lpElement->dwAction == ACT_COMMAND)
      {
        int nCommand=0;

        nCommand=GetParameterInt(&lpElement->hParamStack, 1);

        if (nCommand < IDM_MIN_EXPLORER || nCommand > IDM_MAX_MENU)
        {
          SendMessage(hMainWnd, WM_COMMAND, nCommand, 0);
        }
      }
      else if (lpElement->dwAction == ACT_CALL)
      {
        PLUGINCALL *pc;
        unsigned char *lpStruct=NULL;

        SetParametersExpCharA(&lpElement->hParamStack, szCurrentFile, szExeDir, szMenuID, szItemID, szUrlLink);

        if (CreateParametersStruct(&lpElement->hParamStack, &lpStruct))
        {
          if (pc=(PLUGINCALL *)GlobalAlloc(GPTR, sizeof(PLUGINCALL)))
          {
            pc->lpStruct=lpStruct;
            pc->bOnStart=FALSE;
            pc->bSetOnStart=lpElement->bSetOnStart;
            PostMessage(hMainWnd, AKD_CALLPROC, (WPARAM)CallPluginA, (LPARAM)pc);
          }
        }
      }
      else if (lpElement->dwAction == ACT_EXEC)
      {
        STARTUPINFOA si={0};
        PROCESS_INFORMATION pi={0};
        char *pCmdLine=NULL;
        char *pWorkDir=NULL;

        SetParametersExpCharA(&lpElement->hParamStack, szCurrentFile, szExeDir, szMenuID, szItemID, szUrlLink);
        pCmdLine=(char *)GetParameterExpChar(&lpElement->hParamStack, 1);
        pWorkDir=(char *)GetParameterExpChar(&lpElement->hParamStack, 2);

        if (pCmdLine)
        {
          si.cb=sizeof(STARTUPINFO);
          if (CreateProcessA(NULL, pCmdLine, NULL, NULL, FALSE, 0, NULL, pWorkDir, &si, &pi))
          {
            CloseHandle(pi.hProcess);
            CloseHandle(pi.hThread);
          }
        }
      }
      else if (lpElement->dwAction == ACT_FONT)
      {
        EDITINFO ei;
        char *pFaceName=NULL;
        DWORD dwFontStyle=0;
        int nPointSize=0;

        SetParametersExpCharA(&lpElement->hParamStack, szCurrentFile, szExeDir, szMenuID, szItemID, szUrlLink);
        pFaceName=(char *)GetParameterExpChar(&lpElement->hParamStack, 1);
        dwFontStyle=GetParameterInt(&lpElement->hParamStack, 2);
        nPointSize=GetParameterInt(&lpElement->hParamStack, 3);

        if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
        {
          LOGFONTA lfNew={0};
          LOGFONTA *lfCur;
          HDC hDC;

          lfCur=(LOGFONTA *)SendMessage(hMainWnd, AKD_GETFONT, (WPARAM)ei.hWndEdit, 0);
          memcpy(&lfNew, lfCur, sizeof(LOGFONTA));

          if (nPointSize)
          {
            if (hDC=GetDC(ei.hWndEdit))
            {
              lfNew.lfHeight=-MulDiv(nPointSize, GetDeviceCaps(hDC, LOGPIXELSY), 72);
              ReleaseDC(ei.hWndEdit, hDC);
            }
          }
          if (dwFontStyle != FS_NONE)
          {
            lfNew.lfWeight=(dwFontStyle == FS_FONTBOLD || dwFontStyle == FS_FONTBOLDITALIC)?FW_BOLD:FW_NORMAL;
            lfNew.lfItalic=(dwFontStyle == FS_FONTITALIC || dwFontStyle == FS_FONTBOLDITALIC)?TRUE:FALSE;
          }
          if (*pFaceName != '\0')
          {
            lstrcpynA(lfNew.lfFaceName, pFaceName, LF_FACESIZE);
          }
          SendMessage(hMainWnd, AKD_SETFONT, (WPARAM)ei.hWndEdit, (LPARAM)&lfNew);
        }
      }
      else if (lpElement->dwAction == ACT_RECODE)
      {
        TEXTRECODE tr;
        EDITINFO ei;

        tr.nCodePageFrom=GetParameterInt(&lpElement->hParamStack, 1);
        tr.nCodePageTo=GetParameterInt(&lpElement->hParamStack, 2);

        if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
        {
          SendMessage(hMainWnd, AKD_RECODESEL, (WPARAM)ei.hWndEdit, (LPARAM)&tr);
        }
      }
      else if (lpElement->dwAction == ACT_INSERT)
      {
        EDITINFO ei;
        char *pText=NULL;

        SetParametersExpCharA(&lpElement->hParamStack, szCurrentFile, szExeDir, szMenuID, szItemID, szUrlLink);
        pText=(char *)GetParameterExpChar(&lpElement->hParamStack, 1);

        if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
        {
          SendMessage(hMainWnd, AKD_REPLACESELA, (WPARAM)ei.hWndEdit, (LPARAM)pText);
        }
      }
    }
  }
  else SendMessage(hMainWnd, WM_COMMAND, nItem, 0);
}

void CallContextMenuW(POPUPMENUW *hMenuStackW, int nItem)
{
  if (nItem >= IDM_MIN_EXPLORER && nItem <= IDM_MAX_EXPLORER)
  {
    CMINVOKECOMMANDINFO ici={0};

    ici.cbSize=sizeof(CMINVOKECOMMANDINFO);
    ici.hwnd=hMainWnd;
    ici.lpVerb=MAKEINTRESOURCEA(nItem - IDM_MIN_EXPLORER);
    ici.nShow=SW_SHOWNORMAL;

    if (hMenuStackW->pExplorerMenu) hMenuStackW->pExplorerMenu->InvokeCommand(&ici);
  }
  else if (nItem >= IDM_MIN_MENU && nItem <= IDM_MAX_MENU)
  {
    MENUITEM *lpElement;
    wchar_t wszMenuID[16];
    wchar_t wszItemID[16];

    if (lpElement=GetContextMenuItemW(hMenuStackW, nItem))
    {
      wsprintfW(wszMenuID, L"%d", hMenuStackW->hPopupMenu);
      wsprintfW(wszItemID, L"%d", nItem);

      if (lpElement->dwAction == ACT_COMMAND)
      {
        int nCommand=0;

        nCommand=GetParameterInt(&lpElement->hParamStack, 1);

        if (nCommand < IDM_MIN_EXPLORER || nCommand > IDM_MAX_MENU)
        {
          SendMessage(hMainWnd, WM_COMMAND, nCommand, 0);
        }
      }
      else if (lpElement->dwAction == ACT_CALL)
      {
        PLUGINCALL *pc;
        unsigned char *lpStruct=NULL;

        SetParametersExpCharW(&lpElement->hParamStack, wszCurrentFile, wszExeDir, wszMenuID, wszItemID, wszUrlLink);

        if (CreateParametersStruct(&lpElement->hParamStack, &lpStruct))
        {
          if (pc=(PLUGINCALL *)GlobalAlloc(GPTR, sizeof(PLUGINCALL)))
          {
            pc->lpStruct=lpStruct;
            pc->bOnStart=FALSE;
            pc->bSetOnStart=lpElement->bSetOnStart;
            PostMessage(hMainWnd, AKD_CALLPROC, (WPARAM)CallPluginW, (LPARAM)pc);
          }
        }
      }
      else if (lpElement->dwAction == ACT_EXEC)
      {
        STARTUPINFOW si={0};
        PROCESS_INFORMATION pi={0};
        wchar_t *wpCmdLine=NULL;
        wchar_t *wpWorkDir=NULL;

        SetParametersExpCharW(&lpElement->hParamStack, wszCurrentFile, wszExeDir, wszMenuID, wszItemID, wszUrlLink);
        wpCmdLine=(wchar_t *)GetParameterExpChar(&lpElement->hParamStack, 1);
        wpWorkDir=(wchar_t *)GetParameterExpChar(&lpElement->hParamStack, 2);

        if (wpCmdLine)
        {
          si.cb=sizeof(STARTUPINFOW);
          if (CreateProcessW(NULL, wpCmdLine, NULL, NULL, FALSE, 0, NULL, wpWorkDir, &si, &pi))
          {
            CloseHandle(pi.hProcess);
            CloseHandle(pi.hThread);
          }
        }
      }
      else if (lpElement->dwAction == ACT_FONT)
      {
        EDITINFO ei;
        wchar_t *wpFaceName=NULL;
        DWORD dwFontStyle=0;
        int nPointSize=0;

        SetParametersExpCharW(&lpElement->hParamStack, wszCurrentFile, wszExeDir, wszMenuID, wszItemID, wszUrlLink);
        wpFaceName=(wchar_t *)GetParameterExpChar(&lpElement->hParamStack, 1);
        dwFontStyle=GetParameterInt(&lpElement->hParamStack, 2);
        nPointSize=GetParameterInt(&lpElement->hParamStack, 3);

        if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
        {
          LOGFONTW lfNew={0};
          LOGFONTW *lfCur;
          HDC hDC;

          lfCur=(LOGFONTW *)SendMessage(hMainWnd, AKD_GETFONT, (WPARAM)ei.hWndEdit, 0);
          memcpy(&lfNew, lfCur, sizeof(LOGFONTW));

          if (nPointSize)
          {
            if (hDC=GetDC(ei.hWndEdit))
            {
              lfNew.lfHeight=-MulDiv(nPointSize, GetDeviceCaps(hDC, LOGPIXELSY), 72);
              ReleaseDC(ei.hWndEdit, hDC);
            }
          }
          if (dwFontStyle != FS_NONE)
          {
            lfNew.lfWeight=(dwFontStyle == FS_FONTBOLD || dwFontStyle == FS_FONTBOLDITALIC)?FW_BOLD:FW_NORMAL;
            lfNew.lfItalic=(dwFontStyle == FS_FONTITALIC || dwFontStyle == FS_FONTBOLDITALIC)?TRUE:FALSE;
          }
          if (*wpFaceName != '\0')
          {
            lstrcpynW(lfNew.lfFaceName, wpFaceName, LF_FACESIZE);
          }
          SendMessage(hMainWnd, AKD_SETFONT, (WPARAM)ei.hWndEdit, (LPARAM)&lfNew);
        }
      }
      else if (lpElement->dwAction == ACT_RECODE)
      {
        TEXTRECODE tr;
        EDITINFO ei;

        tr.nCodePageFrom=GetParameterInt(&lpElement->hParamStack, 1);
        tr.nCodePageTo=GetParameterInt(&lpElement->hParamStack, 2);

        if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
        {
          SendMessage(hMainWnd, AKD_RECODESEL, (WPARAM)ei.hWndEdit, (LPARAM)&tr);
        }
      }
      else if (lpElement->dwAction == ACT_INSERT)
      {
        EDITINFO ei;
        wchar_t *wpText=NULL;

        SetParametersExpCharW(&lpElement->hParamStack, wszCurrentFile, wszExeDir, wszMenuID, wszItemID, wszUrlLink);
        wpText=(wchar_t *)GetParameterExpChar(&lpElement->hParamStack, 1);

        if (SendMessage(hMainWnd, AKD_GETEDITINFO, (WPARAM)NULL, (LPARAM)&ei))
        {
          SendMessage(hMainWnd, AKD_REPLACESELW, (WPARAM)ei.hWndEdit, (LPARAM)wpText);
        }
      }
    }
  }
  else SendMessage(hMainWnd, WM_COMMAND, nItem, 0);
}

void FreeContextMenuA(POPUPMENUA *hMenuStackA)
{
  MENUITEM *lpElement=(MENUITEM *)hMenuStackA->hActionStack.first;

  while (lpElement)
  {
    FreeActionParameters(&lpElement->hParamStack);

    lpElement=lpElement->next;
  }
  StackClear((stack **)&hMenuStackA->hActionStack.first, (stack **)&hMenuStackA->hActionStack.last);

  StackClear((stack **)&hMenuStackA->hMainMenuIndexStack.first, (stack **)&hMenuStackA->hMainMenuIndexStack.last);

  if (hMenuStackA->hPopupMenu)
  {
    DestroyMenu(hMenuStackA->hPopupMenu);
    hMenuStackA->hPopupMenu=NULL;
  }
  if (hMenuStackA->hMainMenu)
  {
    DestroyMenu(hMenuStackA->hMainMenu);
    hMenuStackA->hMainMenu=NULL;
  }
  if (hMenuStackA->hExplorerSubMenu)
  {
    hMenuStackA->hExplorerSubMenu=NULL;
  }
  if (hMenuStackA->hRecentFilesSubMenu)
  {
    hMenuStackA->hRecentFilesSubMenu=NULL;
  }
  if (hMenuStackA->hLanguagesSubMenu)
  {
    hMenuStackA->hLanguagesSubMenu=NULL;
  }
  if (hMenuStackA->hMdiDocumentsSubMenu)
  {
    hMenuStackA->hMdiDocumentsSubMenu=NULL;
  }
  if (hMenuStackA->pExplorerSubMenu3)
  {
//    hMenuStackA->pExplorerSubMenu3->Release();
    hMenuStackA->pExplorerSubMenu3=NULL;
  }
  if (hMenuStackA->pExplorerSubMenu2)
  {
//    hMenuStackA->pExplorerSubMenu2->Release();
    hMenuStackA->pExplorerSubMenu2=NULL;
  }
  if (hMenuStackA->pExplorerMenu)
  {
//    hMenuStackA->pExplorerMenu->Release();
    hMenuStackA->pExplorerMenu=NULL;
  }
  hMenuStackA->szExplorerFile[0]='\0';
}

void FreeContextMenuW(POPUPMENUW *hMenuStackW)
{
  MENUITEM *lpElement=(MENUITEM *)hMenuStackW->hActionStack.first;

  while (lpElement)
  {
    FreeActionParameters(&lpElement->hParamStack);

    lpElement=lpElement->next;
  }
  StackClear((stack **)&hMenuStackW->hActionStack.first, (stack **)&hMenuStackW->hActionStack.last);

  StackClear((stack **)&hMenuStackW->hMainMenuIndexStack.first, (stack **)&hMenuStackW->hMainMenuIndexStack.last);

  if (hMenuStackW->hPopupMenu)
  {
    DestroyMenu(hMenuStackW->hPopupMenu);
    hMenuStackW->hPopupMenu=NULL;
  }
  if (hMenuStackW->hMainMenu)
  {
    DestroyMenu(hMenuStackW->hMainMenu);
    hMenuStackW->hMainMenu=NULL;
  }
  if (hMenuStackW->hExplorerSubMenu)
  {
    hMenuStackW->hExplorerSubMenu=NULL;
  }
  if (hMenuStackW->hRecentFilesSubMenu)
  {
    hMenuStackW->hRecentFilesSubMenu=NULL;
  }
  if (hMenuStackW->hLanguagesSubMenu)
  {
    hMenuStackW->hLanguagesSubMenu=NULL;
  }
  if (hMenuStackW->hMdiDocumentsSubMenu)
  {
    hMenuStackW->hMdiDocumentsSubMenu=NULL;
  }
  if (hMenuStackW->pExplorerSubMenu3)
  {
//    hMenuStackW->pExplorerSubMenu3->Release();
    hMenuStackW->pExplorerSubMenu3=NULL;
  }
  if (hMenuStackW->pExplorerSubMenu2)
  {
//    hMenuStackW->pExplorerSubMenu2->Release();
    hMenuStackW->pExplorerSubMenu2=NULL;
  }
  if (hMenuStackW->pExplorerMenu)
  {
//    hMenuStackW->pExplorerMenu->Release();
    hMenuStackW->pExplorerMenu=NULL;
  }
  hMenuStackW->wszExplorerFile[0]='\0';
}

BOOL GetExplorerMenu(LPCONTEXTMENU *pContextMenu, LPCONTEXTMENU2 *pContextSubMenu2, LPCONTEXTMENU3 *pContextSubMenu3, HWND hWnd, wchar_t *wpFile)
{
  LPSHELLFOLDER pDesktopFolder=NULL;
  LPSHELLFOLDER pFolder=NULL;
  LPMALLOC pMalloc=NULL;
  LPITEMIDLIST pidlFirst;
  LPITEMIDLIST pidlNext;
  LPITEMIDLIST pidlLast;
  USHORT nTemp;
  BOOL bResult=FALSE;

  *pContextMenu=NULL;
  *pContextSubMenu2=NULL;
  *pContextSubMenu3=NULL;

  if (SHGetDesktopFolder(&pDesktopFolder) == NOERROR)
  {
    pDesktopFolder->ParseDisplayName(hWnd, NULL, wpFile, NULL, &pidlFirst, NULL);

    if (pidlFirst)
    {
      pidlNext=pidlLast=pidlFirst;

      while (1)
      {
        pidlNext=NextPIDL(pidlNext);
        if (pidlNext->mkid.cb == 0) break;
        pidlLast=pidlNext;
      }

      nTemp=pidlLast->mkid.cb;
      pidlLast->mkid.cb=0;
      pDesktopFolder->BindToObject(pidlFirst, NULL, IID_IShellFolder, (void **)&pFolder);
      pidlLast->mkid.cb=nTemp;

      if (pFolder)
      {
        pFolder->GetUIObjectOf(hWnd, 1, (LPCITEMIDLIST *)&pidlLast, IID_IContextMenu, NULL, (void **)pContextMenu);

        if (pContextMenu)
        {
          (*pContextMenu)->QueryInterface(IID_IContextMenu2, (void **)pContextSubMenu2);
          (*pContextMenu)->QueryInterface(IID_IContextMenu3, (void **)pContextSubMenu3);
          bResult=TRUE;
        }
      }
      else *pContextMenu=NULL;
    }

    //Release
    if (SHGetMalloc(&pMalloc) == NOERROR)
    {
      pMalloc->Free(pidlFirst);
      pMalloc->Release();
    }
    if (pFolder) pFolder->Release();
    if (pDesktopFolder) pDesktopFolder->Release();
  }
  return bResult;
}

LPITEMIDLIST NextPIDL(LPCITEMIDLIST pidl)
{
  unsigned char *pMem=(unsigned char *)pidl;

  pMem+=pidl->mkid.cb;

  return (LPITEMIDLIST)pMem;
}

void GetActionParametersA(HSTACK *hParamStack, char *pText, char **ppText)
{
  PARAMETER *lpParameter;
  char *pParamBegin=pText;
  char *pParamEnd;
  char *pString;
  char chStopChar;
  int nStringLen;

  GetActionParameter:
  while (*pParamBegin == ' ' || *pParamBegin == '\t') ++pParamBegin;

  if (*pParamBegin == '\"' || *pParamBegin == '\'' || *pParamBegin == '`')
  {
    //String
    chStopChar=*pParamBegin++;
    nStringLen=0;

    for (pParamEnd=pParamBegin; *pParamEnd != chStopChar && *pParamEnd != '\0'; ++pParamEnd)
    {
      ++nStringLen;
    }

    if (!StackInsertIndex((stack **)&hParamStack->first, (stack **)&hParamStack->last, (stack **)&lpParameter, -1, sizeof(PARAMETER)))
    {
      if (lpParameter->lParam=(LPARAM)GlobalAlloc(GPTR, nStringLen + 1))
      {
        lpParameter->dwType=PARAM_CHAR;
        pString=(char *)lpParameter->lParam;

        for (pParamEnd=pParamBegin; *pParamEnd != chStopChar && *pParamEnd != '\0'; ++pParamEnd)
        {
          *pString++=*pParamEnd;
        }
      }
    }
  }
  else
  {
    //Number
    for (pParamEnd=pParamBegin; *pParamEnd != ',' && *pParamEnd != ')' && *pParamEnd != '\0'; ++pParamEnd);

    if (!StackInsertIndex((stack **)&hParamStack->first, (stack **)&hParamStack->last, (stack **)&lpParameter, -1, sizeof(PARAMETER)))
    {
      lpParameter->dwType=PARAM_INT;
      lpParameter->lParam=xatoiA(pParamBegin);
    }
  }

  while (*pParamEnd != ',' && *pParamEnd != ')' && *pParamEnd != '\0')
    ++pParamEnd;
  if (*pParamEnd == ',')
  {
    pParamBegin=++pParamEnd;
    goto GetActionParameter;
  }
  if (*pParamEnd == ')')
    ++pParamEnd;
  *ppText=pParamEnd;
}

void GetActionParametersW(HSTACK *hParamStack, wchar_t *wpText, wchar_t **wppText)
{
  PARAMETER *lpParameter;
  wchar_t *wpParamBegin=wpText;
  wchar_t *wpParamEnd;
  wchar_t *wpString;
  wchar_t wchStopChar;
  int nStringLen;

  GetActionParameter:
  while (*wpParamBegin == ' ' || *wpParamBegin == '\t') ++wpParamBegin;

  if (*wpParamBegin == '\"' || *wpParamBegin == '\'' || *wpParamBegin == '`')
  {
    //String
    wchStopChar=*wpParamBegin++;
    nStringLen=0;

    for (wpParamEnd=wpParamBegin; *wpParamEnd != wchStopChar && *wpParamEnd != '\0'; ++wpParamEnd)
    {
      ++nStringLen;
    }

    if (!StackInsertIndex((stack **)&hParamStack->first, (stack **)&hParamStack->last, (stack **)&lpParameter, -1, sizeof(PARAMETER)))
    {
      if (lpParameter->lParam=(LPARAM)GlobalAlloc(GPTR, (nStringLen + 1) * sizeof(wchar_t)))
      {
        lpParameter->dwType=PARAM_CHAR;
        wpString=(wchar_t *)lpParameter->lParam;

        for (wpParamEnd=wpParamBegin; *wpParamEnd != wchStopChar && *wpParamEnd != '\0'; ++wpParamEnd)
        {
          *wpString++=*wpParamEnd;
        }
      }
    }
  }
  else
  {
    //Number
    for (wpParamEnd=wpParamBegin; *wpParamEnd != ',' && *wpParamEnd != ')' && *wpParamEnd != '\0'; ++wpParamEnd);

    if (!StackInsertIndex((stack **)&hParamStack->first, (stack **)&hParamStack->last, (stack **)&lpParameter, -1, sizeof(PARAMETER)))
    {
      lpParameter->dwType=PARAM_INT;
      lpParameter->lParam=xatoiW(wpParamBegin);
    }
  }

  while (*wpParamEnd != ',' && *wpParamEnd != ')' && *wpParamEnd != '\0')
    ++wpParamEnd;
  if (*wpParamEnd == ',')
  {
    wpParamBegin=++wpParamEnd;
    goto GetActionParameter;
  }
  if (*wpParamEnd == ')')
    ++wpParamEnd;
  *wppText=wpParamEnd;
}

void SetParametersExpCharA(HSTACK *hParamStack, char *pFile, char *pExeDir, char *pMenuID, char *pItemID, char *pUrlLink)
{
  //%f -file, %d -file directory, %a -AkelPad directory, %u -URL,  %% -%
  PARAMETER *lpParameter=(PARAMETER *)hParamStack->first;
  char szFileDir[MAX_PATH];
  char *szString;
  char *pCount;
  char *pExpandStr=NULL;
  char chTmp;
  int nFileLen;
  int nFileDirLen;
  int nExeDirLen;
  int nMenuIDLen;
  int nItemIDLen;
  int nUrlLinkLen;
  int nExpandStrLen;
  int nEnvironmentLen;

  nFileLen=lstrlenA(pFile);
  nFileDirLen=GetFileDirA(pFile, szFileDir, MAX_PATH);
  nExeDirLen=lstrlenA(pExeDir);
  nMenuIDLen=lstrlenA(pMenuID);
  nItemIDLen=lstrlenA(pItemID);
  nUrlLinkLen=lstrlenA(pUrlLink);
  nExpandStrLen=0;

  while (lpParameter)
  {
    if (lpParameter->dwType == PARAM_CHAR)
    {
      nEnvironmentLen=ExpandEnvironmentStringsA((char *)lpParameter->lParam, &chTmp, 0);

      if (szString=(char *)GlobalAlloc(GPTR, nEnvironmentLen))
      {
        //Expand environment strings
        ExpandEnvironmentStringsA((char *)lpParameter->lParam, szString, nEnvironmentLen);

        //Calculate expanded size
        for (pCount=szString; *pCount; ++pCount)
        {
          if (*pCount == '%')
          {
            if (*(pCount + 1) == '%')
            {
              ++pCount;
              ++nExpandStrLen;
              continue;
            }
            if (*(pCount + 1) == 'f' || *(pCount + 1) == 'F')
            {
              ++pCount;
              nExpandStrLen+=nFileLen;
              continue;
            }
            if (*(pCount + 1) == 'd' || *(pCount + 1) == 'D')
            {
              ++pCount;
              nExpandStrLen+=nFileDirLen;
              continue;
            }
            if (*(pCount + 1) == 'a' || *(pCount + 1) == 'A')
            {
              ++pCount;
              nExpandStrLen+=nExeDirLen;
              continue;
            }
            if (*(pCount + 1) == 'm' || *(pCount + 1) == 'M')
            {
              ++pCount;
              nExpandStrLen+=nMenuIDLen;
              continue;
            }
            if (*(pCount + 1) == 'i' || *(pCount + 1) == 'I')
            {
              ++pCount;
              nExpandStrLen+=nItemIDLen;
              continue;
            }
            if (*(pCount + 1) == 'u' || *(pCount + 1) == 'U')
            {
              ++pCount;
              nExpandStrLen+=nUrlLinkLen;
              continue;
            }
          }
          else ++nExpandStrLen;
        }

        //Expand string
        if (lpParameter->pExpanded) GlobalFree((HGLOBAL)lpParameter->pExpanded);

        if (lpParameter->pExpanded=(unsigned char *)GlobalAlloc(GPTR, nExpandStrLen + 1))
        {
          pExpandStr=(char *)lpParameter->pExpanded;

          for (pCount=szString; *pCount; ++pCount)
          {
            if (*pCount == '%')
            {
              if (*(pCount + 1) == '%')
              {
                ++pCount;
                *pExpandStr++='%';
                continue;
              }
              if (*(pCount + 1) == 'f' || *(pCount + 1) == 'F')
              {
                ++pCount;
                lstrcpyA(pExpandStr, pFile);
                pExpandStr+=nFileLen;
                continue;
              }
              if (*(pCount + 1) == 'd' || *(pCount + 1) == 'D')
              {
                ++pCount;
                lstrcpyA(pExpandStr, szFileDir);
                pExpandStr+=nFileDirLen;
                continue;
              }
              if (*(pCount + 1) == 'a' || *(pCount + 1) == 'A')
              {
                ++pCount;
                lstrcpyA(pExpandStr, pExeDir);
                pExpandStr+=nExeDirLen;
                continue;
              }
              if (*(pCount + 1) == 'm' || *(pCount + 1) == 'M')
              {
                ++pCount;
                lstrcpyA(pExpandStr, pMenuID);
                pExpandStr+=nMenuIDLen;
                continue;
              }
              if (*(pCount + 1) == 'i' || *(pCount + 1) == 'I')
              {
                ++pCount;
                lstrcpyA(pExpandStr, pItemID);
                pExpandStr+=nItemIDLen;
                continue;
              }
              if (*(pCount + 1) == 'u' || *(pCount + 1) == 'U')
              {
                ++pCount;
                lstrcpyA(pExpandStr, pUrlLink);
                pExpandStr+=nUrlLinkLen;
                continue;
              }
            }
            else *pExpandStr++=*pCount;
          }
        }
        GlobalFree((HGLOBAL)szString);
      }
    }
    lpParameter=lpParameter->next;
  }
}

void SetParametersExpCharW(HSTACK *hParamStack, wchar_t *wpFile, wchar_t *wpExeDir, wchar_t *wpMenuID, wchar_t *wpItemID, wchar_t *wpUrlLink)
{
  //%f -file, %d -file directory, %a -AkelPad directory, %% -%
  PARAMETER *lpParameter=(PARAMETER *)hParamStack->first;
  wchar_t wszFileDir[MAX_PATH];
  wchar_t *wszString;
  wchar_t *wpCount;
  wchar_t *wpExpandStr;
  int nFileLen;
  int nFileDirLen;
  int nExeDirLen;
  int nMenuIDLen;
  int nItemIDLen;
  int nUrlLinkLen;
  int nExpandStrLen;
  int nEnvironmentLen;

  nFileLen=lstrlenW(wpFile);
  nFileDirLen=GetFileDirW(wpFile, wszFileDir, MAX_PATH);
  nExeDirLen=lstrlenW(wpExeDir);
  nMenuIDLen=lstrlenW(wpMenuID);
  nItemIDLen=lstrlenW(wpItemID);
  nUrlLinkLen=lstrlenW(wpUrlLink);
  nExpandStrLen=0;

  while (lpParameter)
  {
    if (lpParameter->dwType == PARAM_CHAR)
    {
      nEnvironmentLen=ExpandEnvironmentStringsW((wchar_t *)lpParameter->lParam, NULL, 0);

      if (wszString=(wchar_t *)GlobalAlloc(GPTR, nEnvironmentLen * sizeof(wchar_t)))
      {
        //Expand environment strings
        ExpandEnvironmentStringsW((wchar_t *)lpParameter->lParam, wszString, nEnvironmentLen);

        //Calculate expanded size
        for (wpCount=wszString; *wpCount; ++wpCount)
        {
          if (*wpCount == '%')
          {
            if (*(wpCount + 1) == '%')
            {
              ++wpCount;
              ++nExpandStrLen;
              continue;
            }
            if (*(wpCount + 1) == 'f' || *(wpCount + 1) == 'F')
            {
              ++wpCount;
              nExpandStrLen+=nFileLen;
              continue;
            }
            if (*(wpCount + 1) == 'd' || *(wpCount + 1) == 'D')
            {
              ++wpCount;
              nExpandStrLen+=nFileDirLen;
              continue;
            }
            if (*(wpCount + 1) == 'a' || *(wpCount + 1) == 'A')
            {
              ++wpCount;
              nExpandStrLen+=nExeDirLen;
              continue;
            }
            if (*(wpCount + 1) == 'm' || *(wpCount + 1) == 'M')
            {
              ++wpCount;
              nExpandStrLen+=nMenuIDLen;
              continue;
            }
            if (*(wpCount + 1) == 'i' || *(wpCount + 1) == 'I')
            {
              ++wpCount;
              nExpandStrLen+=nItemIDLen;
              continue;
            }
            if (*(wpCount + 1) == 'u' || *(wpCount + 1) == 'U')
            {
              ++wpCount;
              nExpandStrLen+=nUrlLinkLen;
              continue;
            }
          }
          else ++nExpandStrLen;
        }

        //Expand string
        if (lpParameter->pExpanded) GlobalFree((HGLOBAL)lpParameter->pExpanded);

        if (lpParameter->pExpanded=(unsigned char *)GlobalAlloc(GPTR, (nExpandStrLen + 1) * sizeof(wchar_t)))
        {
          wpExpandStr=(wchar_t *)lpParameter->pExpanded;

          for (wpCount=wszString; *wpCount; ++wpCount)
          {
            if (*wpCount == '%')
            {
              if (*(wpCount + 1) == '%')
              {
                ++wpCount;
                *wpExpandStr++='%';
                continue;
              }
              if (*(wpCount + 1) == 'f' || *(wpCount + 1) == 'F')
              {
                ++wpCount;
                lstrcpyW(wpExpandStr, wpFile);
                wpExpandStr+=nFileLen;
                continue;
              }
              if (*(wpCount + 1) == 'd' || *(wpCount + 1) == 'D')
              {
                ++wpCount;
                lstrcpyW(wpExpandStr, wszFileDir);
                wpExpandStr+=nFileDirLen;
                continue;
              }
              if (*(wpCount + 1) == 'a' || *(wpCount + 1) == 'A')
              {
                ++wpCount;
                lstrcpyW(wpExpandStr, wpExeDir);
                wpExpandStr+=nExeDirLen;
                continue;
              }
              if (*(wpCount + 1) == 'm' || *(wpCount + 1) == 'M')
              {
                ++wpCount;
                lstrcpyW(wpExpandStr, wpMenuID);
                wpExpandStr+=nMenuIDLen;
                continue;
              }
              if (*(wpCount + 1) == 'i' || *(wpCount + 1) == 'I')
              {
                ++wpCount;
                lstrcpyW(wpExpandStr, wpItemID);
                wpExpandStr+=nItemIDLen;
                continue;
              }
              if (*(wpCount + 1) == 'u' || *(wpCount + 1) == 'U')
              {
                ++wpCount;
                lstrcpyW(wpExpandStr, wpUrlLink);
                wpExpandStr+=nUrlLinkLen;
                continue;
              }
            }
            else *wpExpandStr++=*wpCount;
          }
        }
        GlobalFree((HGLOBAL)wszString);
      }
    }
    lpParameter=lpParameter->next;
  }
}

int CreateParametersStruct(HSTACK *hParamStack, unsigned char **lppStruct)
{
  PARAMETER *lpParameter=(PARAMETER *)hParamStack->first;
  unsigned char *lpStruct=NULL;
  int nStructSize=0;
  int nOffset=0;
  int nElements=0;
  int nIndex=0;

  if (nElements=StackSize((stack *)hParamStack->first, (stack *)hParamStack->last))
  {
    nStructSize=(nElements + 1) * sizeof(int);

    if (lpStruct=(unsigned char *)GlobalAlloc(GPTR, nStructSize))
    {
      while (lpParameter)
      {
        if (nIndex == 1)
        {
          //nIndex == 1 is the size of the call parameters structure
          *((int *)(lpStruct + nOffset))=nElements * sizeof(int);
          nOffset+=sizeof(int);
          ++nIndex;
        }

        //nIndex == 0 is function name, nIndex >= 2 is call parameters
        if (lpParameter->dwType == PARAM_CHAR)
          *((int *)(lpStruct + nOffset))=(int)lpParameter->pExpanded;
        else
          *((int *)(lpStruct + nOffset))=lpParameter->lParam;

        nOffset+=sizeof(int);
        ++nIndex;
        lpParameter=lpParameter->next;
      }
    }
  }
  *lppStruct=lpStruct;
  return nStructSize;
}

int GetParameterInt(HSTACK *hParamStack, int nIndex)
{
  PARAMETER *lpParameter;

  if (!StackGetElement((stack *)hParamStack->first, (stack *)hParamStack->last, (stack **)&lpParameter, nIndex))
  {
    if (lpParameter->dwType == PARAM_INT)
      return lpParameter->lParam;
  }
  return 0;
}

unsigned char* GetParameterChar(HSTACK *hParamStack, int nIndex)
{
  PARAMETER *lpParameter;

  if (!StackGetElement((stack *)hParamStack->first, (stack *)hParamStack->last, (stack **)&lpParameter, nIndex))
  {
    if (lpParameter->dwType == PARAM_CHAR)
      return (unsigned char *)lpParameter->lParam;
  }
  return NULL;
}

unsigned char* GetParameterExpChar(HSTACK *hParamStack, int nIndex)
{
  PARAMETER *lpParameter;

  if (!StackGetElement((stack *)hParamStack->first, (stack *)hParamStack->last, (stack **)&lpParameter, nIndex))
  {
    if (lpParameter->dwType == PARAM_CHAR)
      return lpParameter->pExpanded;
  }
  return NULL;
}

void FreeActionParameters(HSTACK *hParamStack)
{
  PARAMETER *lpParameter=(PARAMETER *)hParamStack->first;

  while (lpParameter)
  {
    if (lpParameter->dwType == PARAM_CHAR)
    {
      if (lpParameter->lParam) GlobalFree((HGLOBAL)lpParameter->lParam);
      if (lpParameter->pExpanded) GlobalFree((HGLOBAL)lpParameter->pExpanded);
    }
    lpParameter=lpParameter->next;
  }
  StackClear((stack **)&hParamStack->first, (stack **)&hParamStack->last);
}

int NextStringA(char *pText, char *szStr, int nStrLen, char **ppText, int *nMinus)
{
  int i;

  while (*pText == ' ' || *pText == '\t' || *pText == '\r') ++pText;

  if (*pText == '-')
  {
    if (nMinus) *nMinus=1;
    ++pText;
  }
  else
  {
    if (nMinus) *nMinus=0;
  }

  if (*pText == '\"')
  {
    ++pText;
    i=0;

    while (*pText != '\"' && *pText != '\0')
    {
      if (i < nStrLen) szStr[i++]=*pText;
      ++pText;
    }
  }
  else
  {
    i=0;

    while (*pText != ' ' && *pText != '\r' && *pText != '\0')
    {
      if (i < nStrLen) szStr[i++]=*pText;
      ++pText;
    }
  }
  szStr[i]='\0';
  if (*pText != '\r' && *pText != '\0') ++pText;
  if (ppText) *ppText=pText;
  return i;
}

int NextStringW(wchar_t *wpText, wchar_t *wszStr, int nStrLen, wchar_t **wppText, int *nMinus)
{
  int i;

  while (*wpText == ' ' || *wpText == '\t' || *wpText == '\r') ++wpText;

  if (*wpText == '-')
  {
    if (nMinus) *nMinus=1;
    ++wpText;
  }
  else
  {
    if (nMinus) *nMinus=0;
  }

  if (*wpText == '\"')
  {
    ++wpText;
    i=0;

    while (*wpText != '\"' && *wpText != '\0')
    {
      if (i < nStrLen) wszStr[i++]=*wpText;
      ++wpText;
    }
  }
  else
  {
    i=0;

    while (*wpText != ' ' && *wpText != '\r' && *wpText != '\0')
    {
      if (i < nStrLen) wszStr[i++]=*wpText;
      ++wpText;
    }
  }
  wszStr[i]='\0';
  if (*wpText != '\r' && *wpText != '\0') ++wpText;
  if (wppText) *wppText=wpText;
  return i;
}

BOOL SkipCommentA(char **pText)
{
  while (1)
  {
    while (**pText == ' ' || **pText == '\t' || **pText == '\r' || **pText == '\n') ++*pText;

    if (**pText == ';' || **pText == '#')
    {
      while (**pText != '\r' && **pText != '\0') ++*pText;
    }
    else break;
  }
  if (**pText == '\0')
    return FALSE;
  return TRUE;
}

BOOL SkipCommentW(wchar_t **wpText)
{
  while (1)
  {
    while (**wpText == ' ' || **wpText == '\t' || **wpText == '\r' || **wpText == '\n') ++*wpText;

    if (**wpText == ';' || **wpText == '#')
    {
      while (**wpText != '\r' && **wpText != '\0') ++*wpText;
    }
    else break;
  }
  if (**wpText == '\0')
    return FALSE;
  return TRUE;
}

int GetActionNameA(char *pText, char *szStr, int nStrLen, char **ppText)
{
  int i=0;

  while (*pText == '\"' || *pText == ' ' || *pText == '\t') ++pText;

  while (*pText != '(' && *pText != '\r' && *pText != '\0')
  {
    if (i < nStrLen) szStr[i++]=*pText;
    ++pText;
  }
  szStr[i]='\0';
  if (*pText != '\r' && *pText != '\0') ++pText;
  if (ppText) *ppText=pText;
  return i;
}

int GetActionNameW(wchar_t *wpText, wchar_t *wszStr, int nStrLen, wchar_t **wppText)
{
  int i=0;

  while (*wpText == '\"' || *wpText == ' ' || *wpText == '\t') ++wpText;

  while (*wpText != '(' && *wpText != '\r' && *wpText != '\0')
  {
    if (i < nStrLen) wszStr[i++]=*wpText;
    ++wpText;
  }
  wszStr[i]='\0';
  if (*wpText != '\r' && *wpText != '\0') ++wpText;
  if (wppText) *wppText=wpText;
  return i;
}

int GetFileDirA(char *pFile, char *szFileDir, int nFileDirLen)
{
  int i;

  if (!nFileDirLen) return 0;
  szFileDir[0]='\0';

  for (i=lstrlenA(pFile) - 1; i > 0; --i)
  {
    if (pFile[i] == '\\')
    {
      i=min(nFileDirLen, i + 1);
      lstrcpynA(szFileDir, pFile, i);
      return (i - 1);
    }
  }
  return 0;
}

int GetFileDirW(wchar_t *wpFile, wchar_t *wszFileDir, int nFileDirLen)
{
  int i;

  if (!nFileDirLen) return 0;
  wszFileDir[0]='\0';

  for (i=lstrlenW(wpFile) - 1; i > 0; --i)
  {
    if (wpFile[i] == '\\')
    {
      i=min(nFileDirLen, i + 1);
      lstrcpynW(wszFileDir, wpFile, i);
      return (i - 1);
    }
  }
  return 0;
}

int GetSubMenuIndex(HMENU hMenu, HMENU hSubMenu)
{
  HMENU hSubMenuCount;
  int i;

  for (i=0; hSubMenuCount=GetSubMenu(hMenu, i); ++i)
  {
    if (hSubMenuCount == hSubMenu) return i;
  }
  return -1;
}

int GetSubMenuCount(HMENU hMenu)
{
  int i;

  for (i=0; GetSubMenu(hMenu, i); ++i);
  return i;
}

void ShowStandartEditMenu(HWND hWnd, HMENU hMenu, BOOL bMouse)
{
  RECT rcRect;
  POINT pt;
  CHARRANGE cr;
  int nCmd;

  if (!bMouse)
  {
    GetWindowRect(hWnd, &rcRect);
    pt.x=rcRect.left;
    pt.y=rcRect.top;
  }
  else GetCursorPos(&pt);

  SendMessage(hWnd, EM_EXGETSEL, 0, (LPARAM)&cr);
  EnableMenuItem(hMenu, IDM_EDIT_UNDO, SendMessage(hWnd, EM_CANUNDO, 0, 0)?MF_ENABLED:MF_GRAYED);
  EnableMenuItem(hMenu, IDM_EDIT_REDO, SendMessage(hWnd, EM_CANREDO, 0, 0)?MF_ENABLED:MF_GRAYED);
  EnableMenuItem(hMenu, IDM_EDIT_PASTE, SendMessage(hWnd, EM_CANPASTE, 0, 0)?MF_ENABLED:MF_GRAYED);
  EnableMenuItem(hMenu, IDM_EDIT_CUT, (cr.cpMin < cr.cpMax)?MF_ENABLED:MF_GRAYED);
  EnableMenuItem(hMenu, IDM_EDIT_CLEAR, (cr.cpMin < cr.cpMax)?MF_ENABLED:MF_GRAYED);
  EnableMenuItem(hMenu, IDM_EDIT_COPY, (cr.cpMin < cr.cpMax)?MF_ENABLED:MF_GRAYED);

  nCmd=TrackPopupMenu(hMenu, TPM_RETURNCMD|TPM_NONOTIFY|TPM_LEFTBUTTON|TPM_RIGHTBUTTON, pt.x, pt.y, 0, hWnd, NULL);

  if (nCmd == IDM_EDIT_UNDO)
    SendMessage(hWnd, EM_UNDO, 0, 0);
  else if (nCmd == IDM_EDIT_REDO)
    SendMessage(hWnd, EM_REDO, 0, 0);
  else if (nCmd == IDM_EDIT_CUT)
    SendMessage(hWnd, WM_CUT, 0, 0);
  else if (nCmd == IDM_EDIT_COPY)
    SendMessage(hWnd, WM_COPY, 0, 0);
  else if (nCmd == IDM_EDIT_PASTE)
    SendMessage(hWnd, WM_PASTE, 0, 0);
  else if (nCmd == IDM_EDIT_CLEAR)
    SendMessage(hWnd, WM_CLEAR, 0, 0);
  else if (nCmd == IDM_EDIT_SELECTALL)
    SendMessage(hWnd, EM_SETSEL, 0, -1);
}

BOOL GetWindowPos(HWND hWnd, HWND hWndOwner, RECT *rc)
{
  if (GetWindowRect(hWnd, rc))
  {
    rc->right-=rc->left;
    rc->bottom-=rc->top;

    if (hWndOwner)
    {
      if (!ScreenToClient(hWndOwner, (POINT *)&rc->left))
        return FALSE;
    }
    return TRUE;
  }
  return FALSE;
}

BOOL DialogResizeMessages(DIALOGRESIZE *drs, RECT *rcInit, RECT *rcCurrent, HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  if (uMsg == WM_INITDIALOG)
  {
    RECT rcTemplate;

    GetWindowPos(hDlg, NULL, rcInit);
    rcTemplate=*rcCurrent;
    *rcCurrent=*rcInit;

    if (rcTemplate.right && rcTemplate.bottom)
    {
      rcTemplate.left=rcInit->left + (rcInit->right - rcTemplate.right) / 2;
      rcTemplate.top=rcInit->top + (rcInit->bottom - rcTemplate.bottom) / 2;
      SetWindowPos(hDlg, 0, rcTemplate.left, rcTemplate.top, rcTemplate.right, rcTemplate.bottom, SWP_NOZORDER);
    }
  }
  else if (uMsg == WM_GETMINMAXINFO)
  {
    MINMAXINFO *mmi=(MINMAXINFO *)lParam;

    mmi->ptMinTrackSize.x=rcInit->right;
    mmi->ptMinTrackSize.y=rcInit->bottom;
  }
  else if (uMsg == WM_SIZE)
  {
    if (lParam)
    {
      RECT rcTemplate;
      RECT rcControl;
      DWORD dwFlags;
      POINT pt;
      int i;

      GetWindowPos(hDlg, NULL, &rcTemplate);
      pt.x=rcTemplate.right - rcCurrent->right;
      pt.y=rcTemplate.bottom - rcCurrent->bottom;
      *rcCurrent=rcTemplate;

      for (i=0; drs[i].lpWnd; ++i)
      {
        if (*drs[i].lpWnd)
        {
          dwFlags=0;
          if (drs[i].dwType & DRS_SIZE)
            dwFlags|=SWP_NOMOVE;
          else if (drs[i].dwType & DRS_MOVE)
            dwFlags|=SWP_NOSIZE;
          GetWindowPos(*drs[i].lpWnd, hDlg, &rcControl);
          SetWindowPos(*drs[i].lpWnd, 0, rcControl.left + ((drs[i].dwType & DRS_X)?pt.x:0), rcControl.top + ((drs[i].dwType & DRS_Y)?pt.y:0), rcControl.right + ((drs[i].dwType & DRS_X)?pt.x:0), rcControl.bottom + ((drs[i].dwType & DRS_Y)?pt.y:0), dwFlags|SWP_NOZORDER);
        }
      }
      InvalidateRect(hDlg, NULL, TRUE);
      return TRUE;
    }
  }
  else if (uMsg == WM_PAINT)
  {
    PAINTSTRUCT ps;
    RECT rcGrip;
    HDC hDC;

    if (hDC=BeginPaint(hDlg, &ps))
    {
      GetClientRect(hDlg, &rcGrip);
      rcGrip.left=rcGrip.right - GetSystemMetrics(SM_CXVSCROLL);
      rcGrip.top=rcGrip.bottom - GetSystemMetrics(SM_CYVSCROLL);
      DrawFrameControl(hDC, &rcGrip, DFC_SCROLL, DFCS_SCROLLSIZEGRIP);
      EndPaint(hDlg, &ps);
    }
  }
  return FALSE;
}


//// Options

void ReadOptionsA()
{
  PLUGINOPTIONA po;
  HANDLE hOptions;
  DWORD dwSize;

  if (hOptions=(HANDLE)SendMessage(hMainWnd, AKD_BEGINOPTIONS, POB_READ, (LPARAM)szPluginName))
  {
    //Manual menu
    po.pOptionName="ManualMenuText";
    po.dwType=PO_BINARY;
    po.lpData=NULL;
    po.dwData=0;
    dwSize=SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    if (dwSize)
    {
      if (wszManualText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
      {
        po.pOptionName="ManualMenuText";
        po.dwType=PO_BINARY;
        po.lpData=(LPBYTE)wszManualText;
        po.dwData=dwSize;
        SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
      }
    }

    //Main menu
    po.pOptionName="MainMenuText";
    po.dwType=PO_BINARY;
    po.lpData=NULL;
    po.dwData=0;
    dwSize=SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    if (dwSize)
    {
      if (wszMainText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
      {
        po.pOptionName="MainMenuText";
        po.dwType=PO_BINARY;
        po.lpData=(LPBYTE)wszMainText;
        po.dwData=dwSize;
        SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
      }
    }

    po.pOptionName="MainMenuEnable";
    po.dwType=PO_DWORD;
    po.lpData=(LPBYTE)&bMenuMainEnable;
    po.dwData=sizeof(DWORD);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    //Edit menu
    po.pOptionName="EditMenuText";
    po.dwType=PO_BINARY;
    po.lpData=NULL;
    po.dwData=0;
    dwSize=SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    if (dwSize)
    {
      if (wszEditText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
      {
        po.pOptionName="EditMenuText";
        po.dwType=PO_BINARY;
        po.lpData=(LPBYTE)wszEditText;
        po.dwData=dwSize;
        SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
      }
    }

    po.pOptionName="EditMenuEnable";
    po.dwType=PO_DWORD;
    po.lpData=(LPBYTE)&bMenuEditEnable;
    po.dwData=sizeof(DWORD);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    //Tab menu
    po.pOptionName="TabMenuText";
    po.dwType=PO_BINARY;
    po.lpData=NULL;
    po.dwData=0;
    dwSize=SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    if (dwSize)
    {
      if (wszTabText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
      {
        po.pOptionName="TabMenuText";
        po.dwType=PO_BINARY;
        po.lpData=(LPBYTE)wszTabText;
        po.dwData=dwSize;
        SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
      }
    }

    po.pOptionName="TabMenuEnable";
    po.dwType=PO_DWORD;
    po.lpData=(LPBYTE)&bMenuTabEnable;
    po.dwData=sizeof(DWORD);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    //Link menu
    po.pOptionName="UrlMenuText";
    po.dwType=PO_BINARY;
    po.lpData=NULL;
    po.dwData=0;
    dwSize=SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    if (dwSize)
    {
      if (wszUrlText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
      {
        po.pOptionName="UrlMenuText";
        po.dwType=PO_BINARY;
        po.lpData=(LPBYTE)wszUrlText;
        po.dwData=dwSize;
        SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
      }
    }

    po.pOptionName="UrlMenuEnable";
    po.dwType=PO_DWORD;
    po.lpData=(LPBYTE)&bMenuUrlEnable;
    po.dwData=sizeof(DWORD);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    //Recent files menu
    po.pOptionName="RecentFilesMenuText";
    po.dwType=PO_BINARY;
    po.lpData=NULL;
    po.dwData=0;
    dwSize=SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    if (dwSize)
    {
      if (wszRecentFilesText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
      {
        po.pOptionName="RecentFilesMenuText";
        po.dwType=PO_BINARY;
        po.lpData=(LPBYTE)wszRecentFilesText;
        po.dwData=dwSize;
        SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
      }
    }

    po.pOptionName="RecentFilesMenuEnable";
    po.dwType=PO_DWORD;
    po.lpData=(LPBYTE)&bMenuRecentFilesEnable;
    po.dwData=sizeof(DWORD);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    po.pOptionName="WindowRect";
    po.dwType=PO_BINARY;
    po.lpData=(LPBYTE)&rcMainCurrentDialog;
    po.dwData=sizeof(RECT);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    SendMessage(hMainWnd, AKD_ENDOPTIONS, (WPARAM)hOptions, 0);
  }

  if (!wszManualText)
  {
    dwSize=wcslen(TXT_MANUALW) * sizeof(wchar_t) + 2;

    if (wszManualText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
    {
      memcpy(wszManualText, TXT_MANUALW, dwSize);
    }
  }
  if (!wszMainText)
  {
    dwSize=wcslen(TXT_MAINW) * sizeof(wchar_t) + 2;

    if (wszMainText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
    {
      memcpy(wszMainText, TXT_MAINW, dwSize);
    }
  }
  if (!wszEditText)
  {
    dwSize=wcslen(TXT_EDITW) * sizeof(wchar_t) + 2;

    if (wszEditText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
    {
      memcpy(wszEditText, TXT_EDITW, dwSize);
    }
  }
  if (!wszTabText)
  {
    dwSize=wcslen(TXT_TABW) * sizeof(wchar_t) + 2;

    if (wszTabText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
    {
      memcpy(wszTabText, TXT_TABW, dwSize);
    }
  }
  if (!wszUrlText)
  {
    dwSize=wcslen(TXT_URLW) * sizeof(wchar_t) + 2;

    if (wszUrlText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
    {
      memcpy(wszUrlText, TXT_URLW, dwSize);
    }
  }
  if (!wszRecentFilesText)
  {
    dwSize=wcslen(TXT_RECENTFILESW) * sizeof(wchar_t) + 2;

    if (wszRecentFilesText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
    {
      memcpy(wszRecentFilesText, TXT_RECENTFILESW, dwSize);
    }
  }

  //Convert Unicode to Ansi
  if (wszManualText)
  {
    dwSize=WideCharToMultiByte(CP_ACP, 0, wszManualText, -1, NULL, 0, NULL, NULL);

    if (szManualText=(char *)GlobalAlloc(GPTR, dwSize))
    {
      WideCharToMultiByte(CP_ACP, 0, wszManualText, -1, szManualText, dwSize, NULL, NULL);
    }
    GlobalFree((HGLOBAL)wszManualText);
    wszManualText=NULL;
  }
  if (wszMainText)
  {
    dwSize=WideCharToMultiByte(CP_ACP, 0, wszMainText, -1, NULL, 0, NULL, NULL);

    if (szMainText=(char *)GlobalAlloc(GPTR, dwSize))
    {
      WideCharToMultiByte(CP_ACP, 0, wszMainText, -1, szMainText, dwSize, NULL, NULL);
    }
    GlobalFree((HGLOBAL)wszMainText);
    wszMainText=NULL;
  }
  if (wszEditText)
  {
    dwSize=WideCharToMultiByte(CP_ACP, 0, wszEditText, -1, NULL, 0, NULL, NULL);

    if (szEditText=(char *)GlobalAlloc(GPTR, dwSize))
    {
      WideCharToMultiByte(CP_ACP, 0, wszEditText, -1, szEditText, dwSize, NULL, NULL);
    }
    GlobalFree((HGLOBAL)wszEditText);
    wszEditText=NULL;
  }
  if (wszTabText)
  {
    dwSize=WideCharToMultiByte(CP_ACP, 0, wszTabText, -1, NULL, 0, NULL, NULL);

    if (szTabText=(char *)GlobalAlloc(GPTR, dwSize))
    {
      WideCharToMultiByte(CP_ACP, 0, wszTabText, -1, szTabText, dwSize, NULL, NULL);
    }
    GlobalFree((HGLOBAL)wszTabText);
    wszTabText=NULL;
  }
  if (wszUrlText)
  {
    dwSize=WideCharToMultiByte(CP_ACP, 0, wszUrlText, -1, NULL, 0, NULL, NULL);

    if (szUrlText=(char *)GlobalAlloc(GPTR, dwSize))
    {
      WideCharToMultiByte(CP_ACP, 0, wszUrlText, -1, szUrlText, dwSize, NULL, NULL);
    }
    GlobalFree((HGLOBAL)wszUrlText);
    wszUrlText=NULL;
  }
  if (wszRecentFilesText)
  {
    dwSize=WideCharToMultiByte(CP_ACP, 0, wszRecentFilesText, -1, NULL, 0, NULL, NULL);

    if (szRecentFilesText=(char *)GlobalAlloc(GPTR, dwSize))
    {
      WideCharToMultiByte(CP_ACP, 0, wszRecentFilesText, -1, szRecentFilesText, dwSize, NULL, NULL);
    }
    GlobalFree((HGLOBAL)wszRecentFilesText);
    wszRecentFilesText=NULL;
  }
}

void ReadOptionsW()
{
  PLUGINOPTIONW po;
  HANDLE hOptions;
  DWORD dwSize;

  if (hOptions=(HANDLE)SendMessage(hMainWnd, AKD_BEGINOPTIONS, POB_READ, (LPARAM)wszPluginName))
  {
    //Manual menu
    po.pOptionName=L"ManualMenuText";
    po.dwType=PO_BINARY;
    po.lpData=NULL;
    po.dwData=0;
    dwSize=SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    if (dwSize)
    {
      if (wszManualText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
      {
        po.pOptionName=L"ManualMenuText";
        po.dwType=PO_BINARY;
        po.lpData=(LPBYTE)wszManualText;
        po.dwData=dwSize;
        SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
      }
    }

    //Main menu
    po.pOptionName=L"MainMenuText";
    po.dwType=PO_BINARY;
    po.lpData=NULL;
    po.dwData=0;
    dwSize=SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    if (dwSize)
    {
      if (wszMainText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
      {
        po.pOptionName=L"MainMenuText";
        po.dwType=PO_BINARY;
        po.lpData=(LPBYTE)wszMainText;
        po.dwData=dwSize;
        SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
      }
    }

    po.pOptionName=L"MainMenuEnable";
    po.dwType=PO_DWORD;
    po.lpData=(LPBYTE)&bMenuMainEnable;
    po.dwData=sizeof(DWORD);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    //Edit menu
    po.pOptionName=L"EditMenuText";
    po.dwType=PO_BINARY;
    po.lpData=NULL;
    po.dwData=0;
    dwSize=SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    if (dwSize)
    {
      if (wszEditText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
      {
        po.pOptionName=L"EditMenuText";
        po.dwType=PO_BINARY;
        po.lpData=(LPBYTE)wszEditText;
        po.dwData=dwSize;
        SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
      }
    }

    po.pOptionName=L"EditMenuEnable";
    po.dwType=PO_DWORD;
    po.lpData=(LPBYTE)&bMenuEditEnable;
    po.dwData=sizeof(DWORD);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    //Tab menu
    po.pOptionName=L"TabMenuText";
    po.dwType=PO_BINARY;
    po.lpData=NULL;
    po.dwData=0;
    dwSize=SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    if (dwSize)
    {
      if (wszTabText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
      {
        po.pOptionName=L"TabMenuText";
        po.dwType=PO_BINARY;
        po.lpData=(LPBYTE)wszTabText;
        po.dwData=dwSize;
        SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
      }
    }

    po.pOptionName=L"TabMenuEnable";
    po.dwType=PO_DWORD;
    po.lpData=(LPBYTE)&bMenuTabEnable;
    po.dwData=sizeof(DWORD);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    //Link menu
    po.pOptionName=L"UrlMenuText";
    po.dwType=PO_BINARY;
    po.lpData=NULL;
    po.dwData=0;
    dwSize=SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    if (dwSize)
    {
      if (wszUrlText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
      {
        po.pOptionName=L"UrlMenuText";
        po.dwType=PO_BINARY;
        po.lpData=(LPBYTE)wszUrlText;
        po.dwData=dwSize;
        SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
      }
    }

    po.pOptionName=L"UrlMenuEnable";
    po.dwType=PO_DWORD;
    po.lpData=(LPBYTE)&bMenuUrlEnable;
    po.dwData=sizeof(DWORD);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    //Recent files menu
    po.pOptionName=L"RecentFilesMenuText";
    po.dwType=PO_BINARY;
    po.lpData=NULL;
    po.dwData=0;
    dwSize=SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    if (dwSize)
    {
      if (wszRecentFilesText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
      {
        po.pOptionName=L"RecentFilesMenuText";
        po.dwType=PO_BINARY;
        po.lpData=(LPBYTE)wszRecentFilesText;
        po.dwData=dwSize;
        SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
      }
    }

    po.pOptionName=L"RecentFilesMenuEnable";
    po.dwType=PO_DWORD;
    po.lpData=(LPBYTE)&bMenuRecentFilesEnable;
    po.dwData=sizeof(DWORD);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    po.pOptionName=L"WindowRect";
    po.dwType=PO_BINARY;
    po.lpData=(LPBYTE)&rcMainCurrentDialog;
    po.dwData=sizeof(RECT);
    SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

    SendMessage(hMainWnd, AKD_ENDOPTIONS, (WPARAM)hOptions, 0);
  }

  if (!wszManualText)
  {
    dwSize=wcslen(TXT_MANUALW) * sizeof(wchar_t) + 2;

    if (wszManualText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
    {
      memcpy(wszManualText, TXT_MANUALW, dwSize);
    }
  }
  if (!wszMainText)
  {
    dwSize=wcslen(TXT_MAINW) * sizeof(wchar_t) + 2;

    if (wszMainText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
    {
      memcpy(wszMainText, TXT_MAINW, dwSize);
    }
  }
  if (!wszEditText)
  {
    dwSize=wcslen(TXT_EDITW) * sizeof(wchar_t) + 2;

    if (wszEditText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
    {
      memcpy(wszEditText, TXT_EDITW, dwSize);
    }
  }
  if (!wszTabText)
  {
    dwSize=wcslen(TXT_TABW) * sizeof(wchar_t) + 2;

    if (wszTabText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
    {
      memcpy(wszTabText, TXT_TABW, dwSize);
    }
  }
  if (!wszUrlText)
  {
    dwSize=wcslen(TXT_URLW) * sizeof(wchar_t) + 2;

    if (wszUrlText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
    {
      memcpy(wszUrlText, TXT_URLW, dwSize);
    }
  }
  if (!wszRecentFilesText)
  {
    dwSize=wcslen(TXT_RECENTFILESW) * sizeof(wchar_t) + 2;

    if (wszRecentFilesText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
    {
      memcpy(wszRecentFilesText, TXT_RECENTFILESW, dwSize);
    }
  }
}

void SaveOptionsA(DWORD dwFlags)
{
  PLUGINOPTIONA po;
  HANDLE hOptions;
  DWORD dwSize;

  if (hOptions=(HANDLE)SendMessage(hMainWnd, AKD_BEGINOPTIONS, POB_SAVE, (LPARAM)szPluginName))
  {
    if (dwFlags & OF_MENUTEXT)
    {
      if (szManualText)
      {
        dwSize=MultiByteToWideChar(CP_ACP, 0, szManualText, -1, NULL, 0) * sizeof(wchar_t);

        if (wszManualText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
        {
          MultiByteToWideChar(CP_ACP, 0, szManualText, -1, wszManualText, dwSize / sizeof(wchar_t));

          po.pOptionName="ManualMenuText";
          po.dwType=PO_BINARY;
          po.lpData=(LPBYTE)wszManualText;
          po.dwData=wcslen(wszManualText) * sizeof(wchar_t) + 2;
          SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

          GlobalFree((HGLOBAL)wszManualText);
          wszManualText=NULL;
        }
      }

      po.pOptionName="MainMenuEnable";
      po.dwType=PO_DWORD;
      po.lpData=(LPBYTE)&bMenuMainEnable;
      po.dwData=sizeof(DWORD);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      if (szMainText)
      {
        dwSize=MultiByteToWideChar(CP_ACP, 0, szMainText, -1, NULL, 0) * sizeof(wchar_t);

        if (wszMainText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
        {
          MultiByteToWideChar(CP_ACP, 0, szMainText, -1, wszMainText, dwSize / sizeof(wchar_t));

          po.pOptionName="MainMenuText";
          po.dwType=PO_BINARY;
          po.lpData=(LPBYTE)wszMainText;
          po.dwData=wcslen(wszMainText) * sizeof(wchar_t) + 2;
          SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

          GlobalFree((HGLOBAL)wszMainText);
          wszMainText=NULL;
        }
      }

      po.pOptionName="EditMenuEnable";
      po.dwType=PO_DWORD;
      po.lpData=(LPBYTE)&bMenuEditEnable;
      po.dwData=sizeof(DWORD);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      if (szEditText)
      {
        dwSize=MultiByteToWideChar(CP_ACP, 0, szEditText, -1, NULL, 0) * sizeof(wchar_t);

        if (wszEditText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
        {
          MultiByteToWideChar(CP_ACP, 0, szEditText, -1, wszEditText, dwSize / sizeof(wchar_t));

          po.pOptionName="EditMenuText";
          po.dwType=PO_BINARY;
          po.lpData=(LPBYTE)wszEditText;
          po.dwData=wcslen(wszEditText) * sizeof(wchar_t) + 2;
          SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

          GlobalFree((HGLOBAL)wszEditText);
          wszEditText=NULL;
        }
      }

      po.pOptionName="TabMenuEnable";
      po.dwType=PO_DWORD;
      po.lpData=(LPBYTE)&bMenuTabEnable;
      po.dwData=sizeof(DWORD);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      if (szTabText)
      {
        dwSize=MultiByteToWideChar(CP_ACP, 0, szTabText, -1, NULL, 0) * sizeof(wchar_t);

        if (wszTabText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
        {
          MultiByteToWideChar(CP_ACP, 0, szTabText, -1, wszTabText, dwSize / sizeof(wchar_t));

          po.pOptionName="TabMenuText";
          po.dwType=PO_BINARY;
          po.lpData=(LPBYTE)wszTabText;
          po.dwData=wcslen(wszTabText) * sizeof(wchar_t) + 2;
          SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

          GlobalFree((HGLOBAL)wszTabText);
          wszTabText=NULL;
        }
      }

      po.pOptionName="UrlMenuEnable";
      po.dwType=PO_DWORD;
      po.lpData=(LPBYTE)&bMenuUrlEnable;
      po.dwData=sizeof(DWORD);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      if (szUrlText)
      {
        dwSize=MultiByteToWideChar(CP_ACP, 0, szUrlText, -1, NULL, 0) * sizeof(wchar_t);

        if (wszUrlText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
        {
          MultiByteToWideChar(CP_ACP, 0, szUrlText, -1, wszUrlText, dwSize / sizeof(wchar_t));

          po.pOptionName="UrlMenuText";
          po.dwType=PO_BINARY;
          po.lpData=(LPBYTE)wszUrlText;
          po.dwData=wcslen(wszUrlText) * sizeof(wchar_t) + 2;
          SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

          GlobalFree((HGLOBAL)wszUrlText);
          wszUrlText=NULL;
        }
      }

      po.pOptionName="RecentFilesMenuEnable";
      po.dwType=PO_DWORD;
      po.lpData=(LPBYTE)&bMenuRecentFilesEnable;
      po.dwData=sizeof(DWORD);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      if (szRecentFilesText)
      {
        dwSize=MultiByteToWideChar(CP_ACP, 0, szRecentFilesText, -1, NULL, 0) * sizeof(wchar_t);

        if (wszRecentFilesText=(wchar_t *)GlobalAlloc(GPTR, dwSize))
        {
          MultiByteToWideChar(CP_ACP, 0, szRecentFilesText, -1, wszRecentFilesText, dwSize / sizeof(wchar_t));

          po.pOptionName="RecentFilesMenuText";
          po.dwType=PO_BINARY;
          po.lpData=(LPBYTE)wszRecentFilesText;
          po.dwData=wcslen(wszRecentFilesText) * sizeof(wchar_t) + 2;
          SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

          GlobalFree((HGLOBAL)wszRecentFilesText);
          wszRecentFilesText=NULL;
        }
      }
    }

    if (dwFlags & OF_WINDOWRECT)
    {
      po.pOptionName="WindowRect";
      po.dwType=PO_BINARY;
      po.lpData=(LPBYTE)&rcMainCurrentDialog;
      po.dwData=sizeof(RECT);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
    }

    SendMessage(hMainWnd, AKD_ENDOPTIONS, (WPARAM)hOptions, 0);
  }
}

void SaveOptionsW(DWORD dwFlags)
{
  PLUGINOPTIONW po;
  HANDLE hOptions;

  if (hOptions=(HANDLE)SendMessage(hMainWnd, AKD_BEGINOPTIONS, POB_SAVE, (LPARAM)wszPluginName))
  {
    if (dwFlags & OF_MENUTEXT)
    {
      po.pOptionName=L"ManualMenuText";
      po.dwType=PO_BINARY;
      po.lpData=(LPBYTE)wszManualText;
      po.dwData=wcslen(wszManualText) * sizeof(wchar_t) + 2;
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      po.pOptionName=L"MainMenuEnable";
      po.dwType=PO_DWORD;
      po.lpData=(LPBYTE)&bMenuMainEnable;
      po.dwData=sizeof(DWORD);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      po.pOptionName=L"MainMenuText";
      po.dwType=PO_BINARY;
      po.lpData=(LPBYTE)wszMainText;
      po.dwData=wcslen(wszMainText) * sizeof(wchar_t) + 2;
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      po.pOptionName=L"EditMenuEnable";
      po.dwType=PO_DWORD;
      po.lpData=(LPBYTE)&bMenuEditEnable;
      po.dwData=sizeof(DWORD);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      po.pOptionName=L"EditMenuText";
      po.dwType=PO_BINARY;
      po.lpData=(LPBYTE)wszEditText;
      po.dwData=wcslen(wszEditText) * sizeof(wchar_t) + 2;
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      po.pOptionName=L"TabMenuEnable";
      po.dwType=PO_DWORD;
      po.lpData=(LPBYTE)&bMenuTabEnable;
      po.dwData=sizeof(DWORD);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      po.pOptionName=L"TabMenuText";
      po.dwType=PO_BINARY;
      po.lpData=(LPBYTE)wszTabText;
      po.dwData=wcslen(wszTabText) * sizeof(wchar_t) + 2;
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      po.pOptionName=L"UrlMenuEnable";
      po.dwType=PO_DWORD;
      po.lpData=(LPBYTE)&bMenuUrlEnable;
      po.dwData=sizeof(DWORD);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      po.pOptionName=L"UrlMenuText";
      po.dwType=PO_BINARY;
      po.lpData=(LPBYTE)wszUrlText;
      po.dwData=wcslen(wszUrlText) * sizeof(wchar_t) + 2;
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      po.pOptionName=L"RecentFilesMenuEnable";
      po.dwType=PO_DWORD;
      po.lpData=(LPBYTE)&bMenuRecentFilesEnable;
      po.dwData=sizeof(DWORD);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);

      po.pOptionName=L"RecentFilesMenuText";
      po.dwType=PO_BINARY;
      po.lpData=(LPBYTE)wszRecentFilesText;
      po.dwData=wcslen(wszRecentFilesText) * sizeof(wchar_t) + 2;
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
    }

    if (dwFlags & OF_WINDOWRECT)
    {
      po.pOptionName=L"WindowRect";
      po.dwType=PO_BINARY;
      po.lpData=(LPBYTE)&rcMainCurrentDialog;
      po.dwData=sizeof(RECT);
      SendMessage(hMainWnd, AKD_OPTION, (WPARAM)hOptions, (LPARAM)&po);
    }

    SendMessage(hMainWnd, AKD_ENDOPTIONS, (WPARAM)hOptions, 0);
  }
}

char* GetLangStringA(LANGID wLangID, int nStringID)
{
  static char szStringBuf[MAX_PATH];

  WideCharToMultiByte(CP_ACP, 0, GetLangStringW(wLangID, nStringID), -1, szStringBuf, MAX_PATH, NULL, NULL);
  return szStringBuf;
}

wchar_t* GetLangStringW(LANGID wLangID, int nStringID)
{
  if (wLangID == LANG_RUSSIAN)
  {
    if (nStringID == STRID_MANUAL)
      return L"\x041C\x0435\x043D\x044E\x0020\x0043\x006F\x006E\x0074\x0065\x0078\x0074\x004D\x0065\x006E\x0075\x003A\x003A\x0053\x0068\x006F\x0077";
    if (nStringID == STRID_MENUMAIN)
      return L"\x0413\x043B\x0430\x0432\x043D\x043E\x0435\x0020\x043C\x0435\x043D\x044E";
    if (nStringID == STRID_MENUEDIT)
      return L"\x041C\x0435\x043D\x044E\x0020\x043E\x043A\x043D\x0430\x0020\x0440\x0435\x0434\x0430\x043A\x0442\x0438\x0440\x043E\x0432\x0430\x043D\x0438\x044F";
    if (nStringID == STRID_MENUTAB)
      return L"\x041C\x0435\x043D\x044E\x0020\x0432\x043A\x043B\x0430\x0434\x043E\x043A";
    if (nStringID == STRID_MENUURL)
      return L"\x041C\x0435\x043D\x044E\x0020\x0441\x0441\x044B\x043B\x043E\x043A";
    if (nStringID == STRID_MENURECENTFILES)
      return L"\x041C\x0435\x043D\x044E\x0020\x043F\x043E\x0441\x043B\x0435\x0434\x043D\x0438\x0445\x0020\x0444\x0430\x0439\x043B\x043E\x0432";
    if (nStringID == STRID_ENABLE)
      return L"\x0412\x043A\x043B\x044E\x0447\x0435\x043D\x043E";
    if (nStringID == STRID_SHOW)
      return L"\x041F\x043E\x043A\x0430\x0437\x0430\x0442\x044C";
    if (nStringID == STRID_AUTOLOAD)
      return L"\x0022\x0025\x0073\x0022\x0020\x043D\x0435\x0020\x043F\x043E\x0434\x0434\x0435\x0440\x0436\x0438\x0432\x0430\x0435\x0442\x0020\x0430\x0432\x0442\x043E\x0437\x0430\x0433\x0440\x0443\x0437\x043A\x0443\x0020\x0028\x0022\x002B\x0022\x0020\x043F\x0435\x0440\x0435\x0434\x0020\x0022\x0043\x0061\x006C\x006C\x0022\x0029\x002E";
    if (nStringID == STRID_OK)
      return L"\x004F\x004B";
    if (nStringID == STRID_CANCEL)
      return L"\x041E\x0442\x043C\x0435\x043D\x0430";
  }
  else
  {
    if (nStringID == STRID_MANUAL)
      return L"ContextMenu::Show menu";
    if (nStringID == STRID_MENUMAIN)
      return L"Main menu";
    if (nStringID == STRID_MENUEDIT)
      return L"Edit menu";
    if (nStringID == STRID_MENUTAB)
      return L"Tab menu";
    if (nStringID == STRID_MENUURL)
      return L"URL menu";
    if (nStringID == STRID_MENURECENTFILES)
      return L"Recent files menu";
    if (nStringID == STRID_ENABLE)
      return L"Enable";
    if (nStringID == STRID_SHOW)
      return L"Show";
    if (nStringID == STRID_AUTOLOAD)
      return L"\"%s\" doesn't support autoload (\"+\" before \"Call\").";
    if (nStringID == STRID_OK)
      return L"OK";
    if (nStringID == STRID_CANCEL)
      return L"Cancel";
  }
  return L"";
}

BOOL IsExtCallParamValid(LPARAM lParam, int nIndex)
{
  if (*((int *)lParam) >= (int)((nIndex + 1) * sizeof(int)))
    return TRUE;
  return FALSE;
}

int GetExtCallParam(LPARAM lParam, int nIndex)
{
  if (*((int *)lParam) >= (int)((nIndex + 1) * sizeof(int)))
    return *(((int *)lParam) + nIndex);
  return 0;
}

void InitCommon(PLUGINDATA *pd)
{
  bInitCommon=TRUE;
  hInstanceDLL=pd->hInstanceDLL;
  hMainWnd=pd->hMainWnd;
  hMdiClient=pd->hMdiClient;
  hMainMenu=pd->hMainMenu;
  hMenuRecentFiles=pd->hMenuRecentFiles;
  hMenuLanguage=pd->hMenuLanguage;
  hMainIcon=pd->hMainIcon;
  bOldWindows=pd->bOldWindows;
  bAkelEdit=pd->bAkelEdit;
  bMDI=pd->bMDI;
  wLangSystem=PRIMARYLANGID(pd->wLangSystem);
  hPopupEdit=GetSubMenu(pd->hPopupMenu, 0);

  if (bOldWindows)
  {
    int i;

    for (i=0; ((char *)pd->pFunction)[i] != ':'; ++i)
      szPluginName[i]=((char *)pd->pFunction)[i];
    szPluginName[i]='\0';
  }
  else
  {
    int i;

    for (i=0; ((wchar_t *)pd->pFunction)[i] != ':'; ++i)
      wszPluginName[i]=((wchar_t *)pd->pFunction)[i];
    wszPluginName[i]='\0';
  }

  if (bOldWindows)
  {
    lstrcpynA(szExeDir, (char *)pd->pAkelDir, MAX_PATH);
    ReadOptionsA();
  }
  else
  {
    lstrcpynW(wszExeDir, (wchar_t *)pd->pAkelDir, MAX_PATH);
    ReadOptionsW();
  }
}

void InitMain()
{
  bInitMain=TRUE;

  if (bOldWindows)
  {
    //SubClass
    NewMainProcData=NULL;
    SendMessage(hMainWnd, AKD_SETMAINPROC, (WPARAM)NewMainProcA, (LPARAM)&NewMainProcData);

    if (bMDI)
    {
      NewFrameProcData=NULL;
      SendMessage(hMainWnd, AKD_SETFRAMEPROC, (WPARAM)NewFrameProcA, (LPARAM)&NewFrameProcData);
    }
  }
  else
  {
    //SubClass
    NewMainProcData=NULL;
    SendMessage(hMainWnd, AKD_SETMAINPROC, (WPARAM)NewMainProcW, (LPARAM)&NewMainProcData);

    if (bMDI)
    {
      NewFrameProcData=NULL;
      SendMessage(hMainWnd, AKD_SETFRAMEPROC, (WPARAM)NewFrameProcW, (LPARAM)&NewFrameProcData);
    }
  }
}

void UninitMain()
{
  bInitMain=FALSE;

  //Remove subclass
  if (NewMainProcData)
  {
    SendMessage(hMainWnd, AKD_SETMAINPROC, (WPARAM)NULL, (LPARAM)&NewMainProcData);
    NewMainProcData=NULL;
  }
  if (bMDI)
  {
    if (NewFrameProcData)
    {
      SendMessage(hMainWnd, AKD_SETFRAMEPROC, (WPARAM)NULL, (LPARAM)&NewFrameProcData);
      NewFrameProcData=NULL;
    }
  }

  if (bOldWindows)
  {
    if (bMainDialogRectSave) SaveOptionsA(OF_WINDOWRECT);

    if (hMenuMainStackA.hMainMenu)
    {
      //SetMenu(hMainWnd, hMainMenu);
      DestroyMenu(hMenuMainStackA.hMainMenu);
      hMenuMainStackA.hMainMenu=NULL;
    }

    if (szManualText)
    {
      GlobalFree((HGLOBAL)szManualText);
      szManualText=NULL;
    }
    if (szMainText)
    {
      GlobalFree((HGLOBAL)szMainText);
      szMainText=NULL;
    }
    if (szEditText)
    {
      GlobalFree((HGLOBAL)szEditText);
      szEditText=NULL;
    }
    if (szTabText)
    {
      GlobalFree((HGLOBAL)szTabText);
      szTabText=NULL;
    }
    if (szUrlText)
    {
      GlobalFree((HGLOBAL)szUrlText);
      szUrlText=NULL;
    }
    if (szRecentFilesText)
    {
      GlobalFree((HGLOBAL)szRecentFilesText);
      szRecentFilesText=NULL;
    }
    FreeContextMenuA(&hMenuManualStackA);
    FreeContextMenuA(&hMenuMainStackA);
    FreeContextMenuA(&hMenuEditStackA);
    FreeContextMenuA(&hMenuTabStackA);
    FreeContextMenuA(&hMenuUrlStackA);
    FreeContextMenuA(&hMenuRecentFilesStackA);
  }
  else
  {
    if (bMainDialogRectSave) SaveOptionsW(OF_WINDOWRECT);

    if (hMenuMainStackW.hMainMenu)
    {
      //SetMenu(hMainWnd, hMainMenu);
      DestroyMenu(hMenuMainStackW.hMainMenu);
      hMenuMainStackW.hMainMenu=NULL;
    }

    if (wszManualText)
    {
      GlobalFree((HGLOBAL)wszManualText);
      wszManualText=NULL;
    }
    if (wszMainText)
    {
      GlobalFree((HGLOBAL)wszMainText);
      wszMainText=NULL;
    }
    if (wszEditText)
    {
      GlobalFree((HGLOBAL)wszEditText);
      wszEditText=NULL;
    }
    if (wszTabText)
    {
      GlobalFree((HGLOBAL)wszTabText);
      wszTabText=NULL;
    }
    if (wszUrlText)
    {
      GlobalFree((HGLOBAL)wszUrlText);
      wszUrlText=NULL;
    }
    if (wszRecentFilesText)
    {
      GlobalFree((HGLOBAL)wszRecentFilesText);
      wszRecentFilesText=NULL;
    }
    FreeContextMenuW(&hMenuManualStackW);
    FreeContextMenuW(&hMenuMainStackW);
    FreeContextMenuW(&hMenuEditStackW);
    FreeContextMenuW(&hMenuTabStackW);
    FreeContextMenuW(&hMenuUrlStackW);
    FreeContextMenuW(&hMenuRecentFilesStackW);
  }
}

//Entry point
extern "C" BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
  if (fdwReason == DLL_PROCESS_ATTACH)
  {
  }
  else if (fdwReason == DLL_THREAD_ATTACH)
  {
  }
  else if (fdwReason == DLL_THREAD_DETACH)
  {
  }
  else if (fdwReason == DLL_PROCESS_DETACH)
  {
    if (bInitMain) UninitMain();
  }
  return TRUE;
}
